Option Strict Off
Option Explicit On
<System.Runtime.InteropServices.ProgId("FastMath_NET.FastMath")> Public Class FastMath
	' -------------------------------------------------------------------------
	' ucalcvb.cls : Class file
	' Designed to work with Visual Basic 5.0 or above.
	'
	' UCalc Fast Math Parser (Beta J)
	' Copyright (c) 1998-2004 by Daniel Corbier.  All rights reserved.
	' http://www.ucalc.com/mathparser
	' ------------------------------------------------------------------------- '+++
	
	Private t As Integer
	
	Private Structure ucComplexNumberType
		Dim Real As Double
		Dim Imag As Double
	End Structure
	
	'UPGRADE_NOTE: Class_Initialize was upgraded to Class_Initialize_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
	Private Sub Class_Initialize_Renamed()
		'   If ucInitialized = False Then
		'      ucGetThreadInfo 0, t0
		'      ucSetThreadInfo 0, t0
		'      ucReset t0
		'      ucInitialized = True
		'   End If
		t = 0 '+++
		'   t = ucNewThread()
		'   ucThreadAddr = t.Handshake.ucThreadAddr ' +++ + ucThread * Len(ucThreadTypeSize)
		'UPGRADE_NOTE: Object Me may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1029"'
		'UPGRADE_WARNING: Couldn't resolve default property of object Me. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1037"'
        '+++	If t = -1 Then Me = Nothing
	End Sub
	Public Sub New()
		MyBase.New()
		Class_Initialize_Renamed()
	End Sub
	
	'UPGRADE_NOTE: Class_Terminate was upgraded to Class_Terminate_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
	Private Sub Class_Terminate_Renamed()
		ucReleaseThread(t)
	End Sub
	Protected Overrides Sub Finalize()
		Class_Terminate_Renamed()
		MyBase.Finalize()
	End Sub
	
	Public Function ucAlias(ByRef AssignFrom As String, ByRef AssignTo As String) As Integer
		ucAlias = ucAliasE(AssignFrom, AssignTo, ucThreadAddr(t))
	End Function
	
	Public Sub ucDetachSymbol(ByRef Symbol As String)
		ucDetachSymbolE(Symbol, ucThreadAddr(t))
	End Sub
	
	Public Sub ucErrorClear()
		ucErrorClearE(ucThreadAddr(t))
	End Sub
	
    Public Function ucErrorHandler(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucErrorHandler = ucSetCallbackE(FunctionAddress, ucErrorCallback, ucThreadAddr(t))
    End Function

    Public Function ucPreParse(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucPreParse = ucSetCallbackE(FunctionAddress, ucTreePre, ucThreadAddr(t))
    End Function

    Public Function ucTreeParseDownRaw(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucTreeParseDownRaw = ucSetCallbackE(FunctionAddress, ucTreeDownRaw, ucThreadAddr(t))
    End Function

    Public Function ucTreeParseDown(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucTreeParseDown = ucSetCallbackE(FunctionAddress, ucTreeDown, ucThreadAddr(t))
    End Function

    Public Function ucTreeParseUp(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucTreeParseUp = ucSetCallbackE(FunctionAddress, ucTreeUp, ucThreadAddr(t))
    End Function


    Public Property ucVariableValueStr(ByVal VarHandle As Integer) As String
        Get
            ucVariableValueStr = ucGetVariableValueStrE(VarHandle)
        End Get
        Set(ByVal Value As String)
            ucSetVariableValueStrE(VarHandle, Value)
        End Set
    End Property

    Public ReadOnly Property ucErrorData(ByVal errIndex As Integer) As String
        Get
            ucErrorData = ucGetErrorDataE(errIndex, ucThreadAddr(t))
        End Get
    End Property


    Public Property ucThreadIndex() As Integer
        Get
            ucThreadIndex = t
        End Get
        Set(ByVal Value As Integer)
            t = Value
        End Set
    End Property

    Public Sub ucReleaseExprPtr(ByVal ExpressionPtr As Integer)
        ' +++ Perhaps insert code here to prevent releasing Expr from wrong thread
        ucReleaseExprPtrE(ExpressionPtr)
    End Sub

    Public Sub ucReleaseItem(ByVal ItemHandle As Integer)
        ' +++ Perhaps insert code here to prevent releasing Expr from wrong thread
        ucReleaseItemE(ItemHandle)
    End Sub

    Private Sub ucReleaseThread(ByVal ucThread As Integer)
        If ucThread > 0 Then ucReleaseThreadE(ucThread)
    End Sub

    Public Sub ucSetThreadIndex(ByVal ucThread As Integer)
        t = ucThread
    End Sub

    Public Sub ucSetTrigMode(ByVal TrigMode As Integer)
        ucSetTrigModeE(TrigMode, ucThreadAddr(t))
    End Sub

    Public Sub ucSetVariableValue(ByVal VarHandle As Integer, ByVal vValue As Double)
        ucSetVariableValueDblE(VarHandle, vValue)
    End Sub

    Public Sub ucSetVariableValueStr(ByVal VarHandle As Integer, ByRef vValue As String)
        ucSetVariableValueStrE(VarHandle, vValue)
    End Sub

    Public Function ucDefineConstant(ByRef ConstantDef As String, Optional ByVal vProperties As Integer = 0) As Integer
        ucDefineConstant = ucDefineVariableE(ConstantDef, 0, 0, vProperties, ucType_Constant, ucThreadAddr(t))
    End Function

    Public Function ucDefineFunction(ByRef FunctionDef As String, Optional ByVal FunctionAddress As ucCallbackDbl = Nothing, Optional ByVal fProperties As Integer = 0, Optional ByVal vType As Integer = 0) As Integer
        ucDefineFunction = ucDefineFunctionE(FunctionDef, FunctionAddress, 0, fProperties, vType, ucThreadAddr(t))
    End Function

    Public Function ucDefineOperator(ByRef OperatorDef As String, Optional ByVal Precedence As Integer = 0, Optional ByVal OperatorAddress As ucCallbackDbl = Nothing, Optional ByVal fProperties As Integer = 0, Optional ByVal vType As Integer = 0) As Integer
        ucDefineOperator = ucDefineFunctionE(OperatorDef, OperatorAddress, Precedence, fProperties, vType, ucThreadAddr(t))
    End Function

    Public Function ucDefineVariable(ByRef VariableDef As String, Optional ByVal vProperties As Integer = 0) As Integer
        ucDefineVariable = ucDefineVariableE(VariableDef, 0, 0, vProperties, ucType_Internal, ucThreadAddr(t))
    End Function

    Public Function ucAttachVariable(ByRef VariableDef As String, ByRef vPtr As Integer, Optional ByVal ExprPtr As Integer = 0, Optional ByVal vProperties As Integer = 0) As Integer
        ucAttachVariable = ucDefineVariableE(VariableDef, vPtr, ExprPtr, vProperties, 0, ucThreadAddr(t))
    End Function

    Public Function ucEval(ByRef Expression As String) As Double
        ucEval = ucEvalE(Expression, ucThreadAddr(t))
    End Function

    Public Function ucEvalStr(ByRef Expression As String, Optional ByVal tNum As Integer = 0) As String
        ucEvalStr = ucEvalStrE(Expression, ucThreadAddr(tNum))
    End Function

    Public Function ucEvaluate(ByVal ExpressionPtr As Integer) As Double
        ucEvaluate = ucEvaluateE(ExpressionPtr)
    End Function

    Public Function ucEvaluateStr(ByVal ExpressionPtr As Integer) As String
        ucEvaluateStr = ucEvaluateStrE(ExpressionPtr)
    End Function

    Public Function ucError() As Integer
        Dim tData As ucThreadType

        ucGetThreadInfo(t, tData)
        ucError = tData.ErrorNumber
    End Function

    Public Function ucGetErrorData(ByVal errIndex As Integer, Optional ByVal t As Integer = 0) As String
        ucGetErrorData = ucGetErrorDataE(errIndex, ucThreadAddr(t))
    End Function

    Public Function ucGetThreadIndex() As Integer
        ucGetThreadIndex = t
    End Function

    Public Function ucGetVariableValue(ByVal VarHandle As Integer) As Double
        ucGetVariableValue = ucGetVariableValueE(VarHandle)
    End Function

    Public Function ucGetVariableValueStr(ByVal VarHandle As Integer) As String
        ucGetVariableValueStr = ucGetVariableValueStrE(VarHandle)
    End Function

    Public Function ucImagPart() As Double
        ucImagPart = ucImagPartE(ucThreadAddr(t))
    End Function

    '+++Function ucEvaluateCplx(ByVal ExpressionPtr As Long, ucValue As ucComplexNumberType) As Double
    '   ucValue.Real = ucEvaluate(ExpressionPtr)
    '   ucValue.Imag = ucImagPartE(ucThreadAddr(t))
    '   ucEvaluateCplx = ucValue.Real
    'End Function

    Private Function ucNewThread() As Integer
        ucNewThread = ucNewThreadE
    End Function

    Public Function ucParse(ByRef Expression As String, Optional ByRef LocalVars As String = "", Optional ByRef ExprType As Integer = 0) As Integer
        ucParse = ucParseE(Expression, LocalVars, ExprType, ucThreadAddr(t))
    End Function

    Public Function ucPrecedence(ByRef Op As String, Optional ByVal OpCategory As Integer = 0) As Integer
        ucPrecedence = ucPrecedenceE(Op, OpCategory, ucThreadAddr(t))
    End Function

    Public Function ucSymbolHandle(ByRef ucSymbolE As String, Optional ByVal SymbolProperty As Integer = 0) As Integer
        ucSymbolHandle = ucSymbolHandleE(ucSymbolE, SymbolProperty, ucThreadAddr(t))
    End Function

    Public Function ucErrorMessage(Optional ByVal ErrorNumber As Integer = -1) As String
        ucErrorMessage = ucGetErrorMessage(ErrorNumber, t)
    End Function
End Class