Option Strict Off
Option Explicit On 
Imports System.Runtime.InteropServices

Module Module1
	
    Declare Sub ucPBLibInit Lib "ucpblib.dll" (ByVal t As Integer)
    Declare Sub ucDelphiLibInit Lib "ucdlplib.dll" (ByVal t As Integer)
	' for ucVBLib.DLL, use \WINDOWS\SYSTEM\REGSVR32 ucVBLib.DLL

    Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal dest As Integer, ByVal source As Integer, ByVal numBytes As Integer)

    Function ErrorHandler(ByRef t As ucThreadType) As Integer
        If (t.Context And ucContext_ucParseOrucEval) Then
            MsgBox(UCalc.ucErrorMessage(t.ErrorNumber, t.ucThread) & vbCrLf & "Data: " & UCalc.ucErrorData(0, t.ucThread), MsgBoxStyle.Exclamation)
        End If
    End Function

    Function ucalcAverage(ByRef t As ucThreadType) As Double
        Dim x As Integer
        Dim Total As Double

        For x = 1 To t.ParamCount
            Total = Total + ucParam(x, t)
        Next

        ucalcAverage = Total / t.ParamCount
    End Function

    Function ucalcSum(ByRef t As ucThreadType) As Double
        Dim ExpressionPtr, VariableHandle As Integer
        Dim x As Double
        Dim Finish, sstep, Start, Total As Double

        ExpressionPtr = ucParam(1, t)
        Start = ucParam(2, t)
        Finish = ucParam(3, t)
        sstep = ucParam(4, t)
        VariableHandle = ucParam(5, t)

        For x = Start To Finish Step sstep
            UCalc.ucSetVariableValue(VariableHandle, x)
            Total = Total + UCalc.ucEvaluate(ExpressionPtr)
        Next

        ucalcSum = Total
    End Function

    Function ucArraySum(ByRef t As ucThreadType) As Double
        Dim x As Integer
        Dim ArrayHandle As Integer
        Dim DataSize As Integer
        Dim UpperBound As Integer
        Dim BaseAddress As Integer
        Dim Total As Double

        ArrayHandle = ucParam(1, t)
        BaseAddress = ucArrayInfo(ArrayHandle, ucArray_DataAddress)
        UpperBound = ucArrayInfo(ArrayHandle, ucArray_ElementCount) - 1
        DataSize = ucArrayInfo(ArrayHandle, ucArray_ElementSize)

        Dim ValueArray(UpperBound) As Double
        Dim aHandle As GCHandle = GCHandle.Alloc(ValueArray(0), GCHandleType.Pinned)

        CopyMemory(Marshal.UnsafeAddrOfPinnedArrayElement(ValueArray, 0).ToInt32, BaseAddress, (UpperBound + 1) * DataSize)
        For x = 0 To UpperBound
            Total = Total + ValueArray(x)
        Next

        ucArraySum = Total
        aHandle.Free()
    End Function

    Function ucNPV(ByRef t As ucThreadType) As Double
        Dim DataSize As Integer
        Dim BaseAddress As Integer
        Dim UpperBound As Integer
        Dim ArrayHandle As Integer
        Dim dRate As Double

        dRate = ucParam(1, t)
        ArrayHandle = ucParam(2, t)
        BaseAddress = ucArrayInfo(ArrayHandle, ucArray_DataAddress)
        UpperBound = ucArrayInfo(ArrayHandle, ucArray_ElementCount) - 1
        DataSize = ucArrayInfo(ArrayHandle, ucArray_ElementSize)

        Dim ValueArray(UpperBound) As Double
        Dim aHandle As GCHandle = GCHandle.Alloc(ValueArray(0), GCHandleType.Pinned)
        CopyMemory(Marshal.UnsafeAddrOfPinnedArrayElement(ValueArray, 0).ToInt32, BaseAddress, (UpperBound + 1) * DataSize)

        ucNPV = NPV(dRate, ValueArray)
        aHandle.Free()
    End Function
End Module