Option Strict Off
Option Explicit On 

Public Module UCalc
    Friend FastMath_definst As New FastMath
    Friend ucVbLibucVbLibrary_definst As New ucVbLib.ucVbLibrary
    ' -------------------------------------------------------------------------
    ' ucalcvb.bas : Module file
    ' Designed to work with VB.NET 2003 or above.
    '
    ' UCalc Fast Math Parser (Beta J)
    ' Copyright (c) 1998-2004 by Daniel Corbier.  All rights reserved.
    ' http://www.ucalc.com/mathparser
    ' -------------------------------------------------------------------------
#Const ucLibraryAddon = False
    ' +++ VB include needs major revision
    Public Structure ucDefinitionSpaceType
        Dim BaseDefinitionSpace As Integer
        Dim DefinitionSpace As Integer
        Dim InlineBuffer As Integer
        Dim MaxErrorData As Integer
        Dim MaxThreadCount As Integer
    End Structure

    Public Structure ucForInternalUseType
        Dim LanguageID As Integer
        Dim ucOperator As Integer
        Dim ucEvalAddr As Integer
        Dim ucEvaluateAddr As Integer
        Dim ucThreadAddr As Integer
        Dim ParamListAddr As Integer
        Dim HandleAddr As Integer
        Dim ReleaseExprPtr As Integer
        Dim TreeIndex As Integer
        Dim TreeParamInfoAddress As Integer
        Dim HaltEvaluation As Integer
        Dim ThreadStatus As Integer
        Dim PrevSCount As Integer
        Dim PrevLCount As Integer
        Dim CompareOld As Integer
        Dim IsStringValue As Integer
        Dim ucStack As Integer
        Dim Infinity As Integer
        Dim TrigFactor As Integer
        Dim TrigFactorInv As Integer
        Dim im As Integer
    End Structure

    Public Structure ucPropertyType
        Dim DefaultNumericType As Integer
        Dim DefaultStringType As Integer
        Dim FPU_ControlWord_UCalc As Integer
        Dim FPU_ControlWord_HostProgram As Integer
        Dim CaseSensitive As Integer
        Dim ComplexNumbers As Integer
        Dim ImagSymbol As Integer
        Dim RelationalTrue As Integer
        Dim ImplicitMultiply As Integer
        Dim MaxParamPerFunction As Integer
        Dim ArrayProperties As Integer
        Dim FunctionProperties As Integer
        Dim StackSize As Integer
        Dim DefaultPrecedence As Integer
        Dim RandomSeed As Integer
        Dim OutputDigits As Integer
        Dim QuoteChar As Integer
        Dim QuoteCharSynonym As Integer
        Dim ArgumentSeparator As Integer
        Dim DecimalSeparator As Integer
        Dim StatementSeparator As Integer
        Dim DefSpace As ucDefinitionSpaceType
    End Structure

    Public Structure ucHandleType
        Dim ucThread As Integer
        Dim Info As Integer
        Dim DataType As Integer
        Dim DataPtr As Integer
        Dim DataCplxPtr As Integer
        Dim SymbolName As Integer
        Dim SortedHandle As Integer
        Dim OverloadHandle As Integer
        Dim OpPrecedence As Integer
        Dim ParamCount As Integer
        Dim CallbackPtr As Integer
        Dim FuncArgs As Integer
        Dim FuncArgHandleData As Integer
        Dim VarValueStr As Integer
        Dim UserData1 As Integer
        Dim UserData2 As Integer
        Dim UserData3 As Integer
        Dim UserData4 As Integer
    End Structure

    ' <StructLayout(LayoutKind.Sequential)> _
    Public Structure ucThreadType
        Dim ucThread As Integer
        Dim Context As Integer
        Dim ParamCount As Integer
        Dim ErrorNumber As Integer
        Dim TreeDirection As Integer
        Dim DefSpace As Integer
        Dim scount As Integer
        Dim lcount As Integer
        Dim Sequence As Integer
        Dim SequenceLast As Integer
        Dim ExprHasChanged As Integer
        Dim IsFunctionParse As Integer
        Dim ComplexStatus As Integer
        Dim ucParamAddr As Integer
        Dim ucParamHandleAddr As Integer
        Dim SymbolStart As Integer
        Dim SymbolEnd As Integer
        Dim PrecedenceMax As Integer
        Dim PrecedenceMin As Integer
        Dim VarHandle As Integer
        Dim OpHandle As Integer
        Dim ReturnString As Integer
        Dim ReturnValue As Integer
        Dim ReturnComplex As Integer
        Dim ucProperty As ucPropertyType
        Dim Handshake As ucForInternalUseType
        Dim User1 As Integer
        Dim User2 As Integer
        Dim User3 As Integer
        Dim User4 As Integer
    End Structure

    Public Structure ucComplexNumberType
        Dim Real As Double
        Dim Imag As Double
    End Structure

    Public Const ucTrue As Short = 1
    Public Const ucFalse As Short = 0

    ' LanguageID
    Public Const uc_Lang_Unsupported As Short = 0
    Public Const uc_Lang_Debug As Short = 1
    Public Const uc_Lang_PowerBasic As Short = 2
    Public Const uc_Lang_Delphi As Short = 3
    Public Const uc_Lang_VisualBasic As Short = 4
    Public Const uc_Lang_VisualBasicNET As Short = 5
    Public Const uc_Lang_CPlusPlus As Short = 6

    ' Type constants for vType arg of ucDefineFunction and ucDefineVariable
    '[[+++ Revise this list later]]
    Public Const ucType_None As Short = -2
    Public Const ucType_Constant As Short = -1
    Public Const ucType_Internal As Short = 0
    Public Const ucType_Integer8 As Short = 1
    Public Const ucType_Integer8u As Short = 2
    Public Const ucType_Integer16 As Short = 3
    Public Const ucType_Integer16u As Short = 4
    Public Const ucType_Integer32 As Short = 5
    Public Const ucType_Integer32u As Short = 6
    Public Const ucType_Integer64 As Short = 7
    Public Const ucType_Integer64u As Short = 8
    Public Const ucType_Currency As Short = 9
    Public Const ucType_CurrencyExt As Short = 10
    Public Const ucType_FloatSingle As Short = 11
    Public Const ucType_FloatDouble As Short = 12
    Public Const ucType_FloatExtended As Short = 13
    Public Const ucType_StringBSTR As Short = 14 ' For VB
    Public Const ucType_StringLPSTR As Short = 15 ' (ASCIIZ) C++ char default
    Public Const ucType_StringAnsi As Short = 16 ' PowerBASIC and Delphi default

    Public Const ucType_Long As Short = ucType_Integer32
    Public Const ucType_Double As Short = ucType_FloatDouble
    Public Const ucType_Extended As Short = ucType_FloatExtended
    Public Const ucType_AnsiString As Short = ucType_StringAnsi

    ' Context options (t.Context)
    Public Const ucContext_ucEval As Short = 1
    Public Const ucContext_ucEvalStr As Short = 2
    Public Const ucContext_ucEvaluateStr As Short = 4
    Public Const ucContext_ucParse As Short = 8
    Public Const ucContext_ucParseOrucEval As Short = 16
    Public Const ucContext_ucDefineFunction As Short = 32
    Public Const ucContext_ucDefineVariable As Short = 64
    Public Const ucContext_ucReset As Short = 128
    Public Const ucContext_MultiLineDef As Short = 256
    Public Const ucContext_MultiLineDefFirst As Short = 512
    Public Const ucContext_MultiLineDefLast As Short = 1024

    ' For ucTreeProperty, ucTreeNodeProperty,
    ' ucTreeParamProperty, and ucTreeParentProperty
    Public Const ucIsInline As Short = 0
    Public Const ucIsDynamic As Short = 1
    Public Const ucIsFastCallback As Short = 2
    Public Const ucIsLocal As Short = 3
    Public Const ucIsComplex As Short = 4
    Public Const ucIsLocked As Short = 5
    Public Const ucIsConstant As Short = ucIsLocked
    Public Const ucIsOverride As Short = 6
    Public Const ucIsOverwrite As Short = 7
    Public Const ucIsOverload As Short = 8
    Public Const ucIsRecursion As Short = 9
    Public Const ucIsBootstrap As Short = 10
    Public Const ucIsMultiLine As Short = 11
    Public Const ucIsEndMultiLine As Short = ucIsMultiLine

    Public Const ucIsArray As Short = 12

    Public Const ucIsFunction As Short = 13
    Public Const ucIsOperator As Short = 14
    Public Const ucIsBinaryOperator As Short = 15
    Public Const ucIsUnaryPostOperator As Short = 16
    Public Const ucIsUnaryPreOperator As Short = 17
    Public Const ucIsVariable As Short = 18
    Public Const ucIsJITVariable As Short = 19
    Public Const ucIsJITExpression As Short = 20
    Public Const ucIsString As Short = 21
    Public Const ucIsInternal As Short = 22
    Public Const ucIsExternal As Short = 23
    Public Const ucIsActive As Short = 24
    Public Const ucIsLCount As Short = 25
    Public Const ucIsSorted As Short = 26
    Public Const ucIsMaybeComplex As Short = 27
    Public Const ucHasComplexAltDef As Short = 28
    Public Const PassAnArray As Short = 29
    Public Const Reserved1 As Short = 30
    Public Const Reserved2 As Short = 31

    Public Const ucBinaryOp As Short = ucIsBinaryOperator
    Public Const ucUnaryPost As Short = ucIsUnaryPostOperator
    Public Const ucUnaryPre As Short = ucIsUnaryPreOperator

    ' For ucElementCategory
    Public Const ucIsOperand As Short = 32
    'ucIsFunction          = (already defined)
    Public Const ucIsFunctionArg As Short = 33
    'ucIsBinaryOperator    = (already defined)
    'ucIsUnaryPreOperator  = (already defined)
    'ucIsUnaryPostOperator = (already defined)

    Public Const ucDataType As Short = 40
    Public Const ucResultPtr As Short = 41
    Public Const ucSignPos As Short = 42
    Public Const ucElementCat As Short = 43
    Public Const ucTreeIndex As Short = 44
    Public Const ucErrorNumber As Short = 45
    Public Const ucOpHandle As Short = 46
    Public Const ucFuncHandle As Short = ucOpHandle
    Public Const ucExprPtr As Short = 47
    Public Const ucCodeAddress As Short = 48
    Public Const ucCurrentPtr As Short = 49
    Public Const ucParentPtr As Short = 50
    Public Const ucDataHandle As Short = 51
    Public Const ucMiscData As Short = 52
    Public Const ucUserData1 As Short = 53
    Public Const ucUserData2 As Short = 54
    Public Const ucUserData3 As Short = 55
    Public Const ucUserData4 As Short = 56

    Public Const ucTreePre As Short = 5
    Public Const ucTreeDownRaw As Short = 6
    Public Const ucTreeDown As Short = 7
    Public Const ucTreeUp As Short = 8

    Public Const ucErrorCallback As Short = 9

    Public Const ucNoChange As Short = 0
    Public Const ucMinorChange As Short = 1
    Public Const ucMajorChange As Short = 2

    ' Trig mode options for ucSetTrigMode
    Public Const ucRadians As Short = 1
    Public Const ucDegrees As Short = 2
    Public Const ucGrads As Short = 3
    Public Const ucCycles As Short = 4

    ' Options for ucArrayInfo,
    ' and the first two for ucProperties.ArrayProperties
    Public Const ucArray_BoundsCheck As Short = 1
    Public Const ucArray_ColumnMajor As Short = 2
    Public Const ucArray_DataAddress As Short = 3
    Public Const ucArray_DataType As Short = 4
    Public Const ucArray_DimensionCount As Short = 5
    Public Const ucArray_ElementCount As Short = 6
    Public Const ucArray_ElementSize As Short = 7

    ' Options for fProperties parameter of ucDefineFunction
    ' and for ucProperties.FunctionProperties
    Public Const ucInline As Short = 1
    Public Const ucDynamic As Short = 2
    Public Const ucFastCallback As Short = 4
    Public Const ucLocal As Short = 8
    Public Const ucComplex As Short = 16
    Public Const ucLocked As Short = 32
    Public Const ucConstant As Short = ucLocked
    Public Const ucOverride As Short = 64
    Public Const ucOverwrite As Short = 128
    Public Const ucOverload As Short = 256
    Public Const ucRecursion As Short = 512
    Public Const ucBootstrap As Short = 1024
    Public Const ucMultiLine As Short = 2048
    Public Const ucEndMultiLine As Short = ucMultiLine

    ' FPU control word values for ucProperties.FPU_ControlWord,
    ' and SetFPU(), SetOrFPU, SetXorFPU, GetFPU(), RestoreFPU
    Public Const ucFPU_ErrMask_InvalidOp As Short = 1
    Public Const ucFPU_ErrMask_DenormalOp As Short = 2
    Public Const ucFPU_ErrMask_ZeroDivide As Short = 4
    Public Const ucFPU_ErrMask_Overflow As Short = 8
    Public Const ucFPU_ErrMask_Underflow As Short = 16
    Public Const ucFPU_ErrMask_PrecisionLoss As Short = 32

    Public Const ucFPU_Precision_Single As Short = 0
    Public Const ucFPU_Precision_Double As Short = 256
    Public Const ucFPU_Precision_Extended As Short = 768

    Public Const ucFPU_Round_Even As Short = 0
    Public Const ucFPU_Round_Down As Short = 1024
    Public Const ucFPU_Round_Up As Short = 2048
    Public Const ucFPU_Round_Toward As Short = 3072

    ' For ucSetErrorData / ucGetErrorData
    Public Const ucNewIndex As Short = -2
    Public Const ucNewUniqueIndex As Short = -1
    Public Const ucAllErrorData As Short = -1

    ' Error Values
    Public Const ucErr_None As Short = 0
    Public Const ucErr_ucErrorData As Short = 1
    Public Const ucErr_SyntaxError As Short = 2
    Public Const ucErr_MismatchedParenth As Short = 3
    Public Const ucErr_MismatchedQuotes As Short = 4
    Public Const ucErr_UndefinedVariable As Short = 5
    Public Const ucErr_UndefinedFunction As Short = 6
    Public Const ucErr_IncorrectArgType As Short = 7
    Public Const ucErr_InvalidNumberOfArgs As Short = 8
    Public Const ucErr_InvalidOperandType As Short = 9
    Public Const ucErr_InvalidName As Short = 10
    Public Const ucErr_ImplicitMult As Short = 11

    Public Const ucErr_InvalidOperation As Short = 20
    Public Const ucErr_DenormalOperand As Short = 21
    Public Const ucErr_DivisionByZero As Short = 22
    Public Const ucErr_Overflow As Short = 23
    Public Const ucErr_Underflow As Short = 24
    Public Const ucErr_InexactResult As Short = 25
    Public Const ucErr_SubscriptOutOfRange As Short = 35
    Public Const ucErr_StackOverflow As Short = 36

    Public Const ucErr_OperationDenied As Short = 40
    Public Const ucErr_PropertyConflict As Short = 41
    Public Const ucErr_ConstantWriteDenied As Short = 42
    Public Const ucErr_FunctionDefError As Short = 43
    Public Const ucErr_FunctionLocked As Short = 44

    Public Const ucErr_DefinitionSpaceFull As Short = 60
    Public Const ucErr_ThreadInitFailed As Short = 61
    Public Const ucErr_UnsupportedFeature As Short = 62

    Public ucInitialized As Integer
    Public t0 As ucThreadType

    Public Delegate Function ucCallbackDbl(ByRef t As ucThreadType) As Double
    Public Delegate Function ucCallbackInt(ByRef t As ucThreadType) As Integer

    Public Declare Sub ucDetachSymbolE Lib "ucalcfmp.dll" (ByVal Symbol As String, ByVal t As Integer)
    Public Declare Sub ucErrorClearE Lib "ucalcfmp.dll" (ByVal t As Integer)
    Public Declare Sub ucLicenseE Lib "ucalcfmp.dll" (ByVal SerialNumber As String)
    Public Declare Sub ucReleaseItemE Lib "ucalcfmp.dll" (ByVal ItemHandle As Integer)
    Public Declare Sub ucReleaseThreadE Lib "ucalcfmp.dll" (ByVal ucThread As Integer)
    Public Declare Sub ucResetE Lib "ucalcfmp.dll" (ByVal t As Integer)
    Public Declare Sub ucReturnDblE Lib "ucalcfmp.dll" (ByVal vValue As Double, ByRef t As ucThreadType)
    Public Declare Sub ucReturnCplxDblE Lib "ucalcfmp.dll" (ByVal vValue As Double, ByRef t As ucThreadType)
    Public Declare Sub ucReturnStrE Lib "ucalcfmp.dll" (ByVal Expression As String, ByRef t As ucThreadType)
    Public Declare Sub ucSetErrorDataE Lib "ucalcfmp.dll" (ByVal errIndex As Integer, ByVal vValue As String, ByRef t As ucThreadType)
    Public Declare Sub ucSetParamStrE Lib "ucalcfmp.dll" (ByVal ParamIndex As Integer, ByVal Argument As String, ByRef t As ucThreadType)
    Public Declare Sub ucSetThreadDataE Lib "ucalcfmp.dll" (ByVal ucThread As Integer, ByRef t As ucThreadType)
    Public Declare Sub ucSetTrigModeE Lib "ucalcfmp.dll" (ByVal TrigMode As Integer, ByVal t As Integer)
    Public Declare Sub ucSetVariableValueDblE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer, ByVal vValue As Double)
    Public Declare Sub ucSetVariableValueStrE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer, ByVal vValue As String)
    Public Declare Sub ucTreeSetParamE Lib "ucalcfmp.dll" (ByVal pIndex As Integer, ByVal pData As String, ByRef t As ucThreadType)
    Public Declare Function ucAliasE Lib "ucalcfmp.dll" (ByVal AssignFrom As String, ByVal AssignTo As String, ByVal t As Integer) As Integer
    Public Declare Function ucArrayInfoE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer, ByVal InfoOption As Integer) As Integer
    Public Declare Function ucDefineFunctionE Lib "ucalcfmp.dll" (ByVal FunctionDef As String, ByVal FunctionAddress As ucCallbackDbl, ByVal Precedence As Integer, ByVal fProperties As Integer, ByVal vType As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucDefineVariableE Lib "ucalcfmp.dll" (ByVal VariableDef As String, ByVal vPtr As Integer, ByVal Expr As Integer, ByVal vProperties As Integer, ByVal vType As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucEvalE Lib "ucalcfmp.dll" (ByVal Expression As String, ByVal t As Integer) As Double
    Public Declare Function ucEvalStrE Lib "ucalcfmp.dll" (ByVal Expression As String, ByVal t As Integer) As String
    Public Declare Function ucEvaluateStrE Lib "ucalcfmp.dll" (ByVal ExpressionPtr As Integer) As String
    Public Declare Function ucGetErrorDataE Lib "ucalcfmp.dll" (ByVal errIndex As Integer, ByVal t As Integer) As String
    Public Declare Function ucGetParamE Lib "ucalcfmp.dll" (ByVal pIndex As Integer, ByRef t As ucThreadType) As Double
    Public Declare Function ucGetParamCplxE Lib "ucalcfmp.dll" (ByVal pIndex As Integer, ByRef t As ucThreadType) As Double
    Public Declare Function ucGetParamStrE Lib "ucalcfmp.dll" (ByVal ParamIndex As Integer, ByRef t As ucThreadType) As String
    Public Declare Function ucGetThreadInfoE Lib "ucalcfmp.dll" (ByVal ucThread As Integer, ByRef t As ucThreadType) As Integer
    Public Declare Function ucGetVariableValueE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer) As Double
    Public Declare Function ucGetVariableValueStrE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer) As String
    Public Declare Function ucImagPartE Lib "ucalcfmp.dll" (ByVal t As Integer) As Double
    Public Declare Function ucLowerBoundE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer, ByVal Dimension As Integer) As Integer
    Public Declare Function ucNewThreadE Lib "ucalcfmp.dll" () As Integer
    Public Declare Function ucNewSymbolHandleE Lib "ucalcfmp.dll" (ByVal t As Integer) As Integer
    Public Declare Function ucParamHandleE Lib "ucalcfmp.dll" (ByVal pIndex As Integer, ByRef t As ucThreadType) As Integer
    Public Declare Function ucParamTypeE Lib "ucalcfmp.dll" (ByVal pIndex As Integer, ByRef t As ucThreadType) As Integer
    Public Declare Function ucParseE Lib "ucalcfmp.dll" (ByVal Expression As String, ByVal LocalVars As String, ByVal ExprType As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucPrecedenceE Lib "ucalcfmp.dll" (ByVal Op As String, ByVal OpCategory As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucSetCallbackE Lib "ucalcfmp.dll" (ByVal FunctionAddress As ucCallbackInt, ByVal TreeOption As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucSymbolHandleE Lib "ucalcfmp.dll" (ByVal ucSymbol As String, ByVal SymbolProperty As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucThreadAddrE Lib "ucalcfmp.dll" (ByVal t As Integer) As Integer
    Public Declare Function ucTreeGetParamE Lib "ucalcfmp.dll" (ByVal pIndex As Integer, ByRef t As ucThreadType) As String
    Public Declare Function ucTreePropertyE Lib "ucalcfmp.dll" (ByVal NodePtr As Integer, ByVal pIndex As Integer, ByVal pOption As Integer, ByRef t As ucThreadType) As Integer
    Public Declare Function ucUpperBoundE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer, ByVal Dimension As Integer) As Integer

    ' These 3 functions come from ucalcfmE.dll instead of ucalcfmP.dll
    Public Declare Function ucEvaluateE Lib "ucalcfme.dll" (ByVal ExpressionPtr As Integer) As Double
    Public Declare Sub ucEvaluateInitE Lib "ucalcfme.dll" ()
    Public Declare Sub ucReleaseExprPtrE Lib "ucalcfme.dll" (ByVal ExpressionPtr As Integer)


    Public Function ucPrecedence(ByRef Op As String, Optional ByVal OpCategory As Integer = 0, Optional ByVal t As Integer = 0) As Integer
        ucPrecedence = ucPrecedenceE(Op, OpCategory, ucThreadAddr(t))
    End Function

    Public Function ucSymbolHandle(ByRef ucSymbolE As String, Optional ByVal SymbolProperty As Integer = 0, Optional ByVal t As Integer = 0) As Integer
        ucSymbolHandle = ucSymbolHandleE(ucSymbolE, SymbolProperty, ucThreadAddr(t))
    End Function

    Public Function ucError() As Integer
        ucGetThreadInfo(0, t0)
        ucError = t0.ErrorNumber
    End Function

    Public ReadOnly Property ucErrorData(ByVal errIndex As Integer, Optional ByVal t As Integer = 0) As String
        Get
            ucErrorData = ucGetErrorDataE(errIndex, ucThreadAddr(t))
        End Get
    End Property

    Public ReadOnly Property ucGetErrorData(ByVal errIndex As Integer, Optional ByVal t As Integer = 0) As String
        Get
            ucGetErrorData = ucGetErrorDataE(errIndex, ucThreadAddr(t))
        End Get
    End Property


    Public Property ucVariableValue(ByVal VarHandle As Integer) As Double
        Get
            ucVariableValue = ucGetVariableValueE(VarHandle)
        End Get
        Set(ByVal Value As Double)
            ucSetVariableValueDblE(VarHandle, Value)
        End Set
    End Property


    Public Property ucVariableValueStr(ByVal VarHandle As Integer) As String
        Get
            ucVariableValueStr = ucGetVariableValueStrE(VarHandle)
        End Get
        Set(ByVal Value As String)
            ucSetVariableValueStrE(VarHandle, Value)
        End Set
    End Property

    Public Property ucParamStr(ByVal ParamIndex As Integer, ByVal t As ucThreadType) As String
        Get
            ucParamStr = ucGetParamStrE(ParamIndex, t)
        End Get
        Set(ByVal Value As String)
            ucSetParamStrE(ParamIndex, Value, t)
        End Set
    End Property

    Public Function ucAttachVariable(ByRef VariableDef As String, ByRef vPtr As Integer, Optional ByVal ExprPtr As Integer = 0, Optional ByVal vProperties As Integer = 0, Optional ByVal t As Integer = 0) As Integer
        ucAttachVariable = ucDefineVariableE(VariableDef, vPtr, ExprPtr, vProperties, 0, ucThreadAddr(t))
    End Function

    Public Function ucDefineFunction(ByRef FunctionDef As String, Optional ByVal FunctionAddress As ucCallbackDbl = Nothing, Optional ByVal fProperties As Integer = 0, Optional ByVal vType As Integer = 0) As Integer
        ucDefineFunction = ucDefineFunctionE(FunctionDef, FunctionAddress, 0, fProperties, vType, ucThreadAddr(0))
    End Function

    Public Function ucDefineOperator(ByRef OperatorDef As String, Optional ByVal Precedence As Integer = 0, Optional ByVal OperatorAddress As ucCallbackDbl = Nothing, Optional ByVal fProperties As Integer = 0, Optional ByVal vType As Integer = 0) As Integer
        ucDefineOperator = ucDefineFunctionE(OperatorDef, OperatorAddress, Precedence, fProperties, vType, ucThreadAddr(0))
    End Function

    Public Function ucAlias(ByRef AssignFrom As String, ByRef AssignTo As String) As Integer
        ucAlias = ucAliasE(AssignFrom, AssignTo, ucThreadAddr(0))
    End Function

    Public Sub ucDetachSymbol(ByRef Symbol As String, ByVal t As Integer)
        ucDetachSymbolE(Symbol, ucThreadAddr(t))
    End Sub

    Public Sub ucErrorClear()
        ucErrorClearE(ucThreadAddr(0))
    End Sub

    Public Function ucDefineConstant(ByRef ConstantDef As String, Optional ByVal vProperties As Integer = 0) As Integer
        ucDefineConstant = ucDefineVariableE(ConstantDef, 0, 0, vProperties, ucType_Constant, ucThreadAddr(0))
    End Function

    Public Sub ucReset()
        Dim Between_Mult_Pow As Integer
        Dim Between_And_Less As Integer
        Dim TempContext As Integer
        ' +++ Need ucItem equivalent for VB.NET

        ucEvaluateInitE()
        ucGetThreadInfo(0, t0)
        ucResetE(ucThreadAddr(0))
        ucGetThreadInfo(0, t0)

        '   ucProperties.DefaultType = ucType_Double
        'TempContext = t0.Context
        't0.Context = t0.Context Or ucContext_ucReset '+++
        t0.Handshake.LanguageID = uc_Lang_VisualBasicNET
        t0.ucProperty.ComplexNumbers = ucTrue
        t0.ucProperty.FunctionProperties = ucInline + ucLocked + ucOverride + ucOverload

        Between_Mult_Pow = (ucPrecedence("*") + ucPrecedence("^")) / 2
        Between_And_Less = (ucPrecedence("AND") + ucPrecedence("<")) / 2

        ' String relational (comparison) operators
        Static d_ucEqual As ucCallbackDbl = New ucCallbackDbl(AddressOf ucEqual)
        Static d_ucNotEqual As ucCallbackDbl = New ucCallbackDbl(AddressOf ucNotEqual)
        Static d_ucGreater As ucCallbackDbl = New ucCallbackDbl(AddressOf ucGreater)
        Static d_ucGreaterOrEqual As ucCallbackDbl = New ucCallbackDbl(AddressOf ucGreaterOrEqual)
        Static d_ucLess As ucCallbackDbl = New ucCallbackDbl(AddressOf ucLess)
        Static d_ucLessOrEqual As ucCallbackDbl = New ucCallbackDbl(AddressOf ucLessOrEqual)

        ucDefineOperator(" =[a$,b$]", ucPrecedence("="), d_ucEqual)
        ucDefineOperator("<>[a$,b$]", ucPrecedence("<>"), d_ucNotEqual)
        ucDefineOperator(" >[a$,b$]", ucPrecedence(">"), d_ucGreater)
        ucDefineOperator(">=[a$,b$]", ucPrecedence(">="), d_ucGreaterOrEqual)
        ucDefineOperator(" <[a$,b$]", ucPrecedence("<"), d_ucLess)
        ucDefineOperator("<=[a$,b$]", ucPrecedence("<="), d_ucLessOrEqual)

        ' Alternative notations
        '   ucDefineOperator "  &[a,b] = a and b", ucPrecedence("and")
        '   ucDefineOperator "  |[a,b] = a or  b", ucPrecedence("or ")
        '   ucDefineOperator " =<[a,b] = a <=  b", ucPrecedence("<= ")
        '   ucDefineOperator " =>[a,b] = a >=  b", ucPrecedence(">= ")
        ucDefineOperator(" ==[a,b] = a  =  b", ucPrecedence("="))
        ucDefineOperator("DIV[a,b] = a  \  b", ucPrecedence("\"))
        ucDefineOperator("**[a,b]  = a  ^  b", ucPrecedence("^"))
        ucDefineOperator(" &$[TextA$,TextB$] = TextA + TextB", ucPrecedence("+"))
        ucDefineOperator("==[TextA$,TextB$] = TextA = TextB", ucPrecedence("="))
        ucDefineFunction("Concatenate$(a$,b$) = a + b")
        ucDefineFunction("RND()   = RND(1)")
        ucDefineFunction("Sign(x) = Sgn(x)")
        ucDefineFunction("Sqrt(x) = Sqr(x)")
        ucDefineFunction("Ln(x)   = Log(x)")
        ucDefineFunction("Atan(x) = Atn(x)")
        ucDefineOperator("[x]! = fact(x)", t0.PrecedenceMax)
        ucDefineOperator("[x]% = x/100", t0.PrecedenceMax)
        ucDefineOperator("%[x,y] = x mod y", ucPrecedence("MOD"))
        ucDefineOperator("-[x] = 0-x", Between_Mult_Pow)
        ucDefineOperator("+[x] = 0+x", Between_Mult_Pow)
        ucDefineOperator("Not[x] = Not(x)", Between_And_Less)

        ' FPU routines
        ucDefineFunction("GetFPU() = GetFPU(0)")
        ucDefineFunction("RestoreFPU() = RestoreFPU(0)")
        ucAlias("GetFPU", "GetFPU(0)")
        ucAlias("RestoreFPU", "RestoreFPU(0)")
        ucAlias("SetFPU(setting, Expression)", "(SetFPU(setting)+(Expression)+RestoreFPU(0))")
        ucAlias("SetOrFPU(setting, Expression)", "(SetOrFPU(setting)+(Expression)+RestoreFPU(0))")
        ucAlias("SetXorFPU(setting, Expression)", "(SetXorFPU(setting)+(Expression)+RestoreFPU(0))")

        ucDefineFunction("Inf() = SetOrFPU(4, 1/0)", Nothing, ucDynamic)
        ucDefineFunction("NaN() = SetOrFPU(1, 0/0)", Nothing, ucDynamic)

        ' Hyperbolic functions
        ucDefineFunction("Sinh(x)  = (exp(x) - exp(-x)) / 2")
        ucDefineFunction("Cosh(x)  = (exp(x) + exp(-x)) / 2")
        ucDefineFunction("Tanh(x)  = (exp(2x) - 1) / (exp(2x) + 1)")
        ucDefineFunction("Coth(x)  = (exp(2x) + 1) / (exp(2x) - 1)")
        ucDefineFunction("Sech(x)  = 2 / (exp(x) + exp(-x))")
        ucDefineFunction("Csch(x)  = 2 / (exp(x) - exp(-x))")
        ucDefineFunction("Asinh(x) = Log(x + Sqr(x ^ 2 + 1))")
        ucDefineFunction("Acosh(x) = Log(x + Sqr(x ^ 2 - 1))")
        ucDefineFunction("Atanh(x) = Log((1 + x) / (1 - x)) / 2")
        ucDefineFunction("Acoth(x) = Log((x + 1) / (x - 1)) / 2")
        ucDefineFunction("Asech(x) = Log((1 + Sqr(1 - x ^ 2)) / x)")
        ucDefineFunction("Acsch(x) = Log(1 / x + Sqr(1 + x ^ 2) / Abs(x))")

        ' A few constants needed in some definitions further down
        ucDefineConstant("Pi     = Atn(1) * 4")
        ucDefineConstant("HalfPI = Pi/2")

        ' Other functions
        ucDefineFunction("Sec(x)   = 1 / Cos(x)")
        ucDefineFunction("Csc(x)   = 1 / Sin(x)")
        ucDefineFunction("Cot(x)   = 1 / Tan(x)")
        ucDefineFunction("Asin(x)  = SetOrFPU(4, Atn(x / Sqr(1 - x * x)))") ' +++ make provisions for complex
        ucDefineFunction("Acos(x)  = HalfPI - Asin(x)")
        ucDefineFunction("Log2(x)  = Log(x) / Log(2)")
        ucDefineFunction("Exp2(x)  = 2 ^ x")
        ucDefineFunction("Log10(x) = Log(x) / Log(10)")
        ucDefineFunction("Exp10(x) = 10 ^ x")

        ' Complex operators & functions
        t0.ucProperty.FunctionProperties = ucDynamic + ucLocked + ucOverride + ucOverload + ucComplex
        ucDefineOperator("+[x] = x.Real + x.Imag*#i", Between_Mult_Pow)
        ucDefineOperator("-[x] = (-x.Real) + (-x.Imag)*#i", Between_Mult_Pow)

        ucDefineOperator("+[x,y] = x.Real+y.Real + (x.Imag+y.Imag)*#i", ucPrecedence("+"))
        ucDefineOperator("*[x,y] = (x.Real*y.Real - x.Imag*y.Imag)+(x.Real*y.Imag + x.Imag*y.Real)*#i", ucPrecedence("*"))
        ucDefineOperator("-[x,y] = (x.Real-y.Real) + (x.Imag-y.Imag)*#i", ucPrecedence("-"))
        ucDefineOperator("/[x,y] = x.Real*y.Real/(y.Real^2+y.Imag^2) + x.Imag*y.Imag" & "/(y.Real^2+y.Imag^2) + (x.Imag*y.Real/(y.Real^2+y.Imag^2)-x.Real*y.Imag" & "/(y.Real^2+y.Imag^2))*#i", ucPrecedence("/"))

        ucDefineFunction("Abs(x) = Sqr(x.Real^2 + x.Imag^2) + 0*#i")
        ucDefineFunction("Sgn(x) = x.Real/Abs(x) + x.Imag/Abs(x)*#i")
        ucDefineFunction("Sin(x) = Sin(x.Real)*Cosh(x.Imag) + Cos(x.Real)*Sinh(x.Imag)*#i")
        ucDefineFunction("Cos(x) = Cos(x.Real)*Cosh(x.Imag) - Sin(x.Real)*Sinh(x.Imag)*#i")
        ucDefineFunction("Phase(x) = iif(x.Imag=0, iif(x.Real>0, 0, pi), atn(x.Imag/x.Real)) + 0*#i")
        ucDefineFunction("Conj(x)  = x.Real - x.Imag*#i")
        ucDefineFunction("Exp(x)   = exp(x.Real)*Cos(x.Imag) + exp(x.Real)*sin(x.Imag)*#i")
        ucDefineFunction("Imag(x)  = x.Imag + 0*#i")
        ucDefineFunction("Real(x)  = x.Real + 0*#i")

        ucDefineFunction("Sqr(x)   = Sqr(Sqr(x.Real^2 + x.Imag^2)+x.Real)/Sqr(2)" & "+ (Sqr(Sqr(x.Real^2 + x.Imag^2)-x.Real)*iif(x.Imag < 0, -1, 1)/Sqr(2))*#i")
        ucDefineFunction("Sqrt(x)  = Sqr(x.Real+x.Imag*#i)")

        ucDefineFunction("Log(x) = iif(x.Real=0 and x.Imag=0, -Inf," & "Log(x.Real^2 + x.Imag^2)/2)" & "+iif(x.Real=0 and x.Imag=0, 0, iif(x.Real>0 and x.Imag=0, 0," & "iif(x.Imag=0, pi, pi*sgn(x.Imag)/2-Atn(x.Real/x.Imag))))*#i")

        ucDefineFunction("_ZeroToZero() = 1", Nothing, ucDynamic + ucOverwrite)
        '  ucDefineFunction "_ZeroToZero() = 0", 0, ucDynamic+ucOverwrite
        '  ucDefineFunction "_ZeroToZero() = NaN", 0, ucDynamic+ucOverwrite
        '  ucDefineFunction "_ZeroToZero() = SetError(1, '0^0 Error')", 0, ucDynamic+ucOverwrite

        ucDefineOperator("^[x,y] = iif(x.Imag = 0, iif(x.Real > 0," & "x.Real^y.Real*Cos(y.Imag*Log(x.Real))," & "iif(x.Real=0 and y.Real=0 and y.Imag=0, _ZeroToZero()," & "(-x.Real)^y.Real*COS(y.Imag*LOG(-x.Real)+pi*y.Real)/EXP(pi*y.Imag)))," & "EXP(y.Imag*ATN(x.Real/x.Imag))*SQR((x.Imag^2+x.Real^2)^y.Real)" & "*COS(pi*y.Real*sgn(x.Imag)/2-y.Real*ATN(x.Real/x.Imag)+y.Imag" & "*LOG(x.Imag^2+x.Real^2)/2)/SQR(EXP(pi*y.Imag*Sgn(x.Imag))))-55+55" & "+iif(x.Imag = 0, iif(x.Real > 0," & "x.Real^y.Real*SIN(y.Imag*LOG(x.Real))," & "iif(x.Real=0 and y.Real=0 and y.Imag=0, 0," & "(-x.Real)^y.Real*SIN(y.Imag*LOG(-x.Real)+pi*y.Real)/EXP(pi*y.Imag)))," & "EXP(y.Imag*ATN(x.Real/x.Imag))*SQR((x.Imag^2+x.Real^2)^y.Real)" & "*SIN(pi*y.Real*sgn(x.Imag)/2-y.Real*ATN(x.Real/x.Imag)+y.Imag" & "*LOG(x.Imag^2+x.Real^2)/2)/SQR(EXP(pi*y.Imag*Sgn(x.Imag)))-55+55)*#i", ucPrecedence("^"))

        ucDefineConstant("Byte     = ucType_Integer8")
        ucDefineConstant("Integer  = ucType_Integer16")
        ucDefineConstant("Word     = ucType_Integer16u")
        ucDefineConstant("Long     = ucType_Integer32")
        ucDefineConstant("DWord    = ucType_Integer32u")
        ucDefineConstant("Quad     = ucType_Integer64")
        ucDefineConstant("Currency = ucType_Currency")
        ucDefineConstant("CurrencyX= ucType_CurrencyExt")
        ucDefineConstant("Single   = ucType_FloatSingle")
        ucDefineConstant("Double   = ucType_FloatDouble")
        ucDefineConstant("Extended = ucType_FloatExtended")
        ucDefineConstant("AsciiZ   = ucType_StringLPSTR")
        ucDefineConstant("String   = ucType_StringAnsi")

        t0.ucProperty.FunctionProperties = ucDynamic + ucOverload + ucOverwrite + ucComplex + ucRecursion
        t0.ucProperty.DefaultNumericType = ucType_Double
        't0.Context = TempContext
    End Sub

    Public Function ucGetThreadInfo(ByVal ucThread As Integer, ByRef t As ucThreadType) As Integer
        ucGetThreadInfo = ucGetThreadInfoE(ucThread, t)
    End Function

    Public Sub ucSetThreadData(ByVal ucThread As Integer, ByRef t As ucThreadType)
        If ucInitialized Then ucSetThreadDataE(ucThread, t)
    End Sub

    Public Sub ucSetTrigMode(ByVal TrigMode As Integer, Optional ByVal t As Integer = 0)
        ucSetTrigModeE(TrigMode, ucThreadAddr(t))
    End Sub

    Public Function ucArrayInfo(ByVal VarHandle As Integer, ByVal InfoOption As Integer) As Integer
        ucArrayInfo = ucArrayInfoE(VarHandle, InfoOption)
    End Function

    Public Function ucLowerBound(ByVal VarHandle As Integer, Optional ByVal Dimension As Integer = 1) As Integer
        ucLowerBound = ucLowerBoundE(VarHandle, Dimension)
    End Function

    Public Function ucParse(ByRef Expression As String, Optional ByRef LocalVars As String = "", Optional ByRef ExprType As Integer = 0) As Integer
        ucParse = ucParseE(Expression, LocalVars, ExprType, ucThreadAddr(0))
    End Function

    Public Function ucUpperBound(ByVal VarHandle As Integer, Optional ByVal Dimension As Integer = 1) As Integer
        ucUpperBound = ucUpperBoundE(VarHandle, Dimension)
    End Function

    Public Function ucNewSymbolHandle(Optional ByVal t As Integer = 0) As Integer
        ucNewSymbolHandle = ucNewSymbolHandleE(ucThreadAddr(t))
    End Function

    Public Sub ucReturn(ByVal vValue As Double, ByRef t As ucThreadType)
        ucReturnDblE(vValue, t)
    End Sub

    Public Sub ucReturnCplx(ByVal vValue As Double, ByRef t As ucThreadType)
        ucReturnCplxDblE(vValue, t)
    End Sub

    Public Sub ucReturnStr(ByRef Expression As String, ByRef t As ucThreadType)
        ucReturnStrE(Expression, t)
    End Sub

    Public Function ucErrorHandler(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucErrorHandler = ucSetCallbackE(FunctionAddress, ucErrorCallback, ucThreadAddr(0))
    End Function

    Public Function ucEval(ByRef Expression As String, Optional ByVal t As Integer = 0) As Double
        ucEval = ucEvalE(Expression, ucThreadAddr(t))
    End Function

    Public Function ucEvalStr(ByRef Expression As String, Optional ByVal t As Integer = 0) As String
        ucEvalStr = ucEvalStrE(Expression, ucThreadAddr(t))
    End Function

    Public Function ucEvaluate(ByVal ExpressionPtr As Integer) As Double
        ucEvaluate = ucEvaluateE(ExpressionPtr)
    End Function

    Public Function ucEvaluateStr(ByVal ExpressionPtr As Integer) As String
        ucEvaluateStr = ucEvaluateStrE(ExpressionPtr)
    End Function

    Public Function ucGetVariableValue(ByVal VarHandle As Integer) As Double
        ucGetVariableValue = ucGetVariableValueE(VarHandle)
    End Function

    Public Function ucGetVariableValueStr(ByVal VarHandle As Integer) As String
        ucGetVariableValueStr = ucGetVariableValueStrE(VarHandle)
    End Function

    Public Sub ucSetVariableValue(ByVal VarHandle As Integer, ByVal vValue As Double)
        ucSetVariableValueDblE(VarHandle, vValue)
    End Sub

    Public Sub ucSetVariableValueStr(ByVal VarHandle As Integer, ByRef vValue As String)
        ucSetVariableValueStrE(VarHandle, vValue & Chr(0))
    End Sub

    Public Function ucImagPart(Optional ByVal t As Integer = 0) As Double
        ucImagPart = ucImagPartE(ucThreadAddr(t))
    End Function

    Public Function ucPreParse(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucPreParse = ucSetCallbackE(FunctionAddress, ucTreePre, ucThreadAddr(0))
    End Function

    Public Function ucTreeParseDownRaw(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucTreeParseDownRaw = ucSetCallbackE(FunctionAddress, ucTreeDownRaw, ucThreadAddr(0))
    End Function

    Public Function ucTreeParseDown(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucTreeParseDown = ucSetCallbackE(FunctionAddress, ucTreeDown, ucThreadAddr(0))
    End Function

    Public Function ucTreeParseUp(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucTreeParseUp = ucSetCallbackE(FunctionAddress, ucTreeUp, ucThreadAddr(0))
    End Function

    Public Function ucGetExpr(ByRef t As ucThreadType) As String
        ucGetExpr = ucTreeGetParamE(-1, t)
    End Function

    Public Function ucTreeGetExpr(ByRef t As ucThreadType) As String
        ucTreeGetExpr = ucTreeGetParamE(-1, t)
    End Function

    Public Function ucTreeGetFunc(ByRef t As ucThreadType) As String
        ucTreeGetFunc = ucTreeGetParamE(0, t)
    End Function

    Public Function ucTreeGetOp(ByRef t As ucThreadType) As String
        ucTreeGetOp = ucTreeGetParamE(0, t)
    End Function

    Public Function ucTreeGetParam(ByVal pIndex As Integer, ByRef t As ucThreadType) As String
        ucTreeGetParam = ucTreeGetParamE(pIndex, t)
    End Function

    Public Function ucTreeGetParamList(ByRef t As ucThreadType) As String
        ucTreeGetParamList = ucTreeGetParamE(-2, t)
    End Function

    Public Sub ucSetExpr(ByRef Expression As String, ByRef t As ucThreadType)
        ucTreeSetParamE(-1, Expression, t)
    End Sub

    Public Sub ucTreeSetExpr(ByRef Expression As String, ByRef t As ucThreadType)
        ucTreeSetParamE(-1, Expression, t)
    End Sub

    Public Sub ucTreeSetFunc(ByRef TreeFunc As String, ByRef t As ucThreadType)
        ucTreeSetParamE(0, TreeFunc, t)
    End Sub

    Public Sub ucTreeSetOp(ByRef TreeOp As String, ByRef t As ucThreadType)
        ucTreeSetParamE(0, TreeOp, t)
    End Sub

    Public Sub ucTreeSetParam(ByVal pIndex As Integer, ByRef pData As String, ByRef t As ucThreadType)
        ucTreeSetParamE(pIndex, pData, t)
    End Sub

    Public Sub ucTreeSetParamList(ByRef pData As String, ByRef t As ucThreadType)
        ucTreeSetParamE(-2, pData, t)
    End Sub

    Public Function ucElementCategory(ByRef t As ucThreadType) As Integer
        ucElementCategory = ucTreePropertyE(0, 0, ucElementCat, t)
    End Function

    Public Function ucTreeProperty(ByVal NodePtr As Integer, ByVal pIndex As Integer, ByVal pOption As Integer, ByRef t As ucThreadType) As Integer
        ucTreeProperty = ucTreePropertyE(NodePtr, pIndex, pOption, t)
    End Function

    Public Function ucTreeNodeProperty(ByVal pOption As Integer, ByRef t As ucThreadType) As Integer
        ucTreeNodeProperty = ucTreePropertyE(0, 0, pOption, t)
    End Function

    Public Function ucTreeParamProperty(ByVal pIndex As Integer, ByVal pOption As Integer, ByRef t As ucThreadType) As Integer
        ucTreeParamProperty = ucTreePropertyE(0, pIndex, pOption, t)
    End Function

    Public Function ucTreeParentProperty(ByVal pOption As Integer, ByRef t As ucThreadType) As Integer
        Dim ParentPtr As Integer

        ParentPtr = ucTreePropertyE(0, 0, ucParentPtr, t)
        ucTreeParentProperty = ucTreePropertyE(ParentPtr, 0, pOption, t)
    End Function

    Public Function ucDefineVariable(ByRef VariableDef As String, Optional ByVal vProperties As Integer = 0) As Integer
        ucDefineVariable = ucDefineVariableE(VariableDef, 0, 0, vProperties, ucType_Internal, ucThreadAddr(0))
    End Function

    Public Function ucGetParamStr(ByVal ParamIndex As Integer, ByRef t As ucThreadType) As String
        ucGetParamStr = ucGetParamStrE(ParamIndex, t)
    End Function
    Public Sub ucSetParamStr(ByVal ParamIndex As Integer, ByRef Argument As String, ByRef t As ucThreadType)
        ucSetParamStrE(ParamIndex, Argument, t)
    End Sub

    Public Sub ucReleaseExprPtr(ByVal ExpressionPtr As Integer)
        ucReleaseExprPtrE(ExpressionPtr)
    End Sub

    Public Sub ucReleaseItem(ByVal ItemHandle As Integer)
        ucReleaseItemE(ItemHandle)
    End Sub

    'Public Property Let ucErrorData(ByVal errIndex As Long, t As ucThreadType, vValue As String)
    '   ucSetErrorDataE errIndex, vValue, t
    'End Property ' +++

    Public Sub ucLicense(ByRef SerialNumber As String)
        ucLicenseE(SerialNumber)
    End Sub

    Public Function ucParam(ByVal x As Integer, ByRef t As ucThreadType) As Double
        ucParam = ucGetParamE(x, t)
    End Function

    Public Function ucParamCplx(ByVal x As Integer, ByRef t As ucThreadType) As Double
        ucParamCplx = ucGetParamCplxE(x, t)
    End Function

    Public Function ucParamHandle(ByVal pIndex As Integer, ByRef t As ucThreadType) As Integer
        ucParamHandle = ucParamHandleE(pIndex, t)
    End Function

    Public Function ucParamType(ByVal pIndex As Integer, ByRef t As ucThreadType) As Integer
        ucParamType = ucParamTypeE(pIndex, t)
    End Function

    Public Sub ucSetErrorData(ByVal errIndex As Integer, ByRef vValue As String, ByRef t As ucThreadType)
        ucSetErrorDataE(errIndex, vValue, t)
    End Sub


    ' *** String operators: =, <>, >, >=, <, <=, +
    Private Function ucEqual(ByRef t As ucThreadType) As Double
        ucEqual = t.ucProperty.RelationalTrue * System.Math.Abs(CInt(ucParamStr(1, t) = ucParamStr(2, t)))
    End Function

    Private Function ucNotEqual(ByRef t As ucThreadType) As Double
        ucNotEqual = t.ucProperty.RelationalTrue * System.Math.Abs(CInt(ucParamStr(1, t) <> ucParamStr(2, t)))
    End Function

    Private Function ucGreater(ByRef t As ucThreadType) As Double
        ucGreater = t.ucProperty.RelationalTrue * System.Math.Abs(CInt(ucParamStr(1, t) > ucParamStr(2, t)))
    End Function

    Private Function ucGreaterOrEqual(ByRef t As ucThreadType) As Double
        ucGreaterOrEqual = t.ucProperty.RelationalTrue * System.Math.Abs(CInt(ucParamStr(1, t) >= ucParamStr(2, t)))
    End Function

    Private Function ucLess(ByRef t As ucThreadType) As Double
        ucLess = t.ucProperty.RelationalTrue * System.Math.Abs(CInt(ucParamStr(1, t) < ucParamStr(2, t)))
    End Function

    Private Function ucLessOrEqual(ByRef t As ucThreadType) As Double
        ucLessOrEqual = t.ucProperty.RelationalTrue * System.Math.Abs(CInt(ucParamStr(1, t) <= ucParamStr(2, t)))
    End Function


    Public Function ucEvaluateCplx(ByVal ExpressionPtr As Integer, ByRef ucValue As ucComplexNumberType, Optional ByVal t As Integer = 0) As Double
        ucValue.Real = ucEvaluateE(ExpressionPtr)
        ucValue.Imag = ucImagPartE(ucThreadAddr(t))
        ucEvaluateCplx = ucValue.Real
    End Function

#If ucAltErrMsg = 0 Then
    Public Function ucGetErrorMessage(Optional ByVal ErrorNumber As Integer = -1, Optional ByVal t As Integer = 0) As String
        Dim ErrMsg As String

        ucGetThreadInfo(0, t0)
        If ErrorNumber = -1 Then ErrorNumber = t0.ErrorNumber

        Select Case ErrorNumber
            Case 0 ' No Error
            Case 1 : ErrMsg = ucGetErrorData(0, ucThreadAddr(t))
            Case 2 : ErrMsg = "Error #2: Syntax error"
            Case 3 : ErrMsg = "Error #3: Mismatched parenthesis"
            Case 4 : ErrMsg = "Error #4: Mismatched quotes"
            Case 5 : ErrMsg = "Error #5: Undefined variable"
            Case 6 : ErrMsg = "Error #6: Undefined function"
            Case 7 : ErrMsg = "Error #7: Incorrect argument type"
            Case 8 : ErrMsg = "Error #8: Invalid number of function arguments"
            Case 9 : ErrMsg = "Error #9: Invalid operand type"
            Case 10 : ErrMsg = "Error #10: Invalid name"
            Case 11 : ErrMsg = "Error #11: Implicit multiplication error"

            Case 20 : ErrMsg = "Error #20: Invalid floating point operation"
            Case 21 : ErrMsg = "Error #21: Denormal floating point operand"
            Case 22 : ErrMsg = "Error #22: Division by 0"
            Case 23 : ErrMsg = "Error #23: Floating point overflow"
            Case 24 : ErrMsg = "Error #24: Floating point underflow"
            Case 25 : ErrMsg = "Error #25: Inexact floating point result"
            Case 35 : ErrMsg = "Error #35: Array subscript out of range"
            Case 36 : ErrMsg = "Error #36: Stack overflow"

            Case 40 : ErrMsg = "Error #40: Cannot perform requested operation"
            Case 41 : ErrMsg = "Error #41: Definition property conflict"
            Case 42 : ErrMsg = "Error #42: Assignment to a constant not allowed"
            Case 43 : ErrMsg = "Error #43: Invalid function or operator definition"
            Case 44 : ErrMsg = "Error #44: Function or operator is locked"

            Case 60 : ErrMsg = "Error #60: Definition space is full"
            Case 61 : ErrMsg = "Error #61: Thread initialization failed"
            Case 62 : ErrMsg = "Error #62: Requires advanced edition of UCalc FMP"
            Case Else : ErrMsg = "Unknown error"
                ' // numbers up to 500 are reserved for future use by UCalc
                ' // Use Case 501 and beyond for user-defined errors
        End Select
        ucGetErrorMessage = ErrMsg
    End Function

    Public Function ucErrorMessage(Optional ByVal ErrorNumber As Integer = -1, Optional ByVal t As Integer = 0) As String
        ucErrorMessage = ucGetErrorMessage(ErrorNumber, t)
    End Function

#End If

    Public Function ucThreadAddr(ByVal t As Integer) As Integer
        If ucInitialized = False Then Call ucEvaluateInit()
        If t = 0 Then ucSetThreadData(0, t0)
        ucThreadAddr = ucThreadAddrE(t)
    End Function

    Public Sub ucEvaluateInit()
        ucInitialized = True
        ucReset()
    End Sub
End Module