//---------------------------------------------------------------------------
#include <vcl.h>
#include <objbase.h>
#pragma hdrstop

#include "DemoCPP.h"
#include "ucalc.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

long OtherProperties;
long double H, W;
void PopulateComboBoxes();
void CartesianLineTo(long double a, long double b);
long double _stdcall ucalcAverage(ucThreadType& t);
long double _stdcall ucalcSum(ucThreadType& t);
long double _stdcall ucArraySum(ucThreadType& t);
long _stdcall ErrorHandler(ucThreadType& t);

typedef void (CALLBACK* UCDELPHILIBINIT)(ucThreadType& t);
typedef void (CALLBACK* UCPBLIBINIT)(ucThreadType& t);
typedef void (CALLBACK* UCVBLIBINIT)(void);

UCDELPHILIBINIT ucDelphiLibInit;
UCPBLIBINIT ucPBLibInit;
UCVBLIBINIT ucVbLibInit;

double Values[5];

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button1Click(TObject *Sender)
{
   Edit1->Text = ucEvalStr(ComboBox1->Text.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   HINSTANCE DelphiLibDLL, VBLibDLL, PBLibDLL;

   DelphiLibDLL = LoadLibrary("ucdlplib.dll");
   VBLibDLL = LoadLibrary("ucvblibh.dll");
   PBLibDLL = LoadLibrary("ucpblib.dll");

   ucDelphiLibInit = (UCDELPHILIBINIT)GetProcAddress(DelphiLibDLL,"ucDelphiLibInit");
   ucPBLibInit = (UCPBLIBINIT)GetProcAddress(PBLibDLL,"ucPBLibInit");
   ucVbLibInit = (UCVBLIBINIT)GetProcAddress(VBLibDLL,"ucVbLibInit");

   Image1->Canvas->Rectangle(0, 0, Image1->Width, Image1->Height);
   PopulateComboBoxes();
   CoInitialize(NULL);

   ucEvalStr("Initialize the parser class");

   // Loads Visual Basic functions (from ucVBLib.DLL)
   if (MessageDlg("Would you like to load 60+ Visual Basic functions (from ucVBLib.DLL)?\n\n"
   "IMPORTANT: The VB 5 runtime, MSVBVM50.DLL, is required for this add-on.\n"
   "Also, be sure that ucVBLib.DLL was registered with REGSVR32.EXE.\n"
   "(If not, click NO to skip this add-on)\n\n"
   "Includes:\n"
   " * Financial\n"
   " * String\n"
   " * Date\n"
   " * and other kinds of functions\n\n"
   "See ucVBlib.* for the source code of this add-on."
   , mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes) ucVbLibInit();

   // Loads PowerBASIC functions (from ucPBLib.DLL)
   if (MessageDlg("Would you like to load 100+ PowerBASIC functions (from ucPBLib.DLL)?\n"
   "Includes enhanced versions of BASIC functions\n\n"
   "See ucPBlib.Bas for the source code of this add-on."
   , mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes) ucPBLibInit(t0);

   // Loads Delphi functions (From ucDlpLib.DLL)
   if (MessageDlg("Would you like to load 150+ Delphi functions (from ucDlpLib.DLL)?\n\n"
   "Includes:\n"
   " * Stats\n"
   " * Conversion\n"
   " * Business\n"
   " * and other kinds of functions\n\n"
   "See ucDlpLib.DPR for the source code of this add-on."
   , mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes) ucDelphiLibInit(t0);

   Values[0] = -70000;  // This array is used in the NPV example
   Values[1] = 22000; Values[2] = 25000;
   Values[3] = 28000; Values[4] = 31000;


   ucAttachVariable("Values(5) As Double", &Values[0]);
   ucDefineConstant("Div0 = 4");  // Div0 = ucFPU_ErrMask_ZeroDivide;
   ucDefineFunction("Average()", ucalcAverage);
   ucDefineFunction("ArraySum(Values())", ucArraySum);
   ucDefineFunction("Sum(Expr&,start,finish,step=1,var@=x)", ucalcSum);
   ucErrorHandler(ErrorHandler);

   OtherProperties = ucOverload + ucComplex + ucRecursion + ucOverwrite + ucOverride;
   t0.ucProperty.FunctionProperties = ucDynamic + OtherProperties;
}
//---------------------------------------------------------------------------

void PopulateComboBoxes()
{
   Form1->ComboBox1->Items->Add("3+4/5-8");
   Form1->ComboBox1->Items->Add("5*(((10+3)!-1) MOD 7)^2");
   Form1->ComboBox1->Items->Add("#b101.1101 + #b110.1001");
   Form1->ComboBox1->Items->Add("(3+4#i)^2");
   Form1->ComboBox1->Items->Add("Sqr(-1)");
   Form1->ComboBox1->Items->Add("\"This\" > \"That\"");
   Form1->ComboBox1->Items->Add("\"This\" < \"That\"");
   Form1->ComboBox1->Items->Add("1/0");
   Form1->ComboBox1->Items->Add("SetOrFPU(Div0, -1/0)");
   Form1->ComboBox1->Items->Add("SetXorFPU(Div0, -1/0)");
   Form1->ComboBox1->Items->Add("");
   Form1->ComboBox1->Items->Add("// -- sum() and average() are defined in");
   Form1->ComboBox1->Items->Add("// -- the source code.  See DEMOCPP.CPP.");
   Form1->ComboBox1->Items->Add("sum(x^2+5,1,10)");
   Form1->ComboBox1->Items->Add("sum(2y-3,1,10,,y)");
   Form1->ComboBox1->Items->Add("sum(x+10,2,5,.5)");
   Form1->ComboBox1->Items->Add("average(5,min(2,5),8)-max(2,5,9,1)");
   Form1->ComboBox1->Items->Add("");
   Form1->ComboBox1->Items->Add("// -- Make sure ucVBlib.DLL or ucPBLib.DLL");
   Form1->ComboBox1->Items->Add("// -- was loaded to run the following examples");
   Form1->ComboBox1->Items->Add("Len(\"String Length\")");
   Form1->ComboBox1->Items->Add("Left$(\"Hello there\", 6) + \"World\"");
   Form1->ComboBox1->Items->Add("InStr(\"This is my string\",\"my\")");
   Form1->ComboBox1->Items->Add("InStr(10,\"This is my string\",\"i\")");
   Form1->ComboBox1->Items->Add("");
   Form1->ComboBox1->Items->Add("// -- A few examples of special PowerBASIC");
   Form1->ComboBox1->Items->Add("// -- functions defined in ucPBLib.DLL");
   Form1->ComboBox1->Items->Add("Asc(\"Hello World\", 7)");
   Form1->ComboBox1->Items->Add("Chr$(72,101,108,108,111)");
   Form1->ComboBox1->Items->Add("Chr$(72,101,108,108,111, 'world. ', 70 to 90)");
   Form1->ComboBox1->Items->Add("Remove$(\"Hello, World!\", Any \",!\")");
   Form1->ComboBox1->Items->Add("");
   Form1->ComboBox1->Items->Add("// -- A few examples of special Visual Basic");
   Form1->ComboBox1->Items->Add("// -- routines defined in ucVBLib.DLL");
   Form1->ComboBox1->Items->Add("\"Cooool\" Like \"C*l\"");
   Form1->ComboBox1->Items->Add("DateAdd(\"d\", 30, Now)");
   Form1->ComboBox1->Items->Add("NPV(.0625, Values())");
   Form1->ComboBox1->Items->Add("");
   Form1->ComboBox1->Items->Add("// -- A few examples of special Delphi");
   Form1->ComboBox1->Items->Add("// -- routines defined in ucDLPLib.DLL");
   Form1->ComboBox1->Items->Add("// -- Be sure to define MyString first");
   Form1->ComboBox1->Items->Add("StdDev(Values())");
   Form1->ComboBox1->Items->Add("Mean(Values())");
   Form1->ComboBox1->Items->Add("MyString[2]");

   Form1->ComboBox2->Items->Add("MyVariable = 100");
   Form1->ComboBox2->Items->Add("MyString = 'This is my string' ");
   Form1->ComboBox2->Items->Add("i = #i");
   Form1->ComboBox2->Items->Add("MyArray() = {57, 23, 98, 17, 46}");
   Form1->ComboBox2->Items->Add("");
   Form1->ComboBox2->Items->Add("// -- Note: The other array named Values()");
   Form1->ComboBox2->Items->Add("// -- is defined at the source code level");
   Form1->ComboBox2->Items->Add("// -- and that one is attached to an array");
   Form1->ComboBox2->Items->Add("// -- of the host program. See DemoPB.BAS");

   Form1->ComboBox3->Items->Add("fract(x)=abs(abs(x)-int(abs(x)))");
   Form1->ComboBox3->Items->Add("concat$(txtA$,txtB$) = txtA+txtB");
   Form1->ComboBox3->Items->Add("TriangleWave(x) = (8/pi^2)*Sum((-1)^((n-1)/2)/(n^2)*Sin(n*x), 1, 100, 2, n)");
   Form1->ComboBox3->Items->Add("");
   Form1->ComboBox3->Items->Add("// -- Overloading a function with 2 definitions");
   Form1->ComboBox3->Items->Add("area(length,width)=length*width");
   Form1->ComboBox3->Items->Add("area(side) = side^2");
   Form1->ComboBox3->Items->Add("");
   Form1->ComboBox3->Items->Add("// -- Function with optional argument");
   Form1->ComboBox3->Items->Add("volume(r,h=0)=iif(h=0,pi*r^3*4/3,pi*r^2*h/3)");
   Form1->ComboBox3->Items->Add("");
   Form1->ComboBox3->Items->Add("// -- Recursive function definition");
   Form1->ComboBox3->Items->Add("Factorial(x) = iif(x=0, 1, x*Factorial(x-1))");
   Form1->ComboBox3->Items->Add("");
   Form1->ComboBox3->Items->Add("// -- Operator definitions");
   Form1->ComboBox3->Items->Add("Note: shl may have already been defined by add-on");
   Form1->ComboBox3->Items->Add("shl[x,y]      =      x * 2^y");
   Form1->ComboBox3->Items->Add("![x]            =      x == 0");
   Form1->ComboBox3->Items->Add("!=[x,y]       =      x <> y");
   Form1->ComboBox3->Items->Add("");
   Form1->ComboBox3->Items->Add("// -- Complex # function definition");
   Form1->ComboBox3->Items->Add("cnj(x)= x.Real + (-x.Imag)*#i");

   Form1->ComboBox4->Items->Add("fract(150/17)+MyVariable");
   Form1->ComboBox4->Items->Add("area(4)+area(5,10)+max(5,9,3)");
   Form1->ComboBox4->Items->Add("volume(4)+volume(4,5)");
   Form1->ComboBox4->Items->Add("Bin$(#b01101 shl 1)");
   Form1->ComboBox4->Items->Add("Len(MyString)");
   Form1->ComboBox4->Items->Add("InStr(MyString, 'is')");
   Form1->ComboBox4->Items->Add("2*cnj(3+4#i)");
   Form1->ComboBox4->Items->Add("ArraySum(MyArray())");
   Form1->ComboBox4->Items->Add("Sum(MyArray(x),1,3)");
   Form1->ComboBox4->Items->Add("");
   Form1->ComboBox4->Items->Add("// -- Note: Some functions such");
   Form1->ComboBox4->Items->Add("// -- as Sum(), ArraySum() and others");
   Form1->ComboBox4->Items->Add("// -- are defined at the source code level.");
   Form1->ComboBox4->Items->Add("// -- Other functions such as Len() and Bin$()");
   Form1->ComboBox4->Items->Add("// -- were defined in one of the add-on DLLs.");
}

long double _stdcall ucalcSum(ucThreadType& t)
{
   DWORD ExpressionPtr;
   long VariableHandle;
   long double x, sstep, Start, Finish, Total;

   ExpressionPtr  = ucParam(1, t);
   Start          = ucParam(2, t);
   Finish         = ucParam(3, t);
   sstep          = ucParam(4, t);
   VariableHandle = ucParam(5, t);

   Total = 0;
   x = Start;

   while (x <= Finish)
   {
      ucSetVariableValue(VariableHandle, x);
      Total = Total + ucEvaluate(ExpressionPtr);
      x = x + sstep;
   }

   return Total;
}

long double _stdcall ucArraySum(ucThreadType& t)
{
   double *ValueArrayDbl;
   long double *ValueArrayExt;
   unsigned long BaseAddress;
   long DataType, ArrayHandle, UpperBound, x;
   double Total = 0;

   ArrayHandle = ucParam(1, t);
   BaseAddress = ucArrayInfo(ArrayHandle, ucArray_DataAddress);
   UpperBound  = ucArrayInfo(ArrayHandle, ucArray_ElementCount)-1;
   DataType    = ucArrayInfo(ArrayHandle, ucArray_DataType);

   ValueArrayDbl = (double *) BaseAddress;
   ValueArrayExt = (long double *) BaseAddress;

   for(x = 0; x <= UpperBound; x++)
   {
      if (DataType == ucType_FloatDouble) Total = Total + ValueArrayDbl[x];
      if (DataType == ucType_FloatExtended) Total = Total + ValueArrayExt[x];
   }

   return Total;
}

long double _stdcall ucalcAverage(ucThreadType& t)
{
   long x;
   long double Total = 0;

   for(x = 1; x <= t.ParamCount; x++)
      Total = Total + ucParam(x, t);

   return Total / t.ParamCount;
}

long _stdcall ErrorHandler(ucThreadType& t)
{
   char ErrorMessage[80];

   if (t.Context & ucContext_ucParseOrucEval) {
      strcpy(ErrorMessage, ucErrorMessage(t.ErrorNumber, t.ucThread));
      strcat(ErrorMessage, "\nData: ");
      if (ucErrorData(0, t.ucThread) != NULL)
         strcat(ErrorMessage, ucErrorData(0, t.ucThread));
      MessageDlg(ErrorMessage, mtConfirmation, TMsgDlgButtons()
   << mbOK, 0);
   }
   return 0;
}

void CartesianLineTo(long double a, long double b)
{
   int x, y;

   x = W * (a + 10) / 20;
   y = H * (2 - b) / 4;
   Form1->Image1->Canvas->LineTo(x, y);
}

void __fastcall TForm1::Button5Click(TObject *Sender)
{
   Edit3->Text = ucEvalStr(ComboBox4->Text.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   ucDefineVariable(ComboBox2->Text.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   ucDefineFunction(ComboBox3->Text.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
   long double x = -10;
   long UserEq;

   Image1->Canvas->FillRect(ClientRect);
   UserEq = ucParse(Edit7->Text.c_str(), "x");
   ucAttachVariable("x", &x, UserEq);

   W = Image1->Width;
   H = Image1->Height;

   Image1->Canvas->MoveTo(0, H/2);

   while (x <= 10)
   {
      CartesianLineTo(x, ucEvaluate(UserEq));
      x = x + 0.125;
   }

   ucReleaseExprPtr(UserEq);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
   long double x = 1, Sum = 0;
   long UserEq, finalValue;
   TDateTime TimerStart, Elapsed;
   AnsiString HourStr, MSecStr;
   Word Hour, Min, Sec, MSec;

   Edit10->Text = "";
   Edit10->Refresh();

   TimerStart = Time();
   finalValue = StrToFloat(Edit9->Text);

   UserEq = ucParse(Edit8->Text.c_str(), "x");
   ucAttachVariable("x", &x, UserEq);

   while (x <= finalValue)
   {
      Sum = Sum + ucEvaluate(UserEq);
      x++;
   }

   Elapsed = Time() - TimerStart;
   DecodeTime(Elapsed, Hour, Min, Sec, MSec);
   HourStr = IntToStr(Sec);
   MSecStr = IntToStr(MSec);    

   Edit10->Text = HourStr + "." + MSecStr + " sec / " + FormatFloat("#", Sum);
   ucReleaseExprPtr(UserEq);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
   if (CheckBox1->Checked == True)
      t0.ucProperty.FunctionProperties = ucDynamic + OtherProperties;
   else
      t0.ucProperty.FunctionProperties = ucInline + OtherProperties;
}
//---------------------------------------------------------------------------

