unit DemoDlp;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   StdCtrls, UCalc, ExtCtrls, Math, ucVBLib_TLB;

type
   TForm1 = class(TForm)
      Edit1: TEdit;
      Button1: TButton;
      Image1: TImage;
      Label3: TLabel;
      Button2: TButton;
      Label4: TLabel;
      Edit2: TEdit;
      Edit7: TEdit;
      Button3: TButton;
      Button4: TButton;
      Button5: TButton;
      Button6: TButton;
      Label13: TLabel;
      Edit8: TEdit;
      Edit9: TEdit;
      Edit10: TEdit;
      Label14: TLabel;
      Label15: TLabel;
      Label16: TLabel;
      Edit11: TEdit;
      Combo1: TComboBox;
      Combo2: TComboBox;
      Combo3: TComboBox;
      Combo4: TComboBox;
      Label1: TLabel;
      Label2: TLabel;
      Label5: TLabel;
      Label6: TLabel;
      Label7: TLabel;
      Label9: TLabel;
      Label8: TLabel;
      CheckBox1: TCheckBox;
      Label10: TLabel;
      procedure Button1Click(Sender: TObject);
      procedure Button2Click(Sender: TObject);
      procedure Button3Click(Sender: TObject);
      procedure Button4Click(Sender: TObject);
      procedure Button5Click(Sender: TObject);
      procedure Button6Click(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure Combo1KeyPress(Sender: TObject; var Key: Char);
      procedure CheckBox1Click(Sender: TObject);
   private
      { Private declarations }
   public
      { Public declarations }
   end;

var
   Form1: TForm1;
   H, W: Variant; { Image1 Height and Width }
   Values: array[0..5] of Double;
   OtherProperties: Longint;

   t: FastMath;
   vbLib: _ucVbLibrary;
const
   CRLF = #13 + #10;

procedure ucDelphiLibInit(var t: ucThreadType); stdcall; external 'ucdlplib.dll';
procedure ucPBLibInit(var t: ucThreadType); stdcall; external 'ucpblib.dll';

implementation

{$R *.DFM}

function ucArraySum(var t: ucThreadType): Extended; stdcall;
var
   ArrayAddress: Pointer;
   UpperBound, x, ArrayHandle, DataSize: Longint;
   Total: Double;
   ArrayData: array of Double;
begin
   ArrayHandle  := Trunc(ucParam(1, t));
   ArrayAddress := Pointer(ucArrayInfo(ArrayHandle, ucArray_DataAddress));
   UpperBound   := ucArrayInfo(ArrayHandle, ucArray_ElementCount)-1;
   DataSize     := ucArrayInfo(ArrayHandle, ucArray_ElementSize);
   Total        := 0;

   SetLength(ArrayData, UpperBound+1);
   CopyMemory(ArrayData, ArrayAddress, DataSize*Length(ArrayData));

   for x := 0 to UpperBound
   do Total := Total + ArrayData[x];

   ucArraySum := Total;
end;

function ucalcSum(var t: ucThreadType): Extended; stdcall;
var
  ExpressionPtr: Pointer;
  VariableHandle: Longint;
  x, sstep, Start, Finish, Total: Extended;
begin
  ExpressionPtr  := Ptr(Trunc(ucParam(1, t)));
  Start          := ucParam(2, t);
  Finish         := ucParam(3, t);
  sstep          := ucParam(4, t);
  VariableHandle := Trunc(ucParam(5, t));

  Total := 0;
  x := Start;

  while x <= Finish do
  begin
    ucSetVariableValue(VariableHandle, x);
    Total := Total + ucEvaluate(ExpressionPtr);
    x := x + sstep;
  end;

  ucalcSum := Total;
end;

function ucalcAverage(var t: ucThreadType): Extended; stdcall;
var
  x: Longint;
  Total: Extended;
begin
  Total := 0;
  for x := 1 to t.ParamCount do Total := Total + ucParam(x, t);
  ucalcAverage := Total / t.ParamCount;
end;

function ucNPV(var t: ucThreadType): Extended; stdcall;
var
   Rate: Extended;
   ArrayAddress: Pointer;
   ArrayHandle, UpperBound, DataSize: Longint;
   CashFlows: array of Double;
begin
   Rate         := ucParam(1, t);
   ArrayHandle  := Trunc(ucParam(2, t));
   ArrayAddress := Pointer(ucArrayInfo(ArrayHandle, ucArray_DataAddress));
   UpperBound   := ucArrayInfo(ArrayHandle, ucArray_ElementCount);
   DataSize     := ucArrayInfo(ArrayHandle, ucArray_ElementSize);

   SetLength(CashFlows, UpperBound);
   CopyMemory(CashFlows, ArrayAddress, DataSize*Length(CashFlows));

   ucNPV := NetPresentValue(Rate, CashFlows, TPaymentTime(0));
end;

function ErrorHandler(var t: ucThreadType): Longint; stdcall;
var
   ErrorMessage: String;
begin
  ErrorMessage := ucErrorMessage(t.ErrorNumber, t.ucThread);
  if (t.Context and ucContext_ucParseOrucEval) <> 0
  then MessageDlg(ErrorMessage+#13#10+'Data: '+ucErrorData(0, t.ucThread), mtWarning, [mbOk], 0);
end;

procedure CartesianLineTo(a: Variant; b: Variant);
var
  x, y: Integer;
begin
  x := W * (a + 10) / 20;
  y := H * (2 - b) / 4;
  Form1.Image1.Canvas.LineTo(x, y);
end;

procedure PopulateComboBoxes;
begin
   with Form1.Combo1.Items do
   begin
      Add('3+4/5-8');
      Add('5*(((10+3)!-1) MOD 7)^2');
      Add('#b101.1101 + #b110.1001');
      Add('NetPV(.0625, Values())');
      Add('(3+4#i)^2');
      Add('Sqr(-1)');
      Add('''This'' > ''That''');
      Add('''This'' < ''That''');
      Add('1/0');
      Add('SetOrFPU(Div0, -1/0)');
      Add('SetXorFPU(Div0, -1/0)');
      Add('');
      Add('// -- sum() and average() are defined in');
      Add('// -- the source code.  See DEMODLP.PAS.');
      Add('sum(x^2+5,1,10)');
      Add('sum(2y-3,1,10,,y)');
      Add('sum(x+10,2,5,.5)');
      Add('average(5,min(2,5),8)-max(2,5,9,1)');
      Add('');
      Add('// -- Make sure ucVBlib.DLL or ucPBLib.DLL');
      Add('// -- was loaded to run the following examples');
      Add('Len(''String Length'')');
      Add('Left(''Hello there'', 6) + ''World''');
      Add('InStr(''This is my string'',''my'')');
      Add('InStr(10,''This is my string'',''i'')');
      Add('');
      Add('// -- A few examples of special PowerBASIC');
      Add('// -- functions defined in ucPBLib.DLL');
      Add('Asc("Hello World", 7)');
      Add('Chr$(72,101,108,108,111)');
      Add('Chr$(72,101,108,108,111, "world. ", 70 to 90)');
      Add('Remove$("Hello, World!", Any ",!")');
      Add('');
      Add('// -- A few examples of special Visual Basic');
      Add('// -- routines defined in ucVBLib.DLL');
      Add('"Cooool" Like "C*l"');
      Add('DateAdd("d", 30, Now)');
      Add('NPV(.0625, Values())');
      Add('');
      Add('// -- A few examples of special Delphi');
      Add('// -- routines defined in ucDLPLib.DLL');
      Add('// -- Be sure to define MyString first');
      Add('StdDev(Values())');
      Add('Mean(Values())');
      Add('MyString[2]');
   end;

   with Form1.Combo2.Items do
   begin
      Add('MyVariable = 100');
      Add('MyString = ''This is my string'' ');
      Add('i = #i');
      Add('MyArray(): Double = {57, 23, 98, 17, 46}');
      Add('');
      Add('// -- Note: The other array named Values()');
      Add('// -- is defined at the source code level');
      Add('// -- and that one is attached to an array');
      Add('// -- of the host program. See DemoPB.BAS');
   end;

   with Form1.Combo3.Items do
   begin
      Add('fract(x)=abs(abs(x)-int(abs(x)))');
      Add('concat$(txtA$,txtB$) = txtA+txtB');
      Add('TriangleWave(x) = (8/pi^2)*Sum((-1)^((n-1)/2)/(n^2)*Sin(n*x), 1, 100, 2, n)');
      Add('');
      Add('// -- Overloading a function with 2 definitions');
      Add('area(length,width)=length*width');
      Add('area(side) = side^2');
      Add('');
      Add('// -- Function with optional argument');
      Add('volume(r,h=0)=iif(h=0,pi*r^3*4/3,pi*r^2*h/3)');
      Add('');
      Add('// -- Recursive function definition');
      Add('Factorial(x) = iif(x=0, 1, x*Factorial(x-1))');
      Add('');
      Add('// -- Operator definitions');
      Add('Note: shl may have already been defined by add-on');
      Add('shl[x,y]      =      x * 2^y');
      Add('![x]            =      x == 0');
      Add('!=[x,y]       =      x <> y');
      Add('');
      Add('// -- Complex # function definition');
      Add('cnj(x)= x.Real + (-x.Imag)*#i');
   end;

   with Form1.Combo4.Items do
   begin
      Add('// -- To run these examples, first');
      Add('// -- define the functions and variables');
      Add('// -- in the above combo boxes.');
      Add('fract(150/17)+MyVariable');
      Add('area(4)+area(5,10)+max(5,9,3)');
      Add('volume(4)+volume(4,5)');
      Add('Bin$(#b01101 shl 1)');
      Add('Length(MyString)');
      Add('InStr(MyString, "is")');
      Add('2*cnj(3+4#i)');
      Add('ArraySum(MyArray())');
      Add('Sum(MyArray(x),1,3)');
      Add('');
      Add('// -- Note: Some functions such');
      Add('// -- as Sum(), ArraySum() and others');
      Add('// -- are defined at the source code level.');
      Add('// -- Other functions such as Len() and Bin$()');
      Add('// -- were defined in one of the add-on DLLs.');
   end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Edit1.Text := ucEvalStr(Combo1.Text);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  x: Extended;
  UserEq: Pointer;
begin
  Image1.Canvas.FillRect(ClientRect);
  UserEq := ucParse(Edit7.Text, 'x');
  ucAttachVariable('x', @x, UserEq);

  W := Image1.Width;
  H := Image1.Height;
  x := -10;

  Image1.Canvas.MoveTo(0, H/2);

  while x <= 10 do
  begin try
    CartesianLineTo(x, ucEvaluate(UserEq));
  except end;
    x := x + 0.125;
  end;

  ucReleaseExprPtr(UserEq);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ucDefineVariable(Combo2.Text);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  ucDefineFunction(Combo3.Text);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Edit2.Text := ucEvalStr(Combo4.Text);
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  x, Sum: Extended;
  Code: Integer;
  UserEq: Pointer;
  finalValue: Longint;
  TimerStart, Elapsed: TDateTime;
  HourStr, MSecStr: string;
  Hour, Min, Sec, MSec: Word;
begin
  Edit10.Text := '';
  Edit10.Refresh;

  x := 1;
  Sum := 0;
  TimerStart := Time;
  val(Edit9.Text, finalValue, Code);

  UserEq := ucParse(Edit8.Text, 'x');
  ucAttachVariable('x', @x, UserEq);

  while x <= finalValue do
  begin
    Sum := Sum + ucEvaluate(UserEq);
    x := x + 1;
  end;

  Elapsed := Time - TimerStart;
  DecodeTime(Elapsed, Hour, Min, Sec, MSec);
  Str(Sec, HourStr);
  Str(MSec, MSecStr);

  Edit10.Text := HourStr + '.' + MSecStr + ' sec / ' + FormatFloat('#', Sum);
  ucReleaseExprPtr(UserEq);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  LoadDLLQuestion: string;
begin
  Image1.Canvas.Rectangle(0, 0, Image1.Width, Image1.Height);
  PopulateComboBoxes;

  Values[0] := -70000;  // This array is used in the NetPV example
  Values[1] := 22000; Values[2] := 25000;
  Values[3] := 28000; Values[4] := 31000;

  // Loads Visual Basic functions (from ucVBLib.DLL)
  LoadDLLQuestion :=
   'Would you like to load 60+ Visual Basic functions (from ucVBLib.DLL)?'+CRLF+CRLF
  +'IMPORTANT: The VB 5 runtime, MSVBVM50.DLL, is required for this add-on.'+CRLF
  +'Also, be sure that ucVBLib.DLL was registered with REGSVR32.EXE.'+CRLF
  +'(If not, click NO to skip this add-on)'+CRLF+CRLF;
  LoadDLLQuestion := LoadDLLQuestion
  +'Includes:'+CRLF
  +'* Financial'+CRLF
  +'* String'+CRLF
  +'* Date'+CRLF
  +'* and other kinds of functions'+CRLF+CRLF;
  LoadDLLQuestion := LoadDLLQuestion
  +'See ucVBlib.* for the source code of this add-on.';
  if MessageDlg(LoadDLLQuestion, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
     vbLib := CoucVbLibrary.Create;
     vbLib.ucVbLibInit;
  end;

  // Loads Delphi functions (From ucDlpLib.DLL)
  LoadDLLQuestion :=
   'Would you like to load 150+ Delphi functions (from ucDlpLib.DLL)?'+CRLF+CRLF
  +'Includes:'+CRLF
  +'* Stats'+CRLF
  +'* Conversion'+CRLF
  +'* Business'+CRLF
  +'* and other kinds of functions'+CRLF+CRLF
  +'See ucDlpLib.DPR for the source code of this add-on.';
  if MessageDlg(LoadDLLQuestion, mtConfirmation, [mbYes, mbNo], 0) = mrYes then ucDelphiLibInit(t0);

  // Loads PowerBASIC functions (from ucPBLib.DLL)
  LoadDLLQuestion :=
   'Would you like to load 100+ PowerBASIC functions (from ucPBLib.DLL)?'+CRLF+CRLF
  +'Includes enhanced versions of functions found in VB, plus a number of others'+CRLF+CRLF
  +'See ucPBlib.Bas for the source code of this add-on.';
  if MessageDlg(LoadDLLQuestion, mtConfirmation, [mbYes, mbNo], 0) = mrYes then ucPBLibInit(t0);


  ucAttachVariable('Values(5) As Double', @Values[0]);
  ucDefineConstant('Div0 = ' + FloatToStr(ucFPU_ErrMask_ZeroDivide));
  ucDefineFunction('NetPV(rate, values())', @ucNPV);
  ucDefineFunction('Average()', @ucalcAverage);
  ucDefineFunction('Sum(Expr&,start,finish,step=1,var@=x)', @ucalcSum);
  ucDefineFunction('ArraySum(Values())', @ucArraySum);

  ucErrorHandler(@ErrorHandler);
  OtherProperties := ucOverload + ucComplex + ucRecursion + ucOverwrite + ucOverride;
  t0.ucProperty.FunctionProperties := ucDynamic + OtherProperties;
end;

procedure TForm1.Combo1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then Edit1.Text := ucEvalStr(Combo1.Text);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked = True
  then t0.ucProperty.FunctionProperties := ucDynamic + OtherProperties
  else t0.ucProperty.FunctionProperties := ucInline  + OtherProperties;
end;

end.
