Attribute VB_Name = "Module1"
Option Explicit

Declare Sub ucPBLibInit Lib "ucpblib.dll" (t As ucThreadType)
Declare Sub ucDelphiLibInit Lib "ucdlplib.dll" (t As ucThreadType)
' for ucVBLib.DLL, use \WINDOWS\SYSTEM\REGSVR32 ucVBLib.DLL

Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, source As Any, ByVal numBytes&)

Function ErrorHandler(t As ucThreadType) As Long
   If (t.Context And ucContext_ucParseOrucEval) Then
      MsgBox ucErrorMessage(t.ErrorNumber, t.ucThread) _
            + vbCrLf + "Data: " + ucErrorData(0, t.ucThread), vbExclamation
   End If
End Function

Function ucalcAverage(t As ucThreadType) As Double
   Dim x As Long, Total As Double

   For x = 1 To t.ParamCount
      Total = Total + ucParam(x, t)
   Next

   ucalcAverage = Total / t.ParamCount
End Function

Function ucalcSum(t As ucThreadType) As Double
   Dim ExpressionPtr As Long, VariableHandle As Long, x As Double
   Dim sstep As Double, Start As Double, Finish As Double, Total As Double
    
   ExpressionPtr = ucParam(1, t)
   Start = ucParam(2, t)
   Finish = ucParam(3, t)
   sstep = ucParam(4, t)
   VariableHandle = ucParam(5, t)
  
   For x = Start To Finish Step sstep
      ucSetVariableValue VariableHandle, x
      Total = Total + ucEvaluate(ExpressionPtr)
   Next

   ucalcSum = Total
End Function

Function ucArraySum(t As ucThreadType) As Double
   Dim BaseAddress As Long, UpperBound As Long, x As Long
   Dim Total As Double, ArrayHandle As Long, DataSize As Long

   ArrayHandle = ucParam(1, t)
   BaseAddress = ucArrayInfo(ArrayHandle, ucArray_DataAddress)
   UpperBound = ucArrayInfo(ArrayHandle, ucArray_ElementCount) - 1
   DataSize = ucArrayInfo(ArrayHandle, ucArray_ElementSize)
    
   ReDim ValueArray(UpperBound) As Double
   CopyMemory ValueArray(0), ByVal BaseAddress, (UpperBound + 1) * DataSize

   For x = 0 To UpperBound
      Total = Total + ValueArray(x)
   Next

   ucArraySum = Total
End Function

Function ucNPV(t As ucThreadType) As Double
   Dim BaseAddress As Long, UpperBound As Long, Rate As Double
   Dim ArrayHandle As Long, DataSize As Long
   
   Rate = ucParam(1, t)
   ArrayHandle = ucParam(2, t)
   BaseAddress = ucArrayInfo(ArrayHandle, ucArray_DataAddress)
   UpperBound = ucArrayInfo(ArrayHandle, ucArray_ElementCount) - 1
   DataSize = ucArrayInfo(ArrayHandle, ucArray_ElementSize)

   ReDim ValueArray(UpperBound) As Double
   CopyMemory ValueArray(0), ByVal BaseAddress, (UpperBound + 1) * DataSize

   ucNPV = NPV(Rate, ValueArray())
End Function
