#Debug Error On
' +++ Need to make and test console demos for VC++ and BCB (and Delphi and VB)
' +++ Test with MkErr
' +++ Test 1/2q.  Priority level changed.  See Notation in help file
' +++ Test x---5 varying case from Precedence in help file
' +++ This doesn't work yet:  ucDefineFunction "cat(a As String, b As String) As String = a + b"
' +++ Will user names with an imbedded ".E." cause ambiguity?
%ExternalTest = 1
#Include "ucalcpb.bas"
#Include "ucvblib.inc"

DefLng a-z

Declare Sub ucPBLibInit     Lib "ucpblib.dll"  Alias "ucPBLibInit" (t As ucThreadType)
Declare Sub ucDelphiLibInit Lib "ucdlplib.dll" Alias "ucDelphiLibInit" (t As ucThreadType)

Global DifferenceCount As Long
Global Expression$, LocalVarList$, PrintStrng$
Global SpecialErrorTest As Long

%SemiColon = 1

Union LeftOp
   LeftLng As Long Ptr
   LeftSng As Single Ptr
   LeftExt As Ext Ptr
End Union

Union RightOp
   RightLng As Long Ptr
   RightSng As Single Ptr
   RightExt As Ext Ptr
End Union

Union Result
   ResultLng As Long Ptr
   ResultSng As Single Ptr
   ResultExt As Ext Ptr
End Union

Type ExpressionType
   LeftOp
   RightOp
   Result
End Type

Sub PrintErr(Text$)
   #Debug Print Text$
   Print #3, Text$
   If DifferenceCount < 6 Then Print Text$
End Sub

Sub PrintOut(Optional ByVal NewText$, Optional ByVal SemiColon)
   Static OldText$, TmpText$

   If Len(OldText$) = 0 Then Line Input #2, OldText$
   NewText$ = TmpText$ + NewText$

   If SemiColon Then
      TmpText$ = NewText$
      Exit Sub
   Else
      Print #1, NewText$
   End If

   If NewText$ = OldText$ Then
      #Debug Print NewText$
   Else
      Incr DifferenceCount
      PrintErr "------ Difference #" + Trim$(Str$(DifferenceCount)) + "-------"
      PrintErr "Expr: " + Expression$
      PrintErr "Old: "  + OldText$
      PrintErr "New: "  + NewText$
      PrintErr " "
   End If

   OldText$ = ""
   TmpText$ = ""
End Sub

Sub PrintAndEval(Expr$)
   Expression$ = Expr$
   Answer$ = ucEvalStr(Expr$)
   If t0.ErrorNumber = %ucErr_None Then PrintOut Answer$
End Sub

Function MyErrorHandler(t As ucThreadType) As Long
   If SpecialErrorTest Then
      ucReturn ucParam(1, t) * 100, t
      ' +++ How about for string?
   Else
      Text$ = ucErrorMessage(t.ErrorNumber, t.ucThread)
      Text$ = Text$ + String$(50-Len(Text$), " ")
      Text$ = Text$ + "Data: " + ucErrorData$(%ucAllErrorData, t.ucThread)
      PrintOut Text$
   End If

   ' +++ Allow error handler to be inserted at a given level.
   ' +++ Have an error history with a ucErrorNum(x) for each ucErrorData$()
End Function

Function ContextErrorHandler(t As ucThreadType) As Long
   For x = 1 To DataCount
      If Bit(t.Context, x-1) Then Context$ = Context$ + $Tab + Read$(x)
   Next

   PrintOut Bin$(t.Context, x) + Context$
   PrintOut

   Data "Eval", "EvalStr", "EvaluateStr", "Parse", "ParseOrEval", "DefFunc"
   Data "DefVar", "Reset", "MultiL", "MultiLFirst", "MultiLLast"
End Function

Function ucalcAverage(t As ucThreadType) As Ext
   Dim x As Long, Total As Ext

   For x = 1 To t.ParamCount
      Total = Total + ucParam(x, t)
   Next

   ucalcAverage = Total / t.ParamCount
End Function

Function ucalcSum(t As ucThreadType) As Ext
    Dim ExpressionPtr As Dword, VarHandle As Long, Counter As Ext
    Dim Increment As Ext, Start As Ext, Finish As Ext, Total As Ext

    ExpressionPtr = ucParam(1, t)
    Start         = ucParam(2, t)
    Finish        = ucParam(3, t)
    Increment     = ucParam(4, t)
    VarHandle      = ucParam(5, t)

    For Counter = Start To Finish Step Increment
       ucSetVariableValue VarHandle, Counter
       Total = Total + ucEvaluate(ExpressionPtr)
    Next

    ucalcSum = Total
End Function

Function ucArraySum(t As ucThreadType) As Ext
   Dim DataAddress As Dword, UpperBound As Long
   Dim ArrayHandle As Long, x As Long, Total As Ext
   Dim DataType As Long

   ArrayHandle  = ucParam(1, t)
   DataAddress = ucArrayInfo(ArrayHandle, %ucArray_DataAddress)
   UpperBound  = ucArrayInfo(ArrayHandle, %ucArray_ElementCount)-1
   DataType    = ucArrayInfo(ArrayHandle, %ucArray_DataType)

   ReDim ValueArrayInt(UpperBound) As Long   At DataAddress
   ReDim ValueArrayDbl(UpperBound) As Double At DataAddress
   ReDim ValueArrayExt(UpperBound) As Ext    At DataAddress

   For x = 0 To UpperBound
      If DataType = %ucType_Long     Then Total = Total + ValueArrayInt(x)
      If DataType = %ucType_Double   Then Total = Total + ValueArrayDbl(x)
      If DataType = %ucType_Extended Then Total = Total + ValueArrayExt(x)
   Next

   ucArraySum = Total
End Function

Function ucTestA(t As ucThreadType) As Ext
   ucTestA = ucParam(1, t) * 10
End Function

Function dTestA(t As ucThreadType) As Ext
   dTestA = ucParam(1, t) * 10
   ucReturnCplx ucParamCplx(1, t) * 10, t
End Function

Function ChangeEqual(t As ucThreadType) As Long
   If ucTreeNodeProperty(%ucTreeIndex, t) = 1 _
   And ucTreeGetOp(t) = "=" Then
      ucSetExpr "SETVAR(" + ucTreeGetParam(1, t) + "," + ucTreeGetParam(2, t) + ")", t
   End If
End Function

Function DetachLocalVars(t As ucThreadType) As Long
   If ucTreeNodeProperty(%ucTreeIndex, t) = 1 Then
      ucDetachSymbol LocalVarList$, t
      LocalVarList$ = ""
   End If
End Function

Function C_Hex(t As ucThreadType) As Long
   If ucTreeNodeProperty(%ucErrorNumber, t) = %ucErr_ImplicitMult _
   And Left$(ucGetExpr(t), 2) = "0X" Then
      ucSetExpr "#H" + Mid$(ucGetExpr(t), 3), t
   End If
End Function

Function uc_TreeParseDown(t As ucThreadType) As Long
   If ucElementCategory(t) = %ucIsFunction Then
      FunctionName$ = ucTreeGetOp(t)

      If FunctionName$ = "LOCAL" Or FunctionName$ = "STATIC" Then
         ucDefineVariable ucTreeGetParam(1, t), %ucLocal, t.ucThread
         LocalVarList$ = LocalVarList$ + ucTreeGetParam(1, t) + ","
      End If
   ElseIf ucElementCategory(t) = %ucIsUnaryPreOperator _
   And ucTreeGetOp(t) = "PRINT" Then
      ' +++ Revisit and refine PRINT routine later
      Expr$ = ucGetExpr(t)

      If Right$(Expr$, 1) <> "," And Right$(Expr$, 1) <> ";" _
      Then Expr$ = Expr$ + ":PRINTLINE()"

      Expr$ = "PRNT " + Mid$(Expr$, 7)
      ' +++ Use SpecialReplace instead
      Replace ";" With ":PRNT " In Expr$
      Replace "," With ":PRINTCOLUMN():PRNT " In Expr$

      If Right$(Expr$, 5) = "PRNT " Then Expr$ = Expr$ + "'':PRINTSEMI()"

      ucSetExpr Expr$, t
   End If
End Function

' Constant folding for "+" operation:  Ex: "5+x+4" returns "x+9"
Function SymbolicOutput(t As ucThreadType) As Long
   Static SkipSymbolic As Long

   If SkipSymbolic Then Exit Function
   SkipSymbolic = %ucTrue

   If ucTreeNodeProperty(%ucTreeIndex, t) = 1 _
   And ucTreeNodeProperty(%ucIsString, t) = %ucFalse _
   And ucTreeParamProperty(2, %ucIsConstant, t) = %ucFalse Then
      ' Final output
      ucSetExpr Chr$(39)+Remove$(ucGetExpr(t), " ")+Chr$(39), t
   ElseIf ucElementCategory(t) = %ucIsBinaryOperator Then
      If ucTreeParamProperty(2, %ucIsConstant, t) = %ucTrue Then
         If ucTreeParamProperty(1, %ucIsConstant, t) = %ucTrue Then
            ucSetExpr ucEvalStr(ucGetExpr(t), t.ucThread), t
         Else ' Swap operands so constants are together.  5+x+4 -->  4+5+x
            OperandA$ = ucTreeGetParam(1, t)
            OperandB$ = ucTreeGetParam(2, t)
            ucTreeSetParam 1, OperandB$, t
            ucTreeSetParam 2, OperandA$, t
         End If
      End If
   End If

   SkipSymbolic = %ucFalse
End Function

Function uc_Eval(t As ucThreadType) As Ext
   uc_Eval = ucEvaluate(ucParam(1, t))
End Function

Function Prnt(t As ucThreadType) As Ext
   PrintStrng$ = PrintStrng$ + ucParamStr(1, t)
End Function

Function PrintColumn(t As ucThreadType) As Ext
   PrintStrng$ = PrintStrng$ + Space$(14 - (Len(PrintStrng$) Mod 14))
End Function

Function PrintLine(t As ucThreadType) As Ext
   PrintOut PrintStrng$
   PrintStrng$ = ""
End Function

Function PrintSemi(t As ucThreadType) As Ext
   PrintOut PrintStrng$, %SemiColon
   PrintStrng$ = ""
End Function

Sub FastCallback(Expr As ExpressionType)
   Expr.@ResultExt = Expr.@LeftExt + Expr.@RightExt
End Sub

Sub LngAdd(Expr As ExpressionType)
   Expr.@ResultLng = Expr.@LeftLng + Expr.@RightLng
End Sub

Sub SngAdd(Expr As ExpressionType)
   Expr.@ResultSng = Expr.@LeftSng + Expr.@RightSng
End Sub

Sub MixAdd(Expr As ExpressionType)
   Expr.@ResultLng = Expr.@LeftSng + Expr.@RightSng
End Sub

Sub LngDiv(Expr As ExpressionType)
   Expr.@ResultLng = Expr.@LeftLng / Expr.@RightLng
End Sub

Sub MixDiv(Expr As ExpressionType)
   Expr.@ResultSng = Expr.@LeftLng / Expr.@RightLng
End Sub

Sub MixDivB(Expr As ExpressionType)
   Expr.@ResultSng = Expr.@LeftSng / Expr.@RightLng
End Sub

Function Ternary(t As ucThreadType) As Long
   If ucTreeGetOp(t) = ":" Then
      ucTreeSetOp ",", t
   ElseIf ucTreeGetOp(t) = "?" Then
      ucTreeSetOp ",", t
      ucSetExpr "IIF(" + ucGetExpr(t) + ")", t
   End If
End Function

Function PbMain
   Dim oVBLib As ucVbLibucVbLibrary
   Dim x As Ext, Finish As Ext, UserEq As Dword, UserEqDbl As Dword
   Dim Sum As Ext, SumDbl As Double, q As Ext, Expr$, txt$
   Dim xDbl As Double, yDbl As Double

#If %Def(%DebugCC)
   LocalInit
#EndIf
   Open "Test.Out" For Output As #1
   Open "Test.Ans" For Input As #2
   Open "Diff.Out" For Output As #3

   q = 101
   xDbl = 5
   yDbl = 10

   Dim Values(5) As Double
   Dim mArray(5, 9, 7) As Ext
   Dim ArrayInt(1985:1995) As Long

   Values(0) = -70000
   Values(1) = 22000: Values(2) = 25000
   Values(3) = 28000: Values(4) = 31000

   For x = 1985 To 1995:ArrayInt(x)=x-1900:Next

   For x = 0 To 5
      For y = 0 To 9
         For z = 0 To 7
            mArray(x,y,z) = (x*100+y*10+z)/10
         Next
      Next
   Next

   ucErrorHandler CodePtr(MyErrorHandler)

   Call ucPBLibInit(t0)
   Set oVBLib = New ucVbLibucVbLibrary In $PROGID_ucVbLibucVbLibrary
   Object Call oVBLib.ucVbLibInit '+++ (t0)
   Call ucDelphiLibInit(t0)

   ucEval "'Message Box'"
   t! = Timer

   ucTreeParseDownRaw CodePtr(uc_TreeParseDown) ' +++ Check why it needs to be Raw
   ucTreeParseUp CodePtr(DetachLocalVars)
   ucTreeParseUp CodePtr(C_Hex)

   ucAlias "AliasTestA(x)", "(x+1)"
   ucAlias "AliasTestB(x)", "x+1"
   ucAlias "AliasTestC(x, y = 2+3)", "x + y"
   ucAlias "Local(x)", "SetVar(x, 0)"
   ucAlias "Static(x)", "0"

   ucDefineConstant "Div0 = " & Str$(%ucFPU_ErrMask_ZeroDivide)
   ucDefineVariable "zero = 0"
   ucDefineVariable "one = 1"
   ucDefineVariable "MyVariable = 100"
   ucDefineVariable "Total = 125"
   ucDefineVariable "TotalB = 0"
   ucAttachVariable "q", VarPtr(q)
   ucDefineVariable "MyStr = 'Word'"
   ucDefineVariable "MyString = ""This is my string"" "
   ucDefineVariable "i = #i"
   ucDefineVariable "im = 3+4#i"
   ucDefineVariable "abc700E = 100"
   ucDefineVariable "x1=0"
   ucDefineVariable "x1='0'"
   ucDefineVariable "NegNum=-25"
   ucDefineVariable "PosNum=25"
   ucAttachVariable "xDbl As Double", VarPtr(xDbl)
   ucAttachVariable "yDbl As Double", VarPtr(yDbl)
   ucAttachVariable "mArray(5, 9, 7)", VarPtr(mArray(0,0,0))
   ucAttachVariable "ArrayInt(1985:1995) As Long", VarPtr(ArrayInt(1985))
   ucAttachVariable "Values(5) As Double", VarPtr(Values(0))
   ucDefineVariable "OtherArray(3) As Double"
   ucDefineVariable "OtherArray(0) = 137"
   ucDefineVariable "OtherArray(1) = 541"
   ucDefineVariable "OtherArray(2) = 255"
   ucDefineVariable "OtherArray(3) = 315"
   ucDefineVariable "MyArray() = {57, 23, 98, 17, 46}"
   ucDefineVariable "qArray(1:) = {11, 22, 33, 44, 55}"
   ucDefineVariable "zYear(1995 to 2002)"
   For x = 1995 To 2002:ucDefineVariable "zYear("+Str$(x)+") ="+Str$(x*10):Next

   t0.ucProperty.FunctionProperties = %ucInline + %ucOverload

   ucDefineFunction "Eval(x)", CodePtr(uc_Eval)
   ucDefineFunction "Sum(Expr&,start,finish,step=1,var@=x)", CodePtr(ucalcSum)
   ucDefineFunction "SumB(Expr&,start,finish,step=1,var@=x) = Sum(Eval(Expr),start,finish,step,var)"
   ucDefineFunction "SumC(Expr&, start, finish, var@=x) = Static(Total):For(var, start, finish, SetVar(Total, Total+Eval(Expr)))"
   ucDefineFunction "SumD(Expr&, start, finish, var@=x) = Local(Total):For(var, start, finish, SetVar(Total, Total+Eval(Expr)))"

   t0.ucProperty.FunctionProperties = %ucDynamic + %ucOverwrite + %ucOverload + %ucRecursion
   ucDefineFunction "Factorial(x) = iif(x=0, 1, x*Factorial(x-1))"
   ucDefineFunction "pPower(x, y) = iif(y, x*pPower(x, y-1), 1)"

   t0.ucProperty.FunctionProperties = %ucDynamic + %ucOverwrite + %ucOverload
   ' +++ Most functions need to be tested with both %ucDynamic and %ucInline.

   ucDefineFunction "ArraySum(Values())", CodePtr(ucArraySum)
   ucDefineFunction "Average()", CodePtr(ucalcAverage)
   ucDefineFunction "frac(x)=abs(abs(x)-int(abs(x)))"
   ucDefineFunction "concat$(txtA$,txtB$) = txtA+txtB"
   ucDefineFunction "TriangleWave(x) = (8/pi^2)*Sum((-1)^((n-1)/2)/(n^2)*Sin(n*x), 1, 100, 2, n)"
   ucDefineFunction "area(length,width)=length*width"
   ucDefineFunction "area(side) = side^2"
   ucDefineFunction "volume(r,h=0)=iif(h=0, pi*r^3*4/3, pi*r^2*h/3)"

   ucDefineFunction "StringTestA$(a$, b) = Left$(a, b)+'qqq'"
   ucDefineFunction "StringTestB$(a) = chr$(a)"
   ucDefineFunction "StringTestC(a$) = len(a)"
'   ucDefineFunction "StringTestD$(a) = StringTestB(a) + MyString" ', 0, %ucInline
 '    above doesn't work yet

' +++ ucDefineFunction NewChr$() = Chr$(...) for multiple args.

   ucDefineFunction "shl[x,y] = x * 2^y"
   ucDefineFunction "nthRoot(x, y) = x ^ (1/y)"
   ucDefineFunction "FastCallback(x, y)", CodePtr(FastCallback), %ucFastCallback

   t0.ucProperty.FunctionProperties = %ucInline + %ucOverwrite + %ucOverload + %ucComplex
   ucDefineFunction "cnj(x)    = x.Real + (-x.Imag)*#i"
   ucDefineFunction "iTest(x)  = iif(x.Real, x.Real, 1) + iif(x.Imag, x.Imag, 2)*#i"
   ucDefineFunction "iiTest(x) = (#i*x.Real + x.Imag) * 2"
   ucDefineFunction "iaTest(x) = #i + cnj(x) + x.Real"

   ucDefineFunction "TestA(condition,a,b)", CodePtr(ucTestA)
   ucDefineFunction "TestAA(condition,a&,b&)", CodePtr(ucTestA)

   ucDefineFunction "iTestAA(x) = x.Real + TestAA(x.Imag,1,2)*#i"
   ucDefineFunction "iTestBB(x) = iTestAA(x.Real+x.Imag*#i)"

   ucDefineFunction "testB(x)   = TestA(x,1,2)"
   ucDefineFunction "testBB(x)  = TestAA(x,1,2)"
   ucDefineFunction "testC(x)   = testB(x)"
   ucDefineFunction "testCC(x)  = testBB(x)"

   t0.ucProperty.FunctionProperties = %ucDynamic + %ucComplex

   ucDefineFunction "dTestA(x)", CodePtr(dTestA)
   ucDefineFunction "dTestB(x) = 2*x.Real + 2*x.Imag*#i"
   ucDefineFunction "dTestC(x) = dTestA(x.Real+x.Imag*#i)"
   ucDefineFunction "dTestD(x) = dTestB(x.Real+x.Imag*#i)"

' +++ Add test for Delphi lib preparse (for MyString[x] syntax)

   PrintAndEval("")
   PrintAndEval("3+4/5-8")
   PrintAndEval("5*(((10+3)!-1) MOD 7)^2")
   PrintAndEval("#b101.1101 + #b110.1001")
   PrintAndEval("(3+4#i)^2")
   PrintAndEval("(3+4#i)*(5+6#i)")
   PrintAndEval("(3+4#i)^(5+6#i)")
   PrintAndEval("Sqr(-1)")
   PrintAndEval("""This"" > ""That""")
   PrintAndEval("""This"" < ""That""")
   PrintAndEval("SetOrFPU(Div0, -1/0)") ' +++ derive gives +/-Inf
   PrintAndEval("sum(x^2+5,1,10)")
   PrintAndEval("sum(2y-3,1,10,,y)")
   PrintAndEval("sum(x+10,2,5,.5)")
   PrintAndEval("SumB(x^2+5, 1, 11)")     ' The following Sums must be tested together
   PrintAndEval("SumC(x^2+5, 1, 12)*10")  ' Total here is Static
   PrintAndEval("SumC(v^2+5, 1, 12, v)")
   PrintAndEval("SumD(x^2+5, 1, 15)*10")   ' Total here is Local
   PrintAndEval("SumD(v^2+5, 1, 15, v)")
   '+++ Test another function that calls SumC and D.  Test one var arg with several Expr arg that use the var
   PrintAndEval("For(x, 1, 20, SetVar(TotalB, TotalB+x^2+5))")
   PrintAndEval("Str$(Total)+Str$(TotalB)")
   PrintAndEval("average(5,min(2,5),8)-max(2,5,9,1)")
   PrintAndEval("'Just '+'a '+DoNothing('vv')+'test'")
   PrintAndEval("Len(""String Length"")")
   PrintAndEval("Left$(""Hello there"", 6) + ""World""")
   PrintAndEval("InStr(""This is my string"",""my"")")
   PrintAndEval("InStr(10,""This is my string"",""i"")")
   PrintAndEval("Asc(""Hello World"", 7)")
   PrintAndEval("Chr$(72,101,108,108,111)")
   PrintAndEval("Chr$(72,101,108,108,111, 'world. ', 70 to 90)")
   PrintAndEval("Remove$(""Hello, World!"", Any "",!"")")
   PrintAndEval("""Cooool"" Like ""C*l""")
   PrintAndEval("DateAdd(""d"", 30, Now)")
   PrintAndEval("NPV(.0625, Values())")
   PrintAndEval("StdDev(Values())")         ' +++ Differs from Excel StdDev
   PrintAndEval("Mean(Values())")
   PrintAndEval("Mean(OtherArray())")
   PrintAndEval("TotalVariance(Values())")  ' +++ Differs from Excel
   PrintAndEval("frac(150/17)")
   PrintAndEval("frac(150/17)+MyVariable")
   PrintAndEval("area(4)+area(5,10)+max(5,9,3)")
   PrintAndEval("volume(4)+volume(4,5)")
   PrintAndEval("Bin$(#b01101 shl 1)")
   PrintAndEval("Concat('Abc', 'QQQ')")
   PrintAndEval("Concat('Abc', MyString)")
   PrintAndEval("MyString")
   PrintAndEval("MyString+'zzz'")
   PrintAndEval("Len(MyString)")
   PrintAndEval("InStr(MyString,""is"")")
   PrintAndEval("Factorial(25)")
   PrintAndEval("pPower(3, 4)")
   PrintAndEval("TriangleWave(5)")
   PrintAndEval("TriangleWave(-2)/sin(-2)")
   PrintAndEval("iif(NegNum, TriangleWave(NegNum), sin(NegNum))")
   PrintAndEval("iif(NegNum<0, TriangleWave(NegNum), sin(NegNum))")
   PrintAndEval("iif(PosNum<0, TriangleWave(PosNum), sin(PosNum))")
   PrintAndEval("ArraySum(MyArray())")
   PrintAndEval("ArraySum(ArrayInt())") ' Integer (Long)
   PrintAndEval("ArraySum(Values())")   ' Double
   PrintAndEval("ArraySum(mArray())")   ' Extended precision array, multidimension
   PrintAndEval("SumInt(ArrayInt())")   ' Delphi routine
' +++ Make a way to pass a subset of the array)
   PrintAndEval("Sum(MyArray(x),1,3)")
   PrintAndEval("zYear(1996)")
   PrintAndEval("zYear(2002)")
   PrintAndEval("Abs(-1)")
   PrintAndEval("'Abc' + 'XYZ'")
   PrintAndEval("'Abc' + 'XYZ' + 'cde'")
   PrintAndEval(" ' ''Hello'' ' + "" """"World"""" "" ")
   PrintAndEval("dTestA(3+4#i)")
   PrintAndEval("dTestB(3+4#i)")
   PrintAndEval("dTestC(3+4#i)")
   PrintAndEval("dTestD(3+4#i)")
   PrintAndEval("2*cnj(3+4#i)")
   PrintAndEval("i*2 + 5")
   PrintAndEval("i^2 + 5")
   PrintAndEval("3*(#i)")
   PrintAndEval("3+(4+5#i)")
   PrintAndEval("3+(4+5)*#i")
   PrintAndEval("sin(3+4#i)")
   PrintAndEval("sin(3-4#i)")
   PrintAndEval("(3+4#i)^(#i)")
   PrintAndEval("Real((3+4#i)^(#i))")
   PrintAndEval("Imag((3+4#i)^(#i))")
'  +++ PrintAndEval("SetOrFPU(2048, (3+4#i)^(#i))")
   PrintAndEval("(3+4*#i)-(#i)")
   PrintAndEval("(#i)+5")
   PrintAndEval("#i*(3+4i)")
   PrintAndEval("i*(3+4i)")
   PrintAndEval("i+(3+4i)")
   PrintAndEval("i*(3+4*im)")
   PrintAndEval("i*cnj(3+4*im)")
   PrintAndEval("i*CNJ(3+4i)")
   PrintAndEval("#i*CNJ(3+4i)")
   PrintAndEval("i*CNJ(3+4i)^2")
' +++ The ^2 in above expr causes problem if def space is too small
   PrintAndEval("#i*CNJ(3+4i)^2")
   PrintAndEval("#i*CNJ(3+4#i)^2")
   PrintAndEval("#i-CNJ(3+4#i)^2")
   PrintAndEval("#i*(-7-24#i)")
   PrintAndEval("#i*#i")
   PrintAndEval("#i")
   PrintAndEval("im")
   PrintAndEval("i")
   PrintAndEval("-#i^(5+#i)")
   PrintAndEval("cnj(im)")
   PrintAndEval("#i^2")
   PrintAndEval("(-25)^(1/2)")
   PrintAndEval("NegNum^(1/2)")
   PrintAndEval("Sqr(NegNum)")
   PrintAndEval("sqr(-25+#i)")   ' +++ Last 2 digits for next 3 exprs are off.
   PrintAndEval("sqr(NegNum+i)")
   PrintAndEval("(NegNum+i)^(1/2)")
   PrintAndEval("sqr(#i)")
   PrintAndEval("sqr(3+4#i)")
   PrintAndEval("sqr(3+4i)")
   PrintAndEval("Sqr(im)")
   PrintAndEval("Sqr(1)")
   PrintAndEval("Sqrt(16)")
   PrintAndEval("Sqrt(-16)")
   PrintAndEval("Sqrt(8#i)")
   PrintAndEval("Sqrt(im)")
   PrintAndEval("Area(Sqr(16))")
   PrintAndEval("Area(Sqrt(16))")
   PrintAndEval("Area(Sqr(16)) + Sqr(NegNum)")
   PrintAndEval("5+#i")
   PrintAndEval("iTest(3+4#i)")
   PrintAndEval("iiTest(3+4#i)")
   PrintAndEval("iiTest(im)")
   PrintAndEval("iiTest(5)")
   PrintAndEval("iTest(cnj(3+4#i))")
   PrintAndEval("cnj(iTest(3+4#i))")
   PrintAndEval("cnj(iTest(iiTest(iaTest(sgn(3+4#i)))))")
   PrintAndEval("sgn(3+4#i)")
   PrintAndEval("Sqrt(3+4#i)")
   PrintAndEval("iaTest(3+4#i)")
   PrintAndEval("iTestBB(3+4#i)")
   PrintAndEval("testC(5)")
   PrintAndEval("testCC(5)")
   PrintAndEval("3*AliasTestA(5)")
   PrintAndEval("3*AliasTestB(5)")
   PrintAndEval("500+AliasTestC(10)")
   PrintAndEval("AliasTestC(50, 20)")
   PrintAndEval("25%")
   PrintAndEval("6!-5")
   PrintAndEval("3*-5")
   PrintAndEval("-3*-5")
   PrintAndEval("-5e-19")
   PrintAndEval("3e5")
   PrintAndEval("+(3+4)")
   PrintAndEval("-Abs(-3)")
   PrintAndEval("-i")
   PrintAndEval("-#i")
   PrintAndEval("--7")
   PrintAndEval("---8")
   PrintAndEval("3--2")
   PrintAndEval("3---2")
   PrintAndEval("3*(-4)")
   PrintAndEval("5+-3^2")
   PrintAndEval("-3^2")
   PrintAndEval("-5+2")
   PrintAndEval("-(3+4)")
   PrintAndEval("-5")
   PrintAndEval("-59")
   PrintAndEval("-5+5")
   PrintAndEval("q+q")
   PrintAndEval("q")
   PrintAndEval("-q")
   PrintAndEval("MyArray(1)")
   PrintAndEval("MyArray(2)")
   PrintAndEval("qArray(1)")
   PrintAndEval("qArray(2)")
   PrintAndEval("qArray(3)")
   PrintAndEval("OtherArray(3)")
   PrintAndEval("5>2 and 3 < 20")
   PrintAndEval("('cde' > 'abc') and ('a' < 'b')")
   PrintAndEval("'cde' > 'abc' and 'a' < 'b'")
   PrintAndEval("'aab' = concatenate('aa', 'b')")
   PrintAndEval("'aab' = 'aa' & 'b'")
   PrintAndEval("'aab' = 'aa' + 'b'")
   PrintAndEval("'asdf' == 'asdf'")
   PrintAndEval("5 > 2   ==  ('asdf' = MyString)")
   PrintAndEval("5 < 2   ==  ('asdf' = MyString)")
   PrintAndEval("'asdf' = MyString == 5 > 2")
   PrintAndEval("'asdf' = MyString == 5 < 2")
   PrintAndEval("MyString = 'dd' or 5 > 2")
   PrintAndEval("MyStr = 'Word' or MyString = 'abcd'")
   PrintAndEval("instr(len('abc'),'XIFYZDIF', 'IF')")
   PrintAndEval("abs(len('abc'))")
'  +++ PrintAndEval("Sum(MyExpression, Sum(z+1,1,3), Sum(x,1,55), 1, MyVar)")
   PrintAndEval("sum(sum(z+x, 1, 5, , z)+x,1,5)")
   PrintAndEval("sum(sum(z*x, 1, 5, , z)+x/2,1,5)")
   PrintAndEval("Sum(z^2+5z-4, Sum(z+1,1,3,,z), Sum(x,1,55), 1, z)")
   PrintAndEval("sum(sum(x,1,10)+x^2+5,1,5)")
   PrintAndEval("sum(x^2+5,1,sum(x^2,1,10))+5")
   ' +++Something with local variable x (ucParse), and x in sum()
   PrintAndEval("iif(3=2+1, 10, 1/0)")
   PrintAndEval("iif(3=2+2, 10, 1/0)")
'  +++ IIF with complex num
   PrintAndEval("MyString & 'zzzzz'")
   PrintAndEval("abs('asd' like 'aa')")
   PrintAndEval("abs('F' Like '[A-Z]')")
   PrintAndEval("5+1/10^15")
   PrintAndEval("(100)^(1/2)")
   PrintAndEval("nthRoot(27, 3)")
   ucDefineVariable "Values(3) = 3030303"
   ucDefineVariable "qArray(5) = 5050505"
   PrintAndEval("Values(4-1)")
   PrintAndEval("qArray(5)")
   PrintAndEval("Str(mArray(3,2,5))+Str(mArray(5,9,7))+Str(mArray(1,2,3))+Str(mArray(2,0,4))")
   PrintAndEval("Str(ArrayInt(1985))+Str(ArrayInt(1989))+Str(ArrayInt(1993))+Str(ArrayInt(1995))")
   PrintAndEval("iif(3,iif(10,20,30), 5)")
   PrintAndEval("iif(3,iif(10-10,20,30), 5)")
   PrintAndEval("iif(0,iif(10,20,30), 5)")
   PrintAndEval("abc700E")
   PrintAndEval("Trim$('Trim   ') + 'ming   ' + '...'")
   PrintAndEval(" ' ''Hello'' ' + ' "" abc "" ' + "" 'cde' "" + "" """" World"""" "" ")
   PrintAndEval("StringTestA('abcde', 3)")
   PrintAndEval("StringTestB(67)")
   PrintAndEval("StringTestC('abc')")
   PrintAndEval("FastCallback(3.2, 4.6)")
   PrintAndEval("xDbl")
   PrintAndEval("xDbl + 20")
   PrintAndEval("50 + yDbl")
   PrintAndEval("xDbl + yDbl")
   PrintAndEval("q + yDbl")
   PrintAndEval("Log(0)") ' +++ Gives Div by 0 instead of InvalidOp
   PrintAndEval("Log(-1)")
   PrintAndEval("Log(1)")
   PrintAndEval("Log(-#i)+#i")
   PrintAndEval("-sin(one)^one")
   PrintAndEval("-sin(0)^(-0)")
   PrintAndEval("VERIFY('123.45,65.1', '123456789')")
   PrintAndEval("$FF") ' Delphi hex
   PrintAndEval("0xFFF") ' C hex
   PrintAndEval("0x1AE") ' C hex
   PrintAndEval("&hFF") ' BASIC hex
   PrintAndEval("Min$('zebra', 'aardvark')")
   PrintAndEval("Max$('zebra', 'aardvark')")
   PrintAndEval("Min$('duck', 'zebra', 'zebu', 'xylophone', 'aardvark')")
   PrintAndEval("Max$('duck', 'zebra', 'zebu', 'xylophone', 'aardvark')")
   PrintAndEval("IIf$(1, 'True', 'False')")
   PrintAndEval("IIf$(0, 'True', 'False')")
   PrintAndEval("'Answer: ' + IIf$(IIf(1, 2, 3), IIf$(1, 'a', 'b'), 'c')")
   PrintAndEval("iif(3=2+2, Str$(1/0), 'B')")
   PrintAndEval("iif(3=2+1, Str$(1/0), 'B')")
   PrintAndEval("InStr('This IS a test', 'IS', 0)") ' 0 = case sensitive
   PrintAndEval("InStr('This IS a test', 'IS', 1)") ' 1 = not case sensitive
   PrintAndEval("InStr('This IS a test', Any 'AIS')")
   PrintAndEval("InStr(5, 'This IS a test', Any 'sia')")
   PrintAndEval("InStr(5, 'This IS a test', Any 'sia', 1)") 'VB PB feature combo
   PrintAndEval("MyString[2]")
   PrintAndEval("MyString[3]")

   ' Numeric types other than the default
' +++ Should return an error (or resolve somehow) if , 0 before CodePtr is omitted
   ucDefineOperator "LngAdd[x As Long, y As Long] As Long", 0, CodePtr(LngAdd), %ucFastCallback
   ucDefineOperator "SngAdd[x As Single, y As Single] As Single", 0, CodePtr(SngAdd), %ucFastCallback
   ucDefineOperator "MixAdd[x As Single, y As Single] As Long", 0, CodePtr(MixAdd), %ucFastCallback
   ucDefineOperator "LngDiv[x As Long, y As Long] As Long", 0, CodePtr(LngDiv), %ucFastCallback
   ucDefineOperator "MixDiv[x As Long, y As Long] As Single", 0, CodePtr(MixDiv), %ucFastCallback
   ucDefineOperator "MixDivB[x As Single, y As Long] As Single", 0, CodePtr(MixDivB), %ucFastCallback

   t0.ucProperty.OutputDigits = 6
   PrintAndEval("1.45 LngAdd 1.45")
   PrintAndEval("1.45 SngAdd 1.45")
   PrintAndEval("1.45 MixAdd 1.45")
   PrintAndEval("5 LngDiv 3")
   PrintAndEval("5.4 LngDiv 3")
   PrintAndEval("5 MixDiv 3")
   PrintAndEval("5.4 MixDiv 3")
   PrintAndEval("5 MixDivB 3")
   PrintAndEval("5.4 MixDivB 3")
   t0.ucProperty.OutputDigits = 18

   PrintAndEval("65536 SngAdd .0156")
   PrintAndEval("65536 + .0156")

   PrintOut

   UserEq = ucParse("x^2 + 5x - 10", "x")
   UserEqDbl = ucParse("x^2 + 5x - x", "x: Double")
   ucAttachVariable "x", VarPtr(x), UserEq
   ucAttachVariable "x As Double", VarPtr(xDbl), UserEqDbl

   For x = 1 To 10000
      Sum = Sum + ucEvaluate(UserEq)
   Next
   PrintOut Str$(Sum)
   ucReleaseExprPtr UserEq

   For xDbl = 1 To 10000
      SumDbl = SumDbl + ucEvaluate(UserEqDbl)
   Next
   PrintOut Str$(SumDbl)
   ucReleaseExprPtr UserEqDbl

   For x = 1 To 1000
      textA$ = ucEvalStr("'ABC' + MyString")
      textB$ = ucEvalStr("1+2*(3+4#i)")
      textC$ = ucEvalStr("concat$('a','b')")
   Next

   PrintOut textA$
   PrintOut textB$
   PrintOut textC$

   x = 3.25
   UserEq = ucParse("frac(x)", "x")
   ucAttachVariable "x", VarPtr(x), UserEq
   PrintOut Str$(ucEvaluate(UserEq))
   ucReleaseExprPtr UserEq

   t0.ucProperty.ImagSymbol = Asc("j")
   PrintAndEval("Sqr(-1)")
   PrintAndEval("10*#j-(3+4#j)")
   PrintAndEval("Sqr(-1)+5")
   t0.ucProperty.ImagSymbol = Asc("i")
   PrintOut


   PrintAndEval("zero^0") ' Using default _ZeroToZero() = 1

   ' _ZeroToZero() is a dynamic function used in the include file def for ^
   ucDefineFunction "_ZeroToZero() = 0", 0, %ucDynamic+%ucOverwrite
   PrintAndEval("0^zero")

   ucDefineFunction "_ZeroToZero() = NaN", 0, %ucDynamic+%ucOverwrite
   PrintAndEval("zero^zero")

   ucDefineFunction "_ZeroToZero() = SetError('0^0 Error')", 0, %ucDynamic+%ucOverwrite
   PrintAndEval("0^(1-1)")

   t0.ucProperty.FunctionProperties = %ucDynamic + %ucComplex + %ucOverwrite + %ucOverload + %ucOverride
   ucDefineFunction "^[a, b] = iif(a.Real = 0 and b.Real = 0, 1,  a.Real ^ b.Real)"
   PrintAndEval("0^0")
   PrintOut

   ' Another dynamic function def test
   ucDefineFunction "MyLog(x) = Ln(x)", 0, %ucDynamic + %ucOverwrite
   ExprPtr = ucParse("MyLog(10)")
   PrintOut Str$(ucEvaluate(ExprPtr))

   ucDefineFunction "MyLog(x) = Log10(x)", 0, %ucDynamic + %ucOverwrite
   PrintOut Str$(ucEvaluate(ExprPtr))
   PrintOut


   ucDefineFunction "test(x) = sin(x)", 0, %ucDynamic
   FuncHandle = ucDefineFunction("sin(x) = sin(x*pi/180)", 0, %ucBootstrap + %ucOverride)

   PrintAndEval("sin(270)")
   PrintAndEval("test(270)") ' +++ Check last 3 digits

   ucReleaseItem FuncHandle

   PrintAndEval("sin(270)")
   PrintOut


   PrintAndEval("'Simple symbolic test, using ucTreeParseUp'")
   ucDefineConstant "ConstA = 10"
   ucDefineConstant "ConstB = 20"

   SymbolicRoutine = ucTreeParseUp(CodePtr(SymbolicOutput))

   PrintAndEval("5+6+a")
   PrintAndEval("x+2+3")
   PrintAndEval("1+2")
   PrintAndEval("45+5+x+y")
   PrintAndEval("30+a+40")
   PrintAndEval("25+b+75+a")
   PrintAndEval("ConstA + x + ConstB + y + z + 5")
   PrintOut

   ucReleaseItem SymbolicRoutine


   t0.ucProperty.FunctionProperties = %ucOverwrite + %ucOverload + %ucOverride

   PrintAndEval("'Unary operators test'")
   ucDefineOperator "!=[x,y] = x <> y", ucPrecedence("<>")
   ucDefineOperator "![x] = x*2", t0.PrecedenceMax
   ucDefineOperator "%[x] = x*100", t0.PrecedenceMax

   PrintAndEval("3000% % 17")     ' Interpreted here as (3000%) % 17
   PrintAndEval("3000% % 700%")   ' Interpreted here as (3000%) % (700%)
   PrintAndEval("1230000% % %17") ' Interpreted here as ((1230000%)%) % 17
   PrintAndEval("(1234500%) % (%17)")
   PrintAndEval("!5")
   PrintAndEval("!5!")            ' Interpreted here as (!5)!
   PrintAndEval("5! != !5")
   PrintAndEval("5! != 5!")
   PrintAndEval("3!!")
   PrintAndEval("!!3")
   PrintAndEval("-3!!")

   ucReleaseItem ucSymbolHandle("%")
   ucReleaseItem ucSymbolHandle("%")
   ucReleaseItem ucSymbolHandle("%")
   ucDefineOperator "%[x,y] = x mod y", ucPrecedence("MOD")
   ucDefineOperator "[x]% = x/100", t0.PrecedenceMax
   ucDefineOperator "%[x] = x*100", t0.PrecedenceMax

   ' +++ Need to document subtle difference in order of defining overloaded items.

   PrintAndEval("3000% % 17")     ' Interpreted here as 3000 % (%17)
   PrintAndEval("3000% % 700%")   ' Interpreted here as 3000 % (%(700%))
   PrintAndEval("1230000% % %17") ' Interpreted here as 1230000 % (%(%17))
   PrintAndEval("(1234500%) % (%17)")
   ' +++ Delphi MOD (in ucalcfme) different than PB's.  PB supports floating point MOD result

   ucDefineOperator "![x] = x*2", t0.PrecedenceMin
   PrintAndEval("!5!")            ' Interpreted here as !(5!)
   PrintAndEval("Not 5")
   PrintAndEval("Not (5)")
   PrintAndEval("Not(5)")
   PrintAndEval("3! = 2")
   PrintAndEval("3 != 2")
   PrintOut


   PrintAndEval("'Multiline function test'")

   EqualRoutine = ucTreeParseDown(CodePtr(ChangeEqual))
   ucDefineOperator "Print[any]", t0.PrecedenceMin+1, CodePtr(Prnt)
   ucDefineOperator "Prnt[text$]", t0.PrecedenceMin+1, CodePtr(Prnt)
   ucDefineOperator "Prnt[number]", t0.PrecedenceMin+1, CodePtr(Prnt)
   ucDefineFunction "PrintLine()", CodePtr(PrintLine)
   ucDefineFunction "PrintSemi()", CodePtr(PrintSemi)
   ucDefineFunction "PrintColumn()", CodePtr(PrintColumn)

   ucDefineOperator ";[x,y] = x+y", t0.PrecedenceMax
   ucDefineOperator ",[x,y] = x+y", t0.PrecedenceMax
   ucDefineOperator "[x]; = x", t0.PrecedenceMax
   ucDefineOperator "[x], = x", t0.PrecedenceMax

   ucDefineVariable "x = 12345"

   ucDefineFunction "Function MultiLine(x, y)", 0, %ucMultiline + %ucInline
   ucDefineFunction "   Print 'Test A'                  "
   ucDefineFunction "   Print 'x: '; x                  "
   ucDefineFunction "   MultiLine = x+y^2               "
   ucDefineFunction "   Print 'MultiLine: '; MultiLine  "
   ucDefineFunction "   Print 'y: '; y                  "
   ucDefineFunction "End Function                       "

   PrintAndEval("MultiLine(7.5, 10)")

   ucDefineFunction "Function MultiLineB(x, y)", 0, %ucMultiline + %ucDynamic
   ucDefineFunction "   Print 'Test B'                  "
   ucDefineFunction "   Print 'x: '; x                  "
   ucDefineFunction "   MultiLineB = x+y^2              "
   ucDefineFunction "   Print 'MultiLineB: '; MultiLineB"
   ucDefineFunction "   Print 'y: '; y                  "
   ucDefineFunction "End Function                       "

   PrintAndEval("MultiLineB(6.5, 100)")

   ucDefineFunction "Function MultiTest(a As Ext, b As Ext)", 0, %ucMultiline+%ucDynamic
   ucDefineFunction "   Dim x As Ext                    "
   ucDefineFunction "                                   "
   ucDefineFunction "   Print x, MultiTest              "
   ucDefineFunction "                                   "
   ucDefineFunction "   For x = a To b                  "
   ucDefineFunction "      If x mod 2 = 0 Then          "
   ucDefineFunction "         Print x; ' is even'       "
   ucDefineFunction "      Else                         "
   ucDefineFunction "         Print x; ' is odd'        "
   ucDefineFunction "      End If                       "
   ucDefineFunction "   Next                            "
   ucDefineFunction "   MultiTest = a*b                 "
   ucDefineFunction "End Function                       "

   PrintAndEval("MultiTest(2, 6)")
   PrintAndEval("MultiTest(2, 6)")

   ucDefineFunction "Function Sin(x)", 0, %ucMultiline+%ucDynamic+%ucBootstrap
   ucDefineFunction "   sin = sin(x)*1000"
   ucDefineFunction "End Function"

   PrintAndEval("int(sin(1))")

   PrintAndEval("x")
   ucReleaseItem EqualRoutine

   t0.ucProperty.QuoteChar = 34
   t0.ucProperty.QuoteCharSynonym = 34
   PrintAndEval("'Hello World'")
   PrintAndEval(" ""Hello World"" ")

   t0.ucProperty.QuoteChar = 39
   t0.ucProperty.QuoteCharSynonym = 39
   PrintAndEval("'Hello World'")
   PrintAndEval(" ""Hello World"" ")
   PrintOut

   ucEvalStr("Print 'Abc', 123, -4, PosNum, 'Z'; NegNum, 5; 'AbcXyz' ")
   ucEvalStr("Print 1, 8.125, 'X', x, 'a'; 'b', 15")
   ucEvalStr("Print 'abc' : Print 'cde'")
   ucEvalStr("Print 'ABC';: Print 'DEF'")
   ucEvalStr("Print 'Abc', 123, 456, 'Z' : Print 'A', 1, 2, 15")

   t0.ucProperty.StatementSeparator = Asc("~")
   ucEvalStr("Print 'abc' ~ Print 123")
   ucEvalStr("Print 'ABC';~ Print 'DEF'")
   ucEvalStr("Print 'Abc', 123, 456, 'Z' ~ Print 'A', 1, 2, 15")

   PrintOut

   SpecialErrorTest = %ucTrue
   PrintAndEval("1/0")
   PrintAndEval("1/0+2/0")
   SpecialErrorTest = %ucFalse


   Dim MyAsciiZ As Asciiz * 20

   ucAttachVariable "StringA$", VarPtr(StringA$)
   ucAttachVariable "StringB As String", VarPtr(StringB$) ' +++ Apparently wouldn't work from VB because of unicode
   ucAttachVariable "MyAsciiZ As AsciiZ", VarPtr(MyAsciiZ)

   StringA$ = "First Ansi, "
   StringB$ = "Second AnsiString"
   MyAsciiZ = "My AsciiZ String"
   PrintAndEval("StringA + StringB")
   PrintAndEval("MyString + '...' + StringB")
   PrintAndEval("MyString + '...' + StringB + '...' + MyAsciiZ")

   PrintOut

   ' Checks Exponential notation resolved conflict
   e    = ucDefineVariable "e = 10"
   ee   = ucDefineVariable "ee = 20"
   e5   = ucDefineVariable "e5 = 100"
   ee5  = ucDefineVariable "ee5 = 200"
   e5e5 = ucDefineVariable "e5e5 = 300"

   PrintAndEval("e5")
   PrintAndEval("3e")
   PrintAndEval("3ee")
   PrintAndEval("3ee5")
   PrintAndEval("3e5e5")
   PrintAndEval("3e+one")

   ucReleaseItem e
   ucReleaseItem ee
   ucReleaseItem e5
   ucReleaseItem ee5
   ucReleaseItem e5e5

   PrintOut
   ' Ternary C operator ?:
   ' Other necessary parts such as ":" and "," already defined
   ucDefineOperator "?[x,y] = x+y", ucPrecedence(":")+1
   ucTreeParseDown CodePtr(Ternary)

   PrintAndEval("1+1 ? 2+2 : 5+5")
   PrintAndEval("1-1 ? 2+2 : 5+5")
   PrintAndEval("1+1 ? (1+1?7:8) : 5+5")
   PrintAndEval("1+1 ? (1-1?7:8) : 5+5")
   PrintAndEval("1-1 ? (1-1?7:8) : 5+5")

   ' Variable Redefine test
   PrintOut
   Var1 = ucDefineVariable("dVar = 10")
   PrintAndEval("dVar")
   Var2 = ucDefineVariable("dVar = 20")
   PrintAndEval("dVar")
   PrintOut Str$(Var1 = Var2)

   VarS1 = ucDefineVariable("dVarS = 'My Var'")
   PrintAndEval("dVarS")
   VarS2 = ucDefineVariable("dVarS = 'Redefined Var'")
   PrintAndEval("dVarS")
   PrintOut Str$(VarS1 = VarS2)

   ' The following should return error message
   PrintOut
   PrintOut "ERROR TEST"
   PrintOut

   ucDefineFunction "F(x) = sqr(x)", 0, %ucDynamic ' not complex
   ucDefineFunction "G(x) = (x + 5"
   ucDefineFunction "ParenthTest(a, b", CodePtr(ucTestA)

   ucDefineVariable "="
   ucDefineVariable "ConstA = 100"

   PrintAndEval("1/0")
   PrintAndEval("SetXorFPU(Div0, -1/0)")
   PrintAndEval(" ""Abc' + 'cde' ")
   PrintAndEval("MyArray(5)")
   PrintAndEval("MyArray(-1)")
   PrintAndEval("abc+cde+efg")
   PrintAndEval("Values(10)")
   PrintAndEval("zYear(1)")
   PrintAndEval("mArray(5,10,3)")
   PrintAndEval("cos()")
   PrintAndEval("cos(1,2)")
   PrintAndEval("'asdf' - 'adsf'")
   PrintAndEval("1.2.3")
   PrintAndEval("F2e")
   PrintAndEval("MyVariable & 1234")
   PrintAndEval("Len(bbb)")
   PrintAndEval("y")
   PrintAndEval("*(3+4)")
   PrintAndEval("iif(3,4,v)")
   PrintAndEval("1234^5678^1234") ' +++ Gives error for ^^ instead of ^
   PrintAndEval("exp(-12345)")
   PrintAndEval("(5 > 2   ==  'asdf') = MyString")
   PrintAndEval("*")
   PrintAndEval("+")
   PrintAndEval("f(-16)") ' +++ Maybe should return f instead of SQR for data
   PrintAndEval("f(#i)")
   PrintAndEval("Trianglewave(0) / sin(0)")
   PrintAndEval("Trianglewave(0) / sin(0)") ' Duplicate is part of test
   PrintAndEval("G(5)")
   PrintAndEval("e5")
   PrintAndEval("3e")
   PrintAndEval("3ee")
   PrintAndEval("3ee5")
   PrintAndEval("3e5e5")
   PrintAndEval("3e+one")
   PrintAndEval("123 BadOp 456")
   PrintAndEval("123BadOp456")
   PrintAndEval("BadOp 456")
   PrintAndEval("#b123")
   PrintAndEval("")

   textB$ = ucEvalStr("1+2*(3+4#i)") ' These 2 lines test that @ReturnCplx is cleared
   UserEq = ucParse("frac(x)", "x")  ' Should not return an error

   PrintAndEval("'t.Context test'")
   ucErrorHandler CodePtr(ContextErrorHandler)
   ErrTestA = ucParse("SetXorFPU(Div0, -1/x)", "x: Extended")
   ErrTestB = ucParse("1*")
   ErrTestC = ucParse("iif(1, 0/0, 0)")
   ucAttachVariable "x", VarPtr(x), ErrTestA  :  x = 0
   ucDefineFunction "MyFunc(x) = x+(5-1"
   ucDefineVariable "MyVar = 1+"
   ucDefineVariable "MyVar = 1/0"
   i = ucEval("1 and")
   i$ = ucEvalStr("1+'abc'")
   ' It is important for 1+'abc' to preceed ucEvaluate(ErrTestA) to test auto error clearing
   PrintOut Str$(ucEvaluate(ErrTestA))
   i$ = ucEvaluateStr(ErrTestA)
   i = ucEvaluate(ErrTestB) ' +++ Maybe should have an error message for this
   i = ucEvaluate(ErrTestC) ' another auto error clearing test
   i = ucEvaluate(ErrTestC)

   PrintAndEval("'The End'")
   Elapsed$ = "Elapsed time: " + Str$(Timer-t!)
   PrintAndEval("'" + Elapsed$ + "'")

   Close
   If DifferenceCount > 2 Then y = Shell("windiff test.out test.ans")

   Print "Press any key ..."
   WaitKey$

   Set oVBLib = Nothing
End Function
