Attribute VB_Name = "ucVbAddOn"
' -------------------------------------------------------------------------
' ucvblib.bas : Visual Basic add-on library Module source code.
' This, along with ucvblib.cls compiles to ucvblib.dll
' Designed to work with Visual Basic 5.0 or above.
'
' Redistribution of this file is not allowed.
'
' UCalc Fast Math Parser (Beta I)
' Copyright (c) 1998-2004 by Daniel Corbier.  All rights reserved.
' http://www.ucalc.com/mathparser
' -------------------------------------------------------------------------

Option Explicit

Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, source As Any, ByVal numBytes&)
'+++ RtlCopyMemory is probably faster

Function uc_PreParse_All(t As ucThreadType) As Long
   Dim LeftOperand$, RightOperand$, Operator$, FunctionName$

'+++ Need to create a good example
'    If ucElementType(t) = uc_IsFunction Then
'        FunctionName$ = ucParamStr(0, t)
'
'        If Right$(FunctionName$, 1) = "$" Then _
'            ucParamStr(0, t) = Left$(FunctionName$, Len(FunctionName$) - 1)
'    End If
End Function

' Date/Time functions

Function ucHour1(t As ucThreadType) As Double
   ucHour1 = Hour(ucParam(1, t))
End Function

Function ucHour2(t As ucThreadType) As Double
   ucHour2 = Hour(ucParamStr(1, t))
End Function

Function ucMinute1(t As ucThreadType) As Double
   ucMinute1 = Minute(ucParam(1, t))
End Function

Function ucMinute2(t As ucThreadType) As Double
   ucMinute2 = Minute(ucParamStr(1, t))
End Function

Function ucSecond1(t As ucThreadType) As Double
   ucSecond1 = Second(ucParam(1, t))
End Function

Function ucSecond2(t As ucThreadType) As Double
   ucSecond2 = Second(ucParamStr(1, t))
End Function

Function ucDay1(t As ucThreadType) As Double
   ucDay1 = Day(ucParam(1, t))
End Function

Function ucDay2(t As ucThreadType) As Double
   ucDay2 = Day(ucParamStr(1, t))
End Function

Function ucMonth1(t As ucThreadType) As Double
   ucMonth1 = Month(ucParam(1, t))
End Function

Function ucMonth2(t As ucThreadType) As Double
   ucMonth2 = Month(ucParamStr(1, t))
End Function

Function ucWeekday1(t As ucThreadType) As Double
   ucWeekday1 = WeekDay(ucParam(1, t), ucParam(2, t))
End Function

Function ucWeekday2(t As ucThreadType) As Double
   ucWeekday2 = WeekDay(ucParamStr(1, t), ucParam(2, t))
End Function

Function ucYear1(t As ucThreadType) As Double
   ucYear1 = Year(ucParam(1, t))
End Function

Function ucYear2(t As ucThreadType) As Double
   ucYear2 = Year(ucParamStr(1, t))
End Function

Function ucDate(t As ucThreadType) As Double
   ucReturnStr Date, t
End Function

Function ucNow(t As ucThreadType) As Double
   ucReturnStr Now, t
End Function

Function ucTime(t As ucThreadType) As Double
   ucReturnStr Time, t
End Function

Function ucTimer(t As ucThreadType) As Double
   ucTimer = Timer
End Function

Function ucDateAdd(t As ucThreadType) As Double
   Dim Interval As String, Number As Long, TheDate As String
    
   Interval = ucParamStr(1, t)
   Number = ucParam(2, t)
   TheDate = ucParamStr(3, t)
    
   ucReturnStr DateAdd(Interval, Number, TheDate), t
End Function

Function ucDateDiff(t As ucThreadType) As Double
   Dim Interval As String, Date1 As String, Date2 As String
   Dim FirstDayOfWeek As Long, FirstWeekOfYear As Long
    
   Interval = ucParamStr(1, t)
   Date1 = ucParamStr(2, t)
   Date2 = ucParamStr(3, t)
   FirstDayOfWeek = ucParam(4, t)
   FirstWeekOfYear = ucParam(5, t)
    
   ucDateDiff = DateDiff(Interval, Date1, Date2, FirstDayOfWeek, FirstWeekOfYear)
End Function

Function ucDatePart(t As ucThreadType) As Double
   Dim Interval As String, TheDate As String
   Dim FirstDayOfWeek As Long, FirstWeekOfYear As Long
    
   Interval = ucParamStr(1, t)
   TheDate = ucParamStr(2, t)
   FirstDayOfWeek = ucParam(3, t)
   FirstWeekOfYear = ucParam(4, t)
    
   ucReturnStr DatePart(Interval, TheDate, FirstDayOfWeek, FirstWeekOfYear), t
End Function

Function ucDateSerial(t As ucThreadType) As Double
   Dim Year As Long, Month As Long, Day As Long
    
   Year = ucParam(1, t)
   Month = ucParam(2, t)
   Day = ucParam(3, t)
    
   ucReturnStr DateSerial(Year, Month, Day), t
End Function

Function ucTimeSerial(t As ucThreadType) As Double
   Dim Hour As Long, Minute As Long, Second As Long
    
   Hour = ucParam(1, t)
   Minute = ucParam(2, t)
   Second = ucParam(3, t)
    
   ucReturnStr DateSerial(Hour, Minute, Second), t
End Function

Function ucDateValue(t As ucThreadType) As Double
   ' +++ Need to enhance DLL so that PreParse can return
   ' a Numeric, or string value, depending on parent function
End Function

Function ucTimeValue(t As ucThreadType) As Double

End Function

' Financial functions
Function ucDDB(t As ucThreadType) As Double
   Dim Cost As Double, Salvage As Double, Life As Double
   Dim Period As Double, Factor As Double
    
   Cost = ucParam(1, t)
   Salvage = ucParam(2, t)
   Life = ucParam(3, t)
   Period = ucParam(4, t)
   Factor = ucParam(5, t)
    
   ucDDB = DDB(Cost, Salvage, Life, Period, Factor)
End Function

Function ucFV(t As ucThreadType) As Double
   Dim Rate As Double, Nper As Integer, Pmt As Double
   Dim PV As Double, fType As Integer
    
   Rate = ucParam(1, t)
   Nper = ucParam(2, t)
   Pmt = ucParam(3, t)
   PV = ucParam(4, t)
   fType = ucParam(5, t)

   ucFV = FV(Rate, Nper, Pmt, PV, fType)
End Function

Function ucIPmt(t As ucThreadType) As Double
   Dim Rate As Double, Per As Double, Nper As Integer
   Dim PV As Double, FV As Double, fType As Integer
    
   Rate = ucParam(1, t)
   Per = ucParam(2, t)
   Nper = ucParam(3, t)
   PV = ucParam(4, t)
   FV = ucParam(5, t)
   fType = ucParam(6, t)
    
   ucIPmt = IPmt(Rate, Per, Nper, PV, FV, fType)
End Function

Function ucIRR(t As ucThreadType) As Double
   Dim DataAddress As Long, LowerBound As Long, UpperBound As Long
   Dim ArrayIndex As Long, Guess As Double, ElementSize As Long
    
   ArrayIndex = ucParam(1, t)
   DataAddress = ucArrayInfo(ArrayIndex, ucArray_DataAddress)
   ElementSize = ucArrayInfo(ArrayIndex, ucArray_ElementSize)
   LowerBound = ucLowerBound(ArrayIndex)
   UpperBound = ucUpperBound(ArrayIndex)
   Guess = ucParam(2, t)
    
   ReDim ValueArray(LowerBound To UpperBound) As Double
   
   CopyMemory ValueArray(LowerBound), ByVal DataAddress, (UpperBound - LowerBound + 1) * ElementSize
    
   ucIRR = IRR(ValueArray(), Guess)
End Function

Function ucMIRR(t As ucThreadType) As Double
   Dim DataAddress As Long, LowerBound As Long, UpperBound As Long, ElementSize As Long
   Dim Finance_Rate As Double, ReInvest_Rate As Double, ArrayIndex As Long
    
   ArrayIndex = ucParam(1, t)
   DataAddress = ucArrayInfo(ArrayIndex, ucArray_DataAddress)
   ElementSize = ucArrayInfo(ArrayIndex, ucArray_ElementSize)
   LowerBound = ucLowerBound(ArrayIndex)
   UpperBound = ucUpperBound(ArrayIndex)
   Finance_Rate = ucParam(2, t)
   ReInvest_Rate = ucParam(3, t)
    
   ReDim ValueArray(LowerBound To UpperBound) As Double
    
   CopyMemory ValueArray(LowerBound), ByVal DataAddress, (UpperBound - LowerBound + 1) * ElementSize
    
   ucMIRR = MIRR(ValueArray(), Finance_Rate, ReInvest_Rate)
End Function

Function ucNPer(t As ucThreadType) As Double
   Dim Rate As Double, Pmt As Double, PV As Double, FV As Double, fType As Long

   Rate = ucParam(1, t)
   Pmt = ucParam(2, t)
   PV = ucParam(3, t)
   FV = ucParam(4, t)
   fType = ucParam(5, t)
    
   ucNPer = Nper(Rate, Pmt, PV, FV, fType)
End Function

Function ucNPV(t As ucThreadType) As Double
   Dim DataAddress As Long, LowerBound As Long, UpperBound As Long
   Dim ArrayIndex As Long, Rate As Double, ElementSize As Long
    
   Rate = ucParam(1, t)
   ArrayIndex = ucParam(2, t)
   DataAddress = ucArrayInfo(ArrayIndex, ucArray_DataAddress)
   ElementSize = ucArrayInfo(ArrayIndex, ucArray_ElementSize)
   LowerBound = ucLowerBound(ArrayIndex)
   UpperBound = ucUpperBound(ArrayIndex)
    
   ReDim ValueArray(LowerBound To UpperBound) As Double
    
   CopyMemory ValueArray(LowerBound), ByVal DataAddress, (UpperBound - LowerBound + 1) * ElementSize
    
   ucNPV = NPV(Rate, ValueArray())
End Function

Function ucPmt(t As ucThreadType) As Double
   Dim Rate As Double, Nper As Integer, PV As Double, FV As Double, fType As Long
    
   Rate = ucParam(1, t)
   Nper = ucParam(2, t)
   PV = ucParam(3, t)
   FV = ucParam(4, t)
   fType = ucParam(5, t)
    
   ucPmt = Pmt(Rate, Nper, PV, FV, fType)
End Function

Function ucPPmt(t As ucThreadType) As Double
   Dim Rate As Double, Per As Integer, Nper As Integer
   Dim PV As Double, FV As Double, fType As Long
    
   Rate = ucParam(1, t)
   Per = ucParam(2, t)
   Nper = ucParam(3, t)
   PV = ucParam(4, t)
   FV = ucParam(5, t)
   fType = ucParam(6, t)
    
   ucPPmt = PPmt(Rate, Per, Nper, PV, FV, fType)
End Function

Function ucPV(t As ucThreadType) As Double
   Dim Rate As Double, Nper As Integer, Pmt As Double, FV As Double, fType As Long
    
   Rate = ucParam(1, t)
   Nper = ucParam(2, t)
   Pmt = ucParam(3, t)
   FV = ucParam(4, t)
   fType = ucParam(5, t)
    
   ucPV = PV(Rate, Nper, Pmt, FV, fType)
End Function

Function ucRate(t As ucThreadType) As Double
   Dim Nper As Double, Pmt As Double, PV As Double, FV As Double
   Dim fType As Integer, Guess As Double
    
   Nper = ucParam(1, t)
   Pmt = ucParam(2, t)
   PV = ucParam(3, t)
   FV = ucParam(4, t)
   fType = ucParam(5, t)
   Guess = ucParam(6, t)
    
   ucRate = Rate(Nper, Pmt, PV, FV, fType, Guess)
End Function

Function ucSLN(t As ucThreadType) As Double
   Dim Cost As Double, Salvage As Double, Life As Double
    
   Cost = ucParam(1, t)
   Salvage = ucParam(2, t)
   Life = ucParam(3, t)
    
   ucSLN = SLN(Cost, Salvage, Life)
End Function

Function ucSYD(t As ucThreadType) As Double
   Dim Cost As Double, Salvage As Double, Life As Double, Period As Double
    
   Cost = ucParam(1, t)
   Salvage = ucParam(2, t)
   Life = ucParam(3, t)
   Period = ucParam(4, t)
    
   ucSYD = SYD(Cost, Salvage, Life, Period)
End Function

' Miscellaneous
Function ucQBColor(t As ucThreadType) As Double
   ucQBColor = QBColor(ucParam(1, t))
End Function

Function ucRGB(t As ucThreadType) As Double
   ucRGB = RGB(ucParam(1, t), ucParam(2, t), ucParam(3, t))
End Function

Function ucEnviron(t As ucThreadType) As Double
   ucReturnStr Environ$(ucParam(1, t)), t
End Function

Function ucEnviron2(t As ucThreadType) As Double
   ucReturnStr Environ$(ucParamStr(1, t)), t
End Function

Function ucFix(t As ucThreadType) As Double
   ucFix = Fix(ucParam(1, t))
End Function

Function ucChr(t As ucThreadType) As Double
   ucReturnStr Chr$(ucParam(1, t)), t
End Function

Function ucHex(t As ucThreadType) As Double
   ucReturnStr Hex$(ucParam(1, t)), t
End Function

Function ucOct(t As ucThreadType) As Double
   ucReturnStr Oct$(ucParam(1, t)), t
End Function

' String routines
Function ucStrComp(t As ucThreadType) As Double
   ucStrComp = StrComp(ucParamStr(1, t), ucParamStr(2, t), ucParam(3, t))
End Function

Function ucStrConv(t As ucThreadType) As Double
   ucReturnStr StrConv(ucParamStr(1, t), ucParam(2, t)), t
End Function

Function ucFormat(t As ucThreadType) As Double
   ucReturnStr Format$(ucParamStr(1, t), ucParamStr(2, t), ucParam(3, t), ucParam(4, t)), t
End Function

Function ucFormat2(t As ucThreadType) As Double
   ucReturnStr Format$(ucParam(1, t), ucParamStr(2, t), ucParam(3, t), ucParam(4, t)), t
End Function

Function ucUCase(t As ucThreadType) As Double
   ucReturnStr UCase$(ucParamStr(1, t)), t
End Function

Function ucLCase(t As ucThreadType) As Double
   ucReturnStr LCase$(ucParamStr(1, t)), t
End Function

Function ucSpace(t As ucThreadType) As Double
   ucReturnStr Space$(ucParam(1, t)), t
End Function

Function ucString(t As ucThreadType) As Double
   ucReturnStr String$(ucParam(1, t), ucParamStr(2, t)), t
End Function

Function ucString2(t As ucThreadType) As Double
   ucReturnStr String$(ucParam(1, t), ucParam(2, t)), t
End Function

Function ucLen(t As ucThreadType) As Double
   ucLen = Len(ucParamStr(1, t))
End Function

Function ucInstr(t As ucThreadType) As Double
   ucInstr = InStr(ucParamStr(1, t), ucParamStr(2, t))
End Function

Function ucInstr2(t As ucThreadType) As Double
   ucInstr2 = InStr(ucParam(1, t), ucParamStr(2, t), ucParamStr(3, t), ucParam(4, t))
End Function

Function ucLeft(t As ucThreadType) As Double
   ucReturnStr Left$(ucParamStr(1, t), ucParam(2, t)), t
End Function

Function ucLTrim(t As ucThreadType) As Double
   ucReturnStr LTrim$(ucParamStr(1, t)), t
End Function

Function ucRTrim(t As ucThreadType) As Double
   ucReturnStr RTrim$(ucParamStr(1, t)), t
End Function

Function ucTrim(t As ucThreadType) As Double
   ucReturnStr Trim$(ucParamStr(1, t)), t
End Function

Function ucMid(t As ucThreadType) As Double
   If ucParam(3, t) = -1 _
   Then ucReturnStr Mid$(ucParamStr(1, t), ucParam(2, t)), t _
   Else ucReturnStr Mid$(ucParamStr(1, t), ucParam(2, t), ucParam(3, t)), t
End Function

Function ucRight(t As ucThreadType) As Double
   ucReturnStr Right$(ucParamStr(1, t), ucParam(2, t)), t
End Function

Function ucAsc(t As ucThreadType) As Double
   ucAsc = Asc(ucParamStr(1, t))
End Function

Function ucStr(t As ucThreadType) As Double
   ucReturnStr Str$(ucParam(1, t)), t
End Function

Function ucLike(t As ucThreadType) As Double
   ucLike = t.ucProperty.RelationalTrue * Abs(ucParamStr(1, t) Like ucParamStr(2, t))
End Function

Function ucVal(t As ucThreadType) As Double
   ucVal = Val(ucParamStr(1, t))
End Function

' Files and directories
Function ucCurDir(t As ucThreadType) As Double
   ucReturnStr CurDir$(ucParamStr(1, t)), t
End Function

Function ucFileDateTime(t As ucThreadType) As Double
   ucReturnStr FileDateTime(ucParamStr(1, t)), t
End Function

Function ucGetAttr(t As ucThreadType) As Double
   ucGetAttr = GetAttr(ucParamStr(1, t))
End Function

Function ucFileLen(t As ucThreadType) As Double
   ucFileLen = FileLen(ucParamStr(1, t))
End Function

Function ucDir(t As ucThreadType) As Double
   If ucParam(2, t) = -1 _
   Then ucReturnStr Dir$(ucParamStr(1, t)), t _
   Else ucReturnStr Dir$(ucParamStr(1, t), ucParam(2, t)), t
End Function
