VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ucVbLibrary"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' -------------------------------------------------------------------------
' ucvblib.cls : Visual Basic add-on library Module source code.
' This, along with ucvblib.bas compiles to ucvblib.dll
' Designed to work with Visual Basic 5.0 or above.
'
' Redistribution of this file is not allowed.
'
' UCalc Fast Math Parser (Beta J)
' Copyright (c) 1998-2004 by Daniel Corbier.  All rights reserved.
' http://www.ucalc.com/mathparser
' -------------------------------------------------------------------------

Option Explicit
Private Declare Sub ucSetPropertiesEE Lib "ucalcfmp.dll" (ByVal ucProperty As Long)

Public Sub ucVbLibInit()
   ' +++ Data type key summary also
    
'  Note: Need to temporarily make ucDefineFunction public to compile this
   ' String routines
   ucDefineFunction "StrComp(string1$, string2$, compare=0)", AddressOf ucStrComp
   ucDefineFunction "StrConv$(string$, conversion)", AddressOf ucStrConv
   ' +++ Check format when = ""
   ucDefineFunction "Format$(expression$, format$='', firstdayofweek=0, firstweekofyear=0)", AddressOf ucFormat
   ucDefineFunction "Format$(expression, format$='', firstdayofweek=0, firstweekofyear=0)", AddressOf ucFormat2
   ucDefineFunction "UCase$(text$)", AddressOf ucUCase
   ucDefineFunction "LCase$(text$)", AddressOf ucLCase
   ucDefineFunction "Space$(number)", AddressOf ucSpace
   ucDefineFunction "String$(number, character$)", AddressOf ucString
   ucDefineFunction "String$(number, CharValue)", AddressOf ucString2
   ucDefineFunction "Len(text$)", AddressOf ucLen
   ucDefineFunction "Instr(string1$, string2$)", AddressOf ucInstr
   ucDefineFunction "Instr(start, string1$, string2$, compare=0)", AddressOf ucInstr2
   ucDefineFunction "Left$(text$, length)", AddressOf ucLeft
   ucDefineFunction "LTrim$(text$)", AddressOf ucLTrim
   ucDefineFunction "RTrim$(text$)", AddressOf ucRTrim
   ucDefineFunction "Trim$(text$)", AddressOf ucTrim
   ucDefineFunction "Mid$(string$, start, length=-1)", AddressOf ucMid
   ucDefineFunction "Right$(text$, length)", AddressOf ucRight
   ucDefineFunction "Asc(character$)", AddressOf ucAsc
   ucDefineFunction "Str$(number)", AddressOf ucStr
   ucDefineFunction "Like[string$, pattern$]", AddressOf ucLike
   ucDefineFunction "Val(string$)", AddressOf ucVal

   ' Miscellaneous
   ucDefineFunction "QBColor(color)", AddressOf ucQBColor
   ucDefineFunction "RGB(red, green, blue)", AddressOf ucRGB
   ucDefineFunction "Environ(number)", AddressOf ucEnviron
   ucDefineFunction "Environ(envstring$)", AddressOf ucEnviron2
   ucDefineFunction "Fix(number)", AddressOf ucFix
   ucDefineFunction "Chr$(number)", AddressOf ucChr
   ucDefineFunction "Hex$(number)", AddressOf ucHex
   ucDefineFunction "Oct$(number)", AddressOf ucOct
    
   ' Date routines
   ucDefineFunction "Hour(time)", AddressOf ucHour1
   ucDefineFunction "Hour(time$)", AddressOf ucHour2
   ucDefineFunction "Minute(time)", AddressOf ucMinute1
   ucDefineFunction "Minute(time$)", AddressOf ucMinute2
   ucDefineFunction "Second(time)", AddressOf ucSecond1
   ucDefineFunction "Second(time$)", AddressOf ucSecond2
   ucDefineFunction "Day(date)", AddressOf ucDay1
   ucDefineFunction "Day(date$)", AddressOf ucDay2
   ucDefineFunction "Month(date)", AddressOf ucMonth1
   ucDefineFunction "Month(date$)", AddressOf ucMonth2
   ucDefineFunction "WeekDay(date, firstdayofweek=1)", AddressOf ucWeekday1
   ucDefineFunction "WeekDay(date$, firstdayofweek=1)", AddressOf ucWeekday2
   ucDefineFunction "Year(date)", AddressOf ucYear1
   ucDefineFunction "Year(date$)", AddressOf ucYear2
   ucDefineFunction "Date$()", AddressOf ucDate
   ucDefineFunction "Time$()", AddressOf ucTime
   ucDefineFunction "Now$()", AddressOf ucNow
   ucDefineFunction "Timer()", AddressOf ucTimer
   ucDefineFunction "DateAdd$(Interval$, Number, Date$)", AddressOf ucDateAdd
   ucDefineFunction "DateDiff(Interval$, Date1$, Date2$, FDW=1, FWY=1)", AddressOf ucDateDiff
   ucDefineFunction "DatePart$(Interval$, Date$, FDW=1, FWY=1)", AddressOf ucDatePart
   ucDefineFunction "DateSerial$(Year, Month, Day)", AddressOf ucDateSerial
   ucDefineFunction "TimeSerial$(Hour, Minute, Second)", AddressOf ucTimeSerial
   ucDefineFunction "DateValue(Date$)", AddressOf ucDateValue
   ucDefineFunction "TimeValue(Time$)", AddressOf ucTimeValue
'+++   ucDefineFunction "Day()", AddressOf
' ... Day, Month, Year, Weekday
    
   ' Financial routines
   ucDefineFunction "DDB(cost, salvage, life, period, factor=2)", AddressOf ucDDB
   ucDefineFunction "FV(rate, nper, pmt, pv=0, type=0)", AddressOf ucFV
   ucDefineFunction "IPmt(rate, per, nper, pv, fv=0, type=0)", AddressOf ucIPmt
   ucDefineFunction "IRR(values(), guess=0.1)", AddressOf ucIRR
   ucDefineFunction "MIRR(values(), finance_rate, reinvest_rate)", AddressOf ucMIRR
   ucDefineFunction "NPer(rate, pmt, pv, fv=0, type=0)", AddressOf ucNPer
   ucDefineFunction "NPV(rate, values())", AddressOf ucNPV
   ucDefineFunction "Pmt(rate, nper, pv, fv=0, type=0)", AddressOf ucPmt
   ucDefineFunction "PPmt(rate, per, nper, pv, fv=0, type=0)", AddressOf ucPPmt
   ucDefineFunction "PV(rate, nper, pmt, fv=0, type=0)", AddressOf ucPV
   ucDefineFunction "Rate(nper, pmt, pv, fv=0, type=0, guess=0.1)", AddressOf ucRate
   ucDefineFunction "SLN(cost, salvage, life)", AddressOf ucSLN
   ucDefineFunction "SYD(cost, salvage, life, period)", AddressOf ucSYD
    
   ' Files and directories
   ucDefineFunction "CurDir$(drive$)", AddressOf ucCurDir
   ucDefineFunction "FileDateTime$(pathname$)", AddressOf ucFileDateTime
   ucDefineFunction "GetAttr(pathname$)", AddressOf ucGetAttr
   ucDefineFunction "FileLen(pathname$)", AddressOf ucFileLen
   ucDefineFunction "Dir$(pathname$, attributes=-1)", AddressOf ucDir
   
'+++   ucSetPropertiesEE TempProperties
End Sub

Private Sub Class_Initialize()
   ucInitialized = True
End Sub

