// ucalc.cpp : Implementation file
// Designed to work with 32-bit MS Visual C++ and Borland C++ Builder.
//
// UCalc Fast Math Parser (Beta J)
// Copyright (c) 1998-2004 by Daniel Corbier.  All rights reserved.
// http://www.ucalc.com/mathparser

#include "ucalc.h"

long ucInitialized = 0;
long ucLoadLibFailed;

ucThreadType t0;
ucHandleType *ucItem;

UCARRAYINFOE ucArrayInfoE;
UCALIASE ucAliasE;
UCDETACHSYMBOLE ucDetachSymbolE;
UCDEFINEFUNCTIONE ucDefineFunctionE;
UCDEFINEVARIABLEE ucDefineVariableE;
UCERRORCLEARE ucErrorClearE;
UCEVALE ucEvalE;
UCEVALSTRE ucEvalStrE;
UCEVALUATEE ucEvaluateE;
UCEVALUATEINITE ucEvaluateInitE;
UCEVALUATESTRE ucEvaluateStrE;
UCGETERRORDATAE ucGetErrorDataE;
UCGETPARAME ucGetParamE;
UCGETPARAMCPLXE ucGetParamCplxE;
UCGETPARAMSTRE ucGetParamStrE;
UCTHREADADDRE ucThreadAddrE;
UCTREEGETPARAME ucTreeGetParamE;
UCTREEPROPERTYE ucTreePropertyE;
UCGETTHREADINFOE ucGetThreadInfoE;
UCGETVARIABLEVALUEE ucGetVariableValueE;
UCGETVARIABLEVALUESTRE ucGetVariableValueStrE;
UCIMAGPARTE ucImagPartE;
UCLICENSEE ucLicenseE;
UCLOWERBOUNDE ucLowerBoundE;
UCNEWTHREADE ucNewThreadE;
UCNEWSYMBOLHANDLEE ucNewSymbolHandleE;
UCPARAMHANDLEE ucParamHandleE;
UCPARAMTYPEE ucParamTypeE;
UCPARSEE ucParseE;
UCPRECEDENCEE ucPrecedenceE;
UCSETCALLBACKE ucSetCallbackE;
UCRELEASEEXPRPTRE ucReleaseExprPtrE;
UCRELEASEITEME ucReleaseItemE;
UCRELEASETHREADE ucReleaseThreadE;
UCRESETE ucResetE;
UCRETURNE ucReturnE;
UCRETURNCPLXE ucReturnCplxE;
UCRETURNSTRE ucReturnStrE;
UCSETERRORDATAE ucSetErrorDataE;
UCSETPARAMSTRE ucSetParamStrE;
UCTREESETPARAME ucTreeSetParamE;
UCSETTHREADADDRE ucSetThreadAddrE;
UCSETTRIGMODEE ucSetTrigModeE;
UCSETVARIABLEVALUEE ucSetVariableValueE;
UCSETVARIABLEVALUESTRE ucSetVariableValueStrE;
UCSYMBOLHANDLEE ucSymbolHandleE;
UCUPPERBOUNDE ucUpperBoundE;

long ucEvaluateInit()
{
   HINSTANCE hDLL;
   HINSTANCE hDLLe;
   long HostFPUWord;

   hDLL  = LoadLibrary("ucalcfmp.dll");
   hDLLe = LoadLibrary("ucalcfme.dll");
   if ((hDLL == NULL) || (hDLLe == NULL))
   {
      ucLoadLibFailed = 1;
      return 0;
      // Host program should check LoadLibraryFailed() before continuing
   }

   ucArrayInfoE = (UCARRAYINFOE)GetProcAddress(hDLL,"ucArrayInfoE");
   ucAliasE = (UCALIASE)GetProcAddress(hDLL,"ucAliasE");
   ucDetachSymbolE = (UCDETACHSYMBOLE)GetProcAddress(hDLL,"ucDetachSymbolE");
   ucDefineFunctionE = (UCDEFINEFUNCTIONE)GetProcAddress(hDLL,"ucDefineFunctionE");
   ucDefineVariableE = (UCDEFINEVARIABLEE)GetProcAddress(hDLL,"ucDefineVariableE");
   ucErrorClearE = (UCERRORCLEARE)GetProcAddress(hDLL,"ucErrorClearE");
   ucEvalE = (UCEVALE)GetProcAddress(hDLL,"ucEvalE");
   ucEvalStrE = (UCEVALSTRE)GetProcAddress(hDLL,"ucEvalStrE");
   ucEvaluateStrE = (UCEVALUATESTRE)GetProcAddress(hDLL,"ucEvaluateStrE");
   ucGetErrorDataE = (UCGETERRORDATAE)GetProcAddress(hDLL,"ucGetErrorDataE");
   ucGetParamE = (UCGETPARAME)GetProcAddress(hDLL,"ucGetParamE");
   ucGetParamCplxE = (UCGETPARAMCPLXE)GetProcAddress(hDLL,"ucGetParamCplxE");
   ucGetParamStrE = (UCGETPARAMSTRE)GetProcAddress(hDLL,"ucGetParamStrE");
   ucTreeGetParamE = (UCTREEGETPARAME)GetProcAddress(hDLL,"ucTreeGetParamE");
   ucTreePropertyE = (UCTREEPROPERTYE)GetProcAddress(hDLL,"ucTreePropertyE");
   ucGetThreadInfoE = (UCGETTHREADINFOE)GetProcAddress(hDLL,"ucGetThreadInfoE");
   ucGetVariableValueE = (UCGETVARIABLEVALUEE)GetProcAddress(hDLL,"ucGetVariableValueE");
   ucGetVariableValueStrE = (UCGETVARIABLEVALUESTRE)GetProcAddress(hDLL,"ucGetVariableValueStrE");
   ucImagPartE = (UCIMAGPARTE)GetProcAddress(hDLL,"ucImagPartE");
   ucLicenseE = (UCLICENSEE)GetProcAddress(hDLL,"ucLicenseE");
   ucLowerBoundE = (UCLOWERBOUNDE)GetProcAddress(hDLL,"ucLowerBoundE");
   ucNewThreadE = (UCNEWTHREADE)GetProcAddress(hDLL,"ucNewThreadE");
   ucNewSymbolHandleE = (UCNEWSYMBOLHANDLEE)GetProcAddress(hDLL,"ucNewSymbolHandleE");
   ucParamHandleE = (UCPARAMHANDLEE)GetProcAddress(hDLL,"ucParamHandleE");
   ucParamTypeE = (UCPARAMTYPEE)GetProcAddress(hDLL,"ucParamTypeE");
   ucParseE = (UCPARSEE)GetProcAddress(hDLL, "ucParseE");
   ucPrecedenceE = (UCPRECEDENCEE)GetProcAddress(hDLL, "ucPrecedenceE");
   ucSetCallbackE = (UCSETCALLBACKE)GetProcAddress(hDLL,"ucSetCallbackE");
   ucReleaseItemE = (UCRELEASEITEME)GetProcAddress(hDLL,"ucReleaseItemE");
   ucReleaseThreadE = (UCRELEASETHREADE)GetProcAddress(hDLL,"ucReleaseThreadE");
   ucResetE = (UCRESETE)GetProcAddress(hDLL,"ucResetE");
#if defined(__BORLANDC__)
   ucReturnE = (UCRETURNE)GetProcAddress(hDLL,"ucReturnE");
   ucReturnCplxE = (UCRETURNCPLXE)GetProcAddress(hDLL,"ucReturnCplxE");
#else
   ucReturnE = (UCRETURNE)GetProcAddress(hDLL,"ucReturnDblE");
   ucReturnCplxE = (UCRETURNCPLXE)GetProcAddress(hDLL,"ucReturnCplxDblE");
#endif
   ucReturnStrE = (UCRETURNSTRE)GetProcAddress(hDLL,"ucReturnStrE");
   ucSetErrorDataE = (UCSETERRORDATAE)GetProcAddress(hDLL,"ucSetErrorDataE");
   ucSetParamStrE = (UCSETPARAMSTRE)GetProcAddress(hDLL,"ucSetParamStrE");
   ucThreadAddrE = (UCTHREADADDRE)GetProcAddress(hDLL,"ucThreadAddrE");
   ucTreeSetParamE = (UCTREESETPARAME)GetProcAddress(hDLL,"ucTreeSetParamE");
   ucSetThreadAddrE = (UCSETTHREADADDRE)GetProcAddress(hDLL,"ucSetThreadAddrE");
   ucSetTrigModeE = (UCSETTRIGMODEE)GetProcAddress(hDLL,"ucSetTrigModeE");
#if defined(__BORLANDC__)
   ucSetVariableValueE = (UCSETVARIABLEVALUEE)GetProcAddress(hDLL,"ucSetVariableValueE");
#else
   ucSetVariableValueE = (UCSETVARIABLEVALUEE)GetProcAddress(hDLL,"ucSetVariableValueDblE");
#endif
   ucSetVariableValueStrE = (UCSETVARIABLEVALUESTRE)GetProcAddress(hDLL,"ucSetVariableValueStrE");
   ucSymbolHandleE = (UCSYMBOLHANDLEE)GetProcAddress(hDLL,"ucSymbolHandleE");
   ucUpperBoundE = (UCUPPERBOUNDE)GetProcAddress(hDLL,"ucUpperBoundE");

   // The following 3 routines come from ucalcfmE.dll instead of ucalcfmP.dll
   ucEvaluateE = (UCEVALUATEE)GetProcAddress(hDLLe,"ucEvaluateE");
   ucEvaluateInitE = (UCEVALUATEINITE)GetProcAddress(hDLLe,"ucEvaluateInitE");
   ucReleaseExprPtrE = (UCRELEASEEXPRPTRE)GetProcAddress(hDLLe,"ucReleaseExprPtrE");

//+++#if defined(__BORLANDC__)
   // For C++ compilers that support long double (80 bit precision).
   // This includes Borland C++ Builder.

//   HostFPUWord = Default8087CW;
//#else
   // For MS Visual C++ 6.0 and other compilers which do not support 80 bit
   // precision.  Microsoft's "long double" is really the same as "double".

   HostFPUWord = ucFPU_Round_Even
   + ucFPU_Precision_Double
   + ucFPU_ErrMask_InvalidOp
   + ucFPU_ErrMask_DenormalOp
   + ucFPU_ErrMask_ZeroDivide
   + ucFPU_ErrMask_Overflow
   + ucFPU_ErrMask_Underflow
   + ucFPU_ErrMask_PrecisionLoss;
   // Note: Although the above is the same setting as CW_DEFAULT,
   // do not set HostFPUWord = CW_DEFAULT, because the
   // HostFPUWord value is for Pentiums, and CW_DEFAULT is for the 386.
//#endif

   ucInitialized = 1;
   ucGetThreadInfo(0, t0);
   ucSetThreadAddr(0, t0);
   ucReset(t0);
// ucNewThreadE();

   t0.ucProperty.FPU_ControlWord_HostProgram = HostFPUWord;

   return 0;
}

long ucElementCategory(ucThreadType& t)
{
   return ucTreePropertyE(0, 0, ucElementCat, t);
}

long ucNewSymbolHandle(ucThreadType& t)
{
   return ucNewSymbolHandleE(t);
}

long ucParamHandle(long pIndex, ucThreadType& t)
{
   return ucParamHandleE(pIndex, t);
}

long ucParamType(long pIndex, ucThreadType& t)
{
   return ucParamTypeE(pIndex, t);
}

long double ucParam(long x, ucThreadType& t)
{
   return ucGetParamE(x, t);
}
long double ucParamCplx(long x, ucThreadType& t)
{
   return ucGetParamCplxE(x, t);
}

char* ucGetParamStr(long ParamIndex, ucThreadType& t)
{
   return ucGetParamStrE(ParamIndex, t);
}

char* ucParamStr(long ParamIndex, ucThreadType& t)
{
   return ucGetParamStrE(ParamIndex, t);
}

char* ucGetExpr(ucThreadType& t)
{
   return ucTreeGetParamE(-1, t);
}

char* ucTreeGetExpr(ucThreadType& t)
{
   return ucTreeGetParamE(-1, t);
}

char* ucTreeGetFunc(ucThreadType& t)
{
   return ucTreeGetParamE(0, t);
}

char* ucTreeGetOp(ucThreadType& t)
{
   return ucTreeGetParamE(0, t);
}

char* ucTreeGetParam(long pIndex, ucThreadType& t)
{
   return ucTreeGetParamE(pIndex, t);
}

char* ucTreeGetParamList(ucThreadType& t)
{
   return ucTreeGetParamE(-2, t);
}

void ucSetExpr(const char* Expression, ucThreadType& t)
{
   ucTreeSetParamE(-1, Expression, t);
}

void ucTreeSetExpr(const char* Expression, ucThreadType& t)
{
   ucTreeSetParamE(-1, Expression, t);
}

DWORD ucThreadAddr(long t)
{
   if (ucInitialized == 0) ucEvaluateInit();
   return ucThreadAddrE(t);
}

void ucTreeSetFunc(const char* TreeFunc, ucThreadType& t)
{
   ucTreeSetParamE(0, TreeFunc, t);
}

void ucTreeSetOp(const char* TreeOp, ucThreadType& t)
{
   ucTreeSetParamE(0, TreeOp, t);
}

void ucTreeSetParam(long pIndex, const char* pData, ucThreadType& t)
{
   ucTreeSetParamE(pIndex, pData, t);
}

void ucTreeSetParamList(const char* pData, ucThreadType& t)
{
   ucTreeSetParamE(-2, pData, t);
}

long ucTreeProperty(DWORD NodePtr, long pIndex, long pOption, ucThreadType& t)
{
   return ucTreePropertyE(NodePtr, pIndex, pOption, t);
}

long ucTreeNodeProperty(long pOption, ucThreadType& t)
{
   return ucTreePropertyE(0, 0, pOption, t);
}

long ucTreeParamProperty(long pIndex, long pOption, ucThreadType& t)
{
   return ucTreePropertyE(0, pIndex, pOption, t);
}

long ucTreeParentProperty(long pOption, ucThreadType& t)
{
   DWORD ParentPtr;

   ParentPtr = ucTreePropertyE(0, 0, ucParentPtr, t);
   return ucTreePropertyE(ParentPtr, 0, pOption, t);
}

void ucLicense(const char* SerialNumber)
{
   ucLicenseE(SerialNumber);
}

void ucSetParamStr(long ParamIndex, const char* ArgStr, ucThreadType& t)
{
   ucSetParamStrE(ParamIndex, ArgStr, t);
}

// String relational operators.  Callback code
ucNUM ucEqual(ucThreadType& t)
{
   if (strcoll(ucParamStr(1, t), ucParamStr(2, t)) == 0)
   return t.ucProperty.RelationalTrue;
   else return 0;
}

ucNUM ucNotEqual(ucThreadType& t)
{
   if (strcoll(ucParamStr(1, t), ucParamStr(2, t)) != 0)
   return t.ucProperty.RelationalTrue;
   else return 0;
}

ucNUM ucGreater(ucThreadType& t)
{
   if (strcoll(ucParamStr(1, t), ucParamStr(2, t)) > 0)
   return t.ucProperty.RelationalTrue;
   else return 0;
}

ucNUM ucGreaterOrEqual(ucThreadType& t)
{
   if (strcoll(ucParamStr(1, t), ucParamStr(2, t)) >= 0)
   return t.ucProperty.RelationalTrue;
   else return 0;
}

ucNUM ucLess(ucThreadType& t)
{
   if (strcoll(ucParamStr(1, t), ucParamStr(2, t)) < 0)
   return t.ucProperty.RelationalTrue;
   else return 0;
}

ucNUM ucLessOrEqual(ucThreadType& t)
{
   if (strcoll(ucParamStr(1, t), ucParamStr(2, t)) <= 0)
   return t.ucProperty.RelationalTrue;
   else return 0;
}

void ucReturn(long double vValue, ucThreadType& t)
{
   ucReturnE(vValue, t);
}
void ucReturnCplx(long double vValue, ucThreadType& t)
{
   ucReturnCplxE(vValue, t);
}

void ucReturnStr(const char* Expression, ucThreadType& t)
{
   ucReturnStrE(Expression, t);
}

void ucSetThreadAddr(long ucThread, ucThreadType& t)
{
   ucSetThreadAddrE(ucThread, t);
}

void ucSetTrigMode(long TrigMode, ucThreadType& t)
{
   ucSetTrigModeE(TrigMode, ucThreadAddr(t.ucThread));
}

void ucSetErrorData(long errIndex, const char* vValue, ucThreadType& t)
{
   ucSetErrorDataE(errIndex, vValue, t);
}



//  These function definitions are for single-thread and/or startup usage only

DWORD ucArrayInfo(long VarHandle, long InfoOption)
{
   return ucArrayInfoE(VarHandle, InfoOption);
}

long ucDefineConstant(const char* ConstantDef, long vProperties = 0)
{
   return ucDefineVariableE(ConstantDef, 0, 0, vProperties, ucType_Constant, ucThreadAddr(0));
}

long ucDefineFunction(const char* FunctionDef, void *FunctionAddress = 0, long fProperties = 0, long vType = ucType)
{
   return ucDefineFunctionE(FunctionDef, reinterpret_cast<DWORD>(FunctionAddress), 0, fProperties, vType, ucThreadAddr(0));
}

long ucDefineOperator(const char* OperatorDef, long Precedence = 0, void *OperatorAddress = 0, long fProperties = 0, long vType = ucType)
{
   return ucDefineFunctionE(OperatorDef, reinterpret_cast<DWORD>(OperatorAddress), Precedence, fProperties, vType, ucThreadAddr(0));
}

long ucDefineVariable(const char* VariableDef, long vProperties = 0, long ucThread = 0)
{
   return ucDefineVariableE(VariableDef, 0, 0, vProperties, ucType_Internal, ucThreadAddr(ucThread));
}

long ucAttachVariable(const char* VariableDef, void* vPtr, DWORD ExprPtr = 0, long vProperties = 0, long t = 0)
{
   return ucDefineVariableE(VariableDef, reinterpret_cast<DWORD>(vPtr), ExprPtr, vProperties, ucType, ucThreadAddr(t));
}

long ucError(void)
{   
   return t0.ErrorNumber;
}

char* ucErrorData(long errIndex, long t = 0)
{
   return ucGetErrorDataE(errIndex, ucThreadAddr(t));
}

long double ucEval(const char* Expression, long t = 0)
{
   return ucEvalE(Expression, ucThreadAddr(t));
}

char* ucEvalStr(const char* Expression, long t = 0)
{
   return ucEvalStrE(Expression, ucThreadAddr(t));
}

long double ucEvaluate(DWORD ExpressionPtr)
{
   return ucEvaluateE(ExpressionPtr);
}

long double ucEvaluate(DWORD ExpressionPtr, ucComplexNumberType& ucValue, long t = 0)
{
   long double ucResult;

   ucResult = ucEvaluateE(ExpressionPtr);
   ucValue.Real = ucResult;
   ucValue.Imag = ucImagPartE(ucThreadAddr(t));

   return ucResult;
}

long double ucEvaluateCplx(DWORD ExpressionPtr, ucComplexNumberType& ucValue, long t = 0)
{
   long double ucResult;

   ucResult = ucEvaluateE(ExpressionPtr);
   ucValue.Real = ucResult;
   ucValue.Imag = ucImagPartE(ucThreadAddr(t));

   return ucResult;
}

char* ucEvaluateStr(DWORD ExpressionPtr)
{
   return ucEvaluateStrE(ExpressionPtr);
}

char* ucGetErrorData(long errIndex, long t = 0)
{
   return ucGetErrorDataE(errIndex, ucThreadAddr(t));
}

DWORD ucGetThreadInfo(long ucThread, ucThreadType& t)
{
   return ucGetThreadInfoE(ucThread, t);
}

long double ucGetVariableValue(long VarHandle)
{
   return ucGetVariableValueE(VarHandle);
}

char* ucGetVariableValueStr(long VarHandle)
{
   return ucGetVariableValueStrE(VarHandle);
}

char* ucVariableValueStr(long VarHandle)
{
   return ucGetVariableValueStrE(VarHandle);
}

long double ucImagPart(long t = 0)
{
   return ucImagPartE(ucThreadAddr(t));
}

long ucLowerBound(long VarHandle, long Dimension = 1)
{
   return ucLowerBoundE(VarHandle, Dimension);
}

DWORD ucParse(const char* Expression, const char* LocalVars = "", long ExprType = 0)
{
   return ucParseE(Expression, LocalVars, ExprType, ucThreadAddr(0));
}

long ucPrecedence(const char* Op, long OpCategory = 0, long t = 0)
{
   return ucPrecedenceE(Op, OpCategory, ucThreadAddr(t));
}

long ucUpperBound(long VarHandle, long Dimension = 1)
{
   return ucUpperBoundE(VarHandle, Dimension);
}

long ucSymbolHandle(const char* ucSymbol, long SymbolProperty = 0, long t = 0)
{
   return ucSymbolHandleE(ucSymbol, SymbolProperty, ucThreadAddr(t));
}


long ucAlias(const char* AssignFrom, const char* AssignTo)
{
   return ucAliasE(AssignFrom, AssignTo, ucThreadAddr(0));
}

void ucDetachSymbol(const char* Symbol, long t = 0)
{
   ucDetachSymbolE(Symbol, ucThreadAddr(t));
}

void ucErrorClear(long t = 0)
{
   ucErrorClearE(ucThreadAddr(t));
}

long ucErrorHandler(void *FunctionAddress)
{
   return ucSetCallbackE(reinterpret_cast<DWORD>(FunctionAddress), ucErrorCallback, ucThreadAddr(0));
}

long ucPreParse(void *FunctionAddress)
{
   return ucSetCallbackE(reinterpret_cast<DWORD>(FunctionAddress), ucTreePre, ucThreadAddr(0));
}

long ucTreeParseDownRaw(void *FunctionAddress)
{
   return ucSetCallbackE(reinterpret_cast<DWORD>(FunctionAddress), ucTreeDownRaw, ucThreadAddr(0));
}

long ucTreeParseDown(void *FunctionAddress)
{
   return ucSetCallbackE(reinterpret_cast<DWORD>(FunctionAddress), ucTreeDown, ucThreadAddr(0));
}

long ucTreeParseUp(void *FunctionAddress)
{
   return ucSetCallbackE(reinterpret_cast<DWORD>(FunctionAddress), ucTreeUp, ucThreadAddr(0));
}

void ucReleaseItem(long ItemHandle)
{
   ucReleaseItemE(ItemHandle);
}

void ucReleaseExprPtr(DWORD ExpressionPtr)
{
   ucReleaseExprPtrE(ExpressionPtr);
}

void ucSetVariableValue(long VarHandle, long double vValue)
{
   ucSetVariableValueE(VarHandle, vValue);
}

void ucSetVariableValueStr(long VarHandle, const char* vValue)
{
   ucSetVariableValueStrE(VarHandle, vValue);
}

void ucReset(ucThreadType& t)
{
   long TempContext, Between_Mult_Pow, Between_And_Less;

   ucItem = (ucHandleType *)calloc(1+t.ucProperty.DefSpace.BaseDefinitionSpace
             +t.ucProperty.DefSpace.DefinitionSpace
             *t.ucProperty.DefSpace.MaxThreadCount, sizeof(ucHandleType));

   TempContext = t.Context;   
   t.Context = t.Context | ucContext_ucReset;
   t.Handshake.LanguageID = uc_Lang_CPlusPlus;
   t.Handshake.HandleAddr = (unsigned long)ucItem;

   ucEvaluateInitE();
   ucResetE(t);

   t.ucProperty.ComplexNumbers = ucTrue;
   t.ucProperty.FunctionProperties = ucInline+ucLocked+ucOverride+ucOverload;

   Between_Mult_Pow = (ucPrecedence("*") + ucPrecedence("^")) / 2;
   Between_And_Less = (ucPrecedence("AND") + ucPrecedence("<")) / 2;


   // String relational (comparison) operators
   ucDefineOperator(" =[a$,b$]", ucPrecedence("="),  ucEqual);
   ucDefineOperator("<>[a$,b$]", ucPrecedence("<>"), ucNotEqual);
   ucDefineOperator(" >[a$,b$]", ucPrecedence(">"),  ucGreater);
   ucDefineOperator(">=[a$,b$]", ucPrecedence(">="), ucGreaterOrEqual);
   ucDefineOperator(" <[a$,b$]", ucPrecedence("<"),  ucLess);
   ucDefineOperator("<=[a$,b$]", ucPrecedence("<="), ucLessOrEqual);

   // Alternative notations
//   ucDefineOperator("  &[a,b] = a and b", ucPrecedence("and"));
//   ucDefineOperator("  |[a,b] = a or  b", ucPrecedence("or "));
//   ucDefineOperator(" =<[a,b] = a <=  b", ucPrecedence("<= "));
//   ucDefineOperator(" =>[a,b] = a >=  b", ucPrecedence(">= "));
   ucDefineOperator(" ==[a,b] = a  =  b", ucPrecedence("="));
   ucDefineOperator("DIV[a,b] = a \\  b", ucPrecedence("\\"));
   ucDefineOperator("**[a,b]  = a  ^  b", ucPrecedence("^"));
   ucDefineOperator(" &$[TextA$,TextB$] = TextA + TextB", ucPrecedence("+"));
   ucDefineOperator("==[TextA$,TextB$] = TextA = TextB", ucPrecedence("="));
   ucDefineFunction("Concatenate$(a$,b$) = a + b");
   ucDefineFunction("RND()   = RND(1)");
   ucDefineFunction("Sign(x) = Sgn(x)");
   ucDefineFunction("Sqrt(x) = Sqr(x)");
   ucDefineFunction("Ln(x)   = Log(x)");
   ucDefineFunction("Atan(x) = Atn(x)");
   ucDefineOperator("[x]! = fact(x)", t.PrecedenceMax);
   ucDefineOperator("[x]% = x/100", t.PrecedenceMax);
   ucDefineOperator("%[x,y] = x mod y", ucPrecedence("MOD"));
   ucDefineOperator("-[x] = 0-x", Between_Mult_Pow);
   ucDefineOperator("+[x] = 0+x", Between_Mult_Pow);
   ucDefineOperator("Not[x] = Not(x)", Between_And_Less);

   // FPU routines
   ucDefineFunction("GetFPU() = GetFPU(0)");
   ucDefineFunction("RestoreFPU() = RestoreFPU(0)");
   ucAlias("GetFPU", "GetFPU(0)");
   ucAlias("RestoreFPU", "RestoreFPU(0)");
   ucAlias("SetFPU(setting, Expression)",   "(SetFPU(setting)+(Expression)+RestoreFPU(0))");
   ucAlias("SetOrFPU(setting, Expression)", "(SetOrFPU(setting)+(Expression)+RestoreFPU(0))");
   ucAlias("SetXorFPU(setting, Expression)","(SetXorFPU(setting)+(Expression)+RestoreFPU(0))");

   ucDefineFunction("Inf() = SetOrFPU(4, 1/0)", 0, ucDynamic);
   ucDefineFunction("NaN() = SetOrFPU(1, 0/0)", 0, ucDynamic);

   // Hyperbolic functions
   ucDefineFunction("Sinh(x)  = (exp(x) - exp(-x)) / 2");
   ucDefineFunction("Cosh(x)  = (exp(x) + exp(-x)) / 2");
   ucDefineFunction("Tanh(x)  = (exp(2x) - 1) / (exp(2x) + 1)");
   ucDefineFunction("Coth(x)  = (exp(2x) + 1) / (exp(2x) - 1)");
   ucDefineFunction("Sech(x)  = 2 / (exp(x) + exp(-x))");
   ucDefineFunction("Csch(x)  = 2 / (exp(x) - exp(-x))");
   ucDefineFunction("Asinh(x) = Log(x + Sqr(x ^ 2 + 1))");
   ucDefineFunction("Acosh(x) = Log(x + Sqr(x ^ 2 - 1))");
   ucDefineFunction("Atanh(x) = Log((1 + x) / (1 - x)) / 2");
   ucDefineFunction("Acoth(x) = Log((x + 1) / (x - 1)) / 2");
   ucDefineFunction("Asech(x) = Log((1 + Sqr(1 - x ^ 2)) / x)");
   ucDefineFunction("Acsch(x) = Log(1 / x + Sqr(1 + x ^ 2) / Abs(x))");

   // A few constants needed in some definitions further down
   ucDefineConstant("Pi     = Atn(1) * 4");
   ucDefineConstant("HalfPI = Pi/2");

   // Other functions
   ucDefineFunction("Sec(x)   = 1 / Cos(x)");
   ucDefineFunction("Csc(x)   = 1 / Sin(x)");
   ucDefineFunction("Cot(x)   = 1 / Tan(x)");
   ucDefineFunction("Asin(x)  = SetOrFPU(4, Atn(x / Sqr(1 - x * x)))"); // +++ make provisions for complex
   ucDefineFunction("Acos(x)  = HalfPI - Asin(x)");
   ucDefineFunction("Log2(x)  = Log(x) / Log(2)");
   ucDefineFunction("Exp2(x)  = 2 ^ x");
   ucDefineFunction("Log10(x) = Log(x) / Log(10)");
   ucDefineFunction("Exp10(x) = 10 ^ x");

   // Complex operators & functions
   t.ucProperty.FunctionProperties = ucDynamic+ucLocked+ucOverride+ucOverload+ucComplex;
   ucDefineOperator("+[x] = x.Real + x.Imag*#i", Between_Mult_Pow);
   ucDefineOperator("-[x] = (-x.Real) + (-x.Imag)*#i", Between_Mult_Pow);

   ucDefineOperator("+[x,y] = x.Real+y.Real + (x.Imag+y.Imag)*#i", ucPrecedence("+"));
   ucDefineOperator("*[x,y] = (x.Real*y.Real - x.Imag*y.Imag)"
                    "+(x.Real*y.Imag + x.Imag*y.Real)*#i", ucPrecedence("*"));
   ucDefineOperator("-[x,y] = (x.Real-y.Real) + (x.Imag-y.Imag)*#i", ucPrecedence("-"));
   ucDefineOperator("/[x,y] = x.Real*y.Real/(y.Real^2+y.Imag^2)"
                    " + x.Imag*y.Imag/(y.Real^2+y.Imag^2)"
                    " + (x.Imag*y.Real/(y.Real^2+y.Imag^2)"
                    "-x.Real*y.Imag/(y.Real^2+y.Imag^2))*#i",
                    ucPrecedence("/"));

   t.ucProperty.FunctionProperties = ucDynamic+ucLocked+ucOverride+ucOverload+ucComplex;
   ucDefineFunction("Abs(x) = Sqr(x.Real^2 + x.Imag^2) + 0*#i");
   ucDefineFunction("Sgn(x) = x.Real/Abs(x) + x.Imag/Abs(x)*#i");   
   ucDefineFunction("Sin(x) = Sin(x.Real)*Cosh(x.Imag) + Cos(x.Real)*Sinh(x.Imag)*#i");
   ucDefineFunction("Cos(x) = Cos(x.Real)*Cosh(x.Imag) - Sin(x.Real)*Sinh(x.Imag)*#i");
   ucDefineFunction("Phase(x) = iif(x.Imag=0, iif(x.Real>0, 0, pi), atn(x.Imag/x.Real)) + 0*#i");
   ucDefineFunction("Conj(x)  = x.Real - x.Imag*#i");
   ucDefineFunction("Exp(x)   = Exp(x.Real)*Cos(x.Imag) + Exp(x.Real)*Sin(x.Imag)*#i");
   ucDefineFunction("Imag(x)  = x.Imag + 0*#i");
   ucDefineFunction("Real(x)  = x.Real + 0*#i");

   ucDefineFunction("Sqr(x)   = Sqr(Sqr(x.Real^2 + x.Imag^2)+x.Real)/Sqr(2)"
                    "+ (Sqr(Sqr(x.Real^2 + x.Imag^2)-x.Real)*iif(x.Imag < 0, -1, 1)/Sqr(2))*#i");
   ucDefineFunction("Sqrt(x)  = Sqr(x.Real+x.Imag*#i)");

   ucDefineFunction("Log(x) = iif(x.Real=0 and x.Imag=0, -Inf,"
                    "Log(x.Real^2 + x.Imag^2)/2)"
                    "+iif(x.Real=0 and x.Imag=0, 0, iif(x.Real>0 and x.Imag=0, 0,"
                    "iif(x.Imag=0, pi, pi*sgn(x.Imag)/2-Atn(x.Real/x.Imag))))*#i");

   ucDefineFunction("_ZeroToZero() = 1", 0, ucDynamic+ucOverwrite);
// ucDefineFunction("_ZeroToZero() = 0", 0, ucDynamic+ucOverwrite);
// ucDefineFunction("_ZeroToZero() = NaN", 0, ucDynamic+ucOverwrite);
// ucDefineFunction("_ZeroToZero() = SetError(1, '0^0 Error')", 0, ucDynamic+ucOverwrite);
   
   ucDefineOperator("^[x,y] = iif(x.Imag = 0, iif(x.Real > 0,"
   "x.Real^y.Real*Cos(y.Imag*Log(x.Real)),"
   "iif(x.Real=0 and y.Real=0 and y.Imag=0, _ZeroToZero(),"
   "(-x.Real)^y.Real*COS(y.Imag*LOG(-x.Real)+pi*y.Real)/EXP(pi*y.Imag))),"
   "EXP(y.Imag*ATN(x.Real/x.Imag))*SQR((x.Imag^2+x.Real^2)^y.Real)"
   "*COS(pi*y.Real*sgn(x.Imag)/2-y.Real*ATN(x.Real/x.Imag)+y.Imag"
   "*LOG(x.Imag^2+x.Real^2)/2)/SQR(EXP(pi*y.Imag*Sgn(x.Imag))))-55+55"
   "+iif(x.Imag = 0, iif(x.Real > 0,"
   "x.Real^y.Real*SIN(y.Imag*LOG(x.Real)),"
   "iif(x.Real=0 and y.Real=0 and y.Imag=0, 0,"
   "(-x.Real)^y.Real*SIN(y.Imag*LOG(-x.Real)+pi*y.Real)/EXP(pi*y.Imag))),"
   "EXP(y.Imag*ATN(x.Real/x.Imag))*SQR((x.Imag^2+x.Real^2)^y.Real)"
   "*SIN(pi*y.Real*sgn(x.Imag)/2-y.Real*ATN(x.Real/x.Imag)+y.Imag"
   "*LOG(x.Imag^2+x.Real^2)/2)/SQR(EXP(pi*y.Imag*Sgn(x.Imag)))-55+55)*#i",
     ucPrecedence("^"));

   ucDefineConstant("Byte     = ucType_Integer8");
   ucDefineConstant("Integer  = ucType_Integer16");
   ucDefineConstant("Word     = ucType_Integer16u");
   ucDefineConstant("Long     = ucType_Integer32");
   ucDefineConstant("DWord    = ucType_Integer32u");
   ucDefineConstant("Quad     = ucType_Integer64");
   ucDefineConstant("Currency = ucType_Currency");
   ucDefineConstant("CurrencyX= ucType_CurrencyExt");
   ucDefineConstant("Single   = ucType_FloatSingle");
   ucDefineConstant("Double   = ucType_FloatDouble");
   ucDefineConstant("Extended = ucType_FloatExtended");
   ucDefineConstant("AsciiZ   = ucType_StringLPSTR");
   ucDefineConstant("String   = ucType_StringAnsi");

   t.ucProperty.FunctionProperties = ucDynamic+ucOverload+ucOverwrite+ucComplex+ucRecursion;
   t.Context = TempContext;

#if defined(__BORLANDC__)
   t.ucProperty.DefaultNumericType = ucType_Extended;
#else
   t.ucProperty.DefaultNumericType = ucType_Double;
#endif
}

#ifndef ucAltErrMsg
char* ucGetErrorMessage(long ErrorNumber = -1, long t = 0)
{

   if (ErrorNumber == -1) ErrorNumber = t0.ErrorNumber;

   switch(ErrorNumber)
   {
      case 0:  return ""; // No Error
      case 1:  return ucGetErrorData(0, t);
      case 2:  return "Error #2: Syntax error";
      case 3:  return "Error #3: Mismatched parenthesis";
      case 4:  return "Error #4: Mismatched quotes";
      case 5:  return "Error #5: Undefined variable";
      case 6:  return "Error #6: Undefined function";
      case 7:  return "Error #7: Incorrect argument type";
      case 8:  return "Error #8: Invalid number of function arguments";
      case 9:  return "Error #9: Invalid operand type";
      case 10: return "Error #10: Invalid name";
      case 11: return "Error #11: Implicit multiplication error";

      case 20: return "Error #20: Invalid floating point operation";
      case 21: return "Error #21: Denormal floating point operand";
      case 22: return "Error #22: Division by 0";
      case 23: return "Error #23: Floating point overflow";
      case 24: return "Error #24: Floating point underflow";
      case 25: return "Error #25: Inexact floating point result";
      case 35: return "Error #35: Array subscript out of range";
      case 36: return "Error #36: Stack overflow";

      case 40: return "Error #40: Cannot perform requested operation";
      case 41: return "Error #41: Definition property conflict"; 
      case 42: return "Error #42: Assignment to a constant not allowed";
      case 43: return "Error #43: Invalid function or operator definition";
      case 44: return "Error #44: Function or operator is locked";      

      case 60: return "Error #60: Definition space is full";
      case 61: return "Error #61: Thread initialization failed";
      case 62: return "Error #62: Requires advanced edition of UCalc FMP";
      default: return "Unknown error";
      // numbers up to 500 are reserved for future use by UCalc
      // Use Case 501 and beyond for user-defined errors
   }
}
#endif

char* ucErrorMessage(long ErrorNumber = -1, long t = 0)
{
   return ucGetErrorMessage(ErrorNumber, t);
}

