VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "FastMath"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' -------------------------------------------------------------------------
' ucalcvb.cls : Class file
' Designed to work with Visual Basic 5.0 or above.
'
' UCalc Fast Math Parser (Beta J)
' Copyright (c) 1998-2004 by Daniel Corbier.  All rights reserved.
' http://www.ucalc.com/mathparser
' -------------------------------------------------------------------------
Option Explicit '+++

Private t As Long

Private Type ucComplexNumberType
   Real As Double
   Imag As Double
End Type

Private Sub Class_Initialize()
'   If ucInitialized = False Then
'      ucGetThreadInfo 0, t0
'      ucSetThreadInfo 0, t0
'      ucReset t0
'      ucInitialized = True
'   End If
t = 0 '+++
'   t = ucNewThread()
'   ucThreadAddr = t.Handshake.ucThreadAddr ' +++ + ucThread * Len(ucThreadTypeSize)
   If t = -1 Then Me = Nothing
End Sub

Private Sub Class_Terminate()
   ucReleaseThread t
End Sub

Public Function ucAlias(AssignFrom$, AssignTo$) As Long
   ucAlias = ucAliasE(AssignFrom$, AssignTo$, ucThreadAddr(t))
End Function

Public Sub ucDetachSymbol(Symbol$)
   ucDetachSymbolE Symbol$, ucThreadAddr(t)
End Sub

Public Sub ucErrorClear()
   ucErrorClearE ucThreadAddr(t)
End Sub

Public Function ucErrorHandler(ByVal FunctionAddress As Long) As Long
   ucErrorHandler = ucSetCallbackE(FunctionAddress, ucErrorCallback, ucThreadAddr(t))
End Function

Public Function ucPreParse(ByVal FunctionAddress As Long) As Long
   ucPreParse = ucSetCallbackE(FunctionAddress, ucTreePre, ucThreadAddr(t))
End Function

Public Function ucTreeParseDownRaw(ByVal FunctionAddress As Long) As Long
   ucTreeParseDownRaw = ucSetCallbackE(FunctionAddress, ucTreeDownRaw, ucThreadAddr(t))
End Function

Public Function ucTreeParseDown(ByVal FunctionAddress As Long) As Long
   ucTreeParseDown = ucSetCallbackE(FunctionAddress, ucTreeDown, ucThreadAddr(t))
End Function

Public Function ucTreeParseUp(ByVal FunctionAddress As Long) As Long
   ucTreeParseUp = ucSetCallbackE(FunctionAddress, ucTreeUp, ucThreadAddr(t))
End Function

Public Property Get ucVariableValueStr(ByVal VarHandle As Long) As String
   ucVariableValueStr = ucGetVariableValueStrE(VarHandle)
End Property

Public Property Let ucVariableValueStr(ByVal VarHandle As Long, vValue As String)
   ucSetVariableValueStrE VarHandle, vValue
End Property

Public Sub ucReleaseExprPtr(ByVal ExpressionPtr As Long)
   ' +++ Perhaps insert code here to prevent releasing Expr from wrong thread
   ucReleaseExprPtrE ExpressionPtr
End Sub

Public Sub ucReleaseItem(ByVal ItemHandle As Long)
   ' +++ Perhaps insert code here to prevent releasing Expr from wrong thread
   ucReleaseItemE ItemHandle
End Sub

Private Sub ucReleaseThread(ByVal ucThread As Long)
   If ucThread > 0 Then ucReleaseThreadE ucThread
End Sub

Public Sub ucSetThreadIndex(ByVal ucThread As Long)
   t = ucThread
End Sub

Public Sub ucSetTrigMode(ByVal TrigMode As Long)
   ucSetTrigModeE TrigMode, ucThreadAddr(t)
End Sub

Public Sub ucSetVariableValue(ByVal VarHandle As Long, ByVal vValue As Double)
   ucSetVariableValueDblE VarHandle, vValue
End Sub

Public Sub ucSetVariableValueStr(ByVal VarHandle As Long, vValue As String)
   ucSetVariableValueStrE VarHandle, vValue
End Sub

Public Function ucDefineConstant(ConstantDef$, Optional ByVal vProperties As Long = 0) As Long
   ucDefineConstant = ucDefineVariableE(ConstantDef$, 0, 0, vProperties, ucType_Constant, ucThreadAddr(t))
End Function

Public Function ucDefineFunction(FunctionDef$, Optional ByVal FunctionAddress As Long = 0, Optional ByVal fProperties As Long = 0, Optional ByVal vType As Long = 0) As Long
   ucDefineFunction = ucDefineFunctionE(FunctionDef$, FunctionAddress, 0, fProperties, vType, ucThreadAddr(t))
End Function

Public Function ucDefineOperator(OperatorDef$, Optional ByVal Precedence As Long = 0, Optional ByVal OperatorAddress As Long = 0, Optional ByVal fProperties As Long = 0, Optional ByVal vType As Long = 0) As Long
   ucDefineOperator = ucDefineFunctionE(OperatorDef$, OperatorAddress, Precedence, fProperties, vType, ucThreadAddr(t))
End Function

Public Function ucDefineVariable(VariableDef$, Optional ByVal vProperties As Long = 0) As Long
   ucDefineVariable = ucDefineVariableE(VariableDef$, 0, 0, vProperties, ucType_Internal, ucThreadAddr(t))
End Function

Public Function ucAttachVariable(VariableDef$, ByRef vPtr As Long, Optional ByVal ExprPtr As Long = 0, Optional ByVal vProperties As Long) As Long
   ucAttachVariable = ucDefineVariableE(VariableDef$, vPtr, ExprPtr, vProperties, 0, ucThreadAddr(t))
End Function

Public Function ucEval(Expression$) As Double
   ucEval = ucEvalE(Expression$, ucThreadAddr(t))
End Function

Public Function ucEvalStr(Expression$, Optional ByVal tNum As Long = 0) As String
   ucEvalStr = ucEvalStrE(Expression$, ucThreadAddr(tNum))
End Function

Public Function ucEvaluate(ByVal ExpressionPtr As Long) As Double
   ucEvaluate = ucEvaluateE(ExpressionPtr)
End Function

Public Function ucEvaluateStr(ByVal ExpressionPtr As Long) As String
   ucEvaluateStr = ucEvaluateStrE(ExpressionPtr)
End Function

Public Function ucError() As Long
   Dim tData As ucThreadType
   
   ucGetThreadInfo t, tData
   ucError = tData.ErrorNumber
End Function

Public Function ucGetErrorData(ByVal errIndex As Long, Optional ByVal t As Long = 0) As String
   ucGetErrorData = ucGetErrorDataE(errIndex, ucThreadAddr(t))
End Function

Public Function ucGetThreadIndex() As Long
   ucGetThreadIndex = t
End Function

Public Function ucGetVariableValue(ByVal VarHandle As Long) As Double
   ucGetVariableValue = ucGetVariableValueE(VarHandle)
End Function

Public Function ucGetVariableValueStr(ByVal VarHandle As Long) As String
   ucGetVariableValueStr = ucGetVariableValueStrE(VarHandle)
End Function

Public Function ucImagPart() As Double
   ucImagPart = ucImagPartE(ucThreadAddr(t))
End Function

'+++Function ucEvaluateCplx(ByVal ExpressionPtr As Long, ucValue As ucComplexNumberType) As Double
'   ucValue.Real = ucEvaluate(ExpressionPtr)
'   ucValue.Imag = ucImagPartE(ucThreadAddr(t))
'   ucEvaluateCplx = ucValue.Real
'End Function

Private Function ucNewThread() As Long
   ucNewThread = ucNewThreadE
End Function

Public Function ucParse(Expression$, Optional LocalVars$ = "", Optional ExprType As Long = 0) As Long
   ucParse = ucParseE(Expression$, LocalVars$, ExprType, ucThreadAddr(t))
End Function

Public Function ucPrecedence(Op$, Optional ByVal OpCategory As Long) As Long
   ucPrecedence = ucPrecedenceE(Op$, OpCategory, ucThreadAddr(t))
End Function
             
Public Function ucSymbolHandle(ucSymbolE$, Optional ByVal SymbolProperty As Long = 0) As Long
   ucSymbolHandle = ucSymbolHandleE(ucSymbolE$, SymbolProperty, ucThreadAddr(t))
End Function

Public Property Get ucErrorData(ByVal errIndex As Long) As String
   ucErrorData = ucGetErrorDataE(errIndex, ucThreadAddr(t))
End Property

Public Property Get ucThreadIndex() As Long
   ucThreadIndex = t
End Property

Public Property Let ucThreadIndex(ByVal uThread As Long)
   t = uThread
End Property

Public Function ucErrorMessage(Optional ByVal ErrorNumber As Long = -1) As String
   ucErrorMessage = ucGetErrorMessage(ErrorNumber, t)
End Function
