' -------------------------------------------------------------------------
' ucpblib.bas : PowerBASIC add-on library source code.
' Compiles to ucpblib.dll
' Designed to work with PowerBASIC/Win 7.0 and PB/CC 3.0 or above.
'
' Redistribution of this file is not allowed.
'
' UCalc Fast Math Parser (Beta J)
' Copyright (c) 1998-2004 by Daniel Corbier.  All rights reserved.
' http://www.ucalc.com/mathparser
' -------------------------------------------------------------------------

$Compile Dll "ucPBLib.dll"
DefLng a-z

%ucAddOnLibrary = 1
' +++ use ucAddOnLibrary technique also for Delphi and VB lib if possible

Global MaxFunc As Long
Global MinFunc As Long
Global IIfFunc As Long

#Include "ucalcpb.bas"

Type ExpressionType
   LeftOp      As Ext Ptr
   RightOp     As Ext Ptr
   Result      As Ext Ptr
   Reserved    As String * 16
   GoToAddress As Dword
End Type

Sub ucLibInit Alias "ucLibInit" (t As ucThreadType) Export
   Call ucPBLibInit(t)
End Sub

Sub ucPBLibInit Alias "ucPBLibInit" (t As ucThreadType) Export
   ucTreeParseDown CodePtr(StringHelper)
   ucTreeParseDown CodePtr(MultiLineParse)
   ucTreeParseDown CodePtr(ForNext)
   ucTreeParseDown CodePtr(BASIC_Hex)

   ucTreeParseUp   CodePtr(StringMinMaxIIfStr)

   MaxFunc = ucSymbolHandle("MAX")
   MinFunc = ucSymbolHandle("MIN")
   IIfFunc = ucSymbolHandle("IIF")

   t.ucProperty.FunctionProperties = %ucInline + %ucOverload + %ucOverride
   ucDefineOperator "$[x,y] = x+y"
   ucDefineOperator "&[x] = x"

   t.ucProperty.FunctionProperties = %ucInline + %ucOverload
   ucDefineFunction "ASC(a$, b=1)", CodePtr(uc_ASC)
   ucDefineFunction "BIN$(a, b=0)", CodePtr(uc_BIN)
   ucDefineFunction "BIT(a, b)", CodePtr(uc_BIT)
   ' BITS +++
   ucDefineFunction "CBYT(a)", CodePtr(uc_CBYT)
   ucDefineFunction "CCUR(a)", CodePtr(uc_CCUR)
   ucDefineFunction "CCUX(a)", CodePtr(uc_CCUX)
   ucDefineFunction "CDBL(a)", CodePtr(uc_CDBL)
   ucDefineFunction "CDWD(a)", CodePtr(uc_CDWD)
   ucDefineFunction "CEXT(a)", CodePtr(uc_CEXT)
   ucDefineFunction "CINT(a)", CodePtr(uc_CINT)
   ucDefineFunction "CLNG(a)", CodePtr(uc_CLNG)
   ucDefineFunction "CQUD(a)", CodePtr(uc_CQUD)
   ucDefineFunction "CSNG(a)", CodePtr(uc_CSNG)
   ucDefineFunction "CWRD(a)", CodePtr(uc_CWRD)
   ' Matrix ops
   ucDefineFunction "CURDIR$(drive$)", CodePtr(uc_CURDIR2)
   ucDefineFunction "CURDIR$()", CodePtr(uc_CURDIR) '+++ Bug: doesn't work if CURDIR$() comes before CURDIR$(drive$)
   ucDefineFunction "CHR$()", CodePtr(uc_CHR)
   ucDefineFunction "TO$[start, finish]", CodePtr(uc_CHRTO) ' This is a Chr$() helper
   ucDefineFunction "CVBYT(variable, offset=-1)", CodePtr(uc_CVBYT)
   ucDefineFunction "CVCUR(variable, offset=-1)", CodePtr(uc_CVCUR)
   ucDefineFunction "CVCUX(variable, offset=-1)", CodePtr(uc_CVCUX)
   ucDefineFunction "CVD(variable, offset=-1)", CodePtr(uc_CVD)
   ucDefineFunction "CVDWD(variable, offset=-1)", CodePtr(uc_CVDWD)
   ucDefineFunction "CVE(variable, offset=-1)", CodePtr(uc_CVE)
   ucDefineFunction "CVI(variable, offset=-1)", CodePtr(uc_CVI)
   ucDefineFunction "CVL(variable, offset=-1)", CodePtr(uc_CVL)
   ucDefineFunction "CVQ(variable, offset=-1)", CodePtr(uc_CVQ)
   ucDefineFunction "CVS(variable, offset=-1)", CodePtr(uc_CVS)
   ucDefineFunction "CVWRD(variable, offset=-1)", CodePtr(uc_CVWRD)
   ucDefineFunction "DATE$()", CodePtr(uc_DATE)
   ucDefineFunction "DIR$(mask$)", CodePtr(uc_DIR2)
   ucDefineFunction "DIR$(mask$, attribute)", CodePtr(uc_DIR3)
   ucDefineFunction "DIR$()", CodePtr(uc_DIR)
   ucDefineFunction "DISKFREE(drive$)", CodePtr(uc_DISKFREE)
   ucDefineFunction "DISKSIZE(drive$)", CodePtr(uc_DISKSIZE)
   ucDefineFunction "ENVIRON$(string$)", CodePtr(uc_ENVIRON)
   ucDefineFunction "ENVIRON$(n)", CodePtr(uc_ENVIRON2)
   '+++ ERR etc...
   ucDefineFunction "EXTRACT$(a, b$, c$, VB_Compare=0, PB_Any=0)", CodePtr(uc_EXTRACT)
   ucDefineFunction "EXTRACT$(b$, c$, VB_Compare=0, PB_Any=0) = Extract$(1, b, c, VB_Compare, PB_Any)"
   ucDefineFunction "FIX(a)", CodePtr(uc_FIX)
   ucDefineFunction "FRAC(a)", CodePtr(uc_FRAC)
   ucDefineFunction "FORMAT$(expr)", CodePtr(uc_FORMAT)
   ucDefineFunction "FORMAT$(expr, fmt$)", CodePtr(uc_FORMAT2)
   ucDefineFunction "GETATTR(file$)", CodePtr(uc_GETATTR)
   ucDefineFunction "HEX$(a$, b=0)", CodePtr(uc_HEX)
   ucDefineFunction "HIBYT(a)", CodePtr(uc_HIBYT)
   ucDefineFunction "HIBYTE(a)", CodePtr(uc_HIBYT)
   ucDefineFunction "HIWRD(a)", CodePtr(uc_HIWRD)
   ucDefineFunction "HIWORD(a)", CodePtr(uc_HIWRD)
'  INSTR is enhanced
   ucDefineFunction "INSTR(a, b$, c$, VB_Compare=0, PB_Any=0)", CodePtr(uc_INSTR)
   ucDefineFunction "INSTR(b$, c$, VB_Compare=0, PB_Any=0) = InStr(1, b, c, VB_Compare, PB_Any)"
   ucDefineFunction "INSTRREV(a$, b$, c=-1, d=0)", CodePtr(uc_INSTRREV)
   ucDefineFunction "ISFALSE(a)", CodePtr(uc_ISFALSE)
   ucDefineFunction "ISTRUE(a)", CodePtr(uc_ISTRUE)
   ucDefineFunction "LCASE$(a$)", CodePtr(uc_LCASE)
   ucDefineFunction "LEFT$(a$, b)", CodePtr(uc_LEFT)
   '+++ Len for other types and arrays
   ucDefineFunction "LEN(a$)", CodePtr(uc_LEN)
   ucDefineFunction "LOBYT(a)", CodePtr(uc_LOBYT)
   ucDefineFunction "LOBYTE(a)", CodePtr(uc_LOBYT)
   ucDefineFunction "LOWRD(a)", CodePtr(uc_LOBYT)
   ucDefineFunction "LOWORD(a)", CodePtr(uc_LOWRD)
   ucDefineFunction "LTRIM$(a$, b$=' ', c=0)", CodePtr(uc_LTRIM)
   ucDefineFunction "MAKDWD(a, b)", CodePtr(uc_MAKDWD)
   ucDefineFunction "MAKEDWORD(a, b)", CodePtr(uc_MAKDWD) '+++?
   ucDefineFunction "MAKLNG(a, b)", CodePtr(uc_MAKLNG)
   ucDefineFunction "MAKELONG(a, b)", CodePtr(uc_MAKLNG)
   ucDefineFunction "MAKPTR(a, b)", CodePtr(uc_MAKPTR)
   ucDefineFunction "MAKEPTR(a, b)", CodePtr(uc_MAKPTR)
   ucDefineFunction "MaxStr$()", CodePtr(uc_MaxStr) ' for Max$()
   ucDefineFunction "MinStr$()", CodePtr(uc_MinStr) ' for Min$()
   ucDefineFunction "IIfStr$(condition, true&, false&)", CodePtr(uc_IIfStr) ' for IIf$()
   ucDefineFunction "MCASE$(a$)", CodePtr(uc_MCASE)
   ucDefineFunction "MID$(a$, b, c=-1)", CodePtr(uc_MID)
   ucDefineFunction "MKBYT$(a)", CodePtr(uc_MKBYT)
   ucDefineFunction "MKCUR$(a)", CodePtr(uc_MKCUR)
   ucDefineFunction "MKCUX$(a)", CodePtr(uc_MKCUX)
   ucDefineFunction "MKD$(a)", CodePtr(uc_MKD)
   ucDefineFunction "MKDWD$(a)", CodePtr(uc_MKDWD)
   ucDefineFunction "MKE$(a)", CodePtr(uc_MKE)
   ucDefineFunction "MKI$(a)", CodePtr(uc_MKI)
   ucDefineFunction "MKL$(a)", CodePtr(uc_MKL)
   ucDefineFunction "MKQ$(a)", CodePtr(uc_MKQ)
   ucDefineFunction "MKS$(a)", CodePtr(uc_MKS)
   ucDefineFunction "MKWRD$(a)", CodePtr(uc_MKWRD)
   '+++ MSGBOX
   ucDefineFunction "OCT$(a)", CodePtr(uc_OCT)
   ucDefineFunction "PARSE$(text$, field)", CodePtr(uc_PARSE)
   ucDefineFunction "PARSE$(text$, delimit$, field, option=0)", CodePtr(uc_PARSE2)
   ucDefineFunction "PARSECOUNT(text$, delmit$, option=0)", CodePtr(uc_PARSECOUNT)
   ucDefineFunction "PEEK(a)", CodePtr(uc_PEEK)
   ucDefineFunction "PEEK$(a, b)", CodePtr(uc_PEEKs)
   ' +++ REGEXPR, REGREPL
   ucDefineFunction "REMAIN$(a, b$, c$, VB_Compare=0, PB_Any=0)", CodePtr(uc_REMAIN)
   ucDefineFunction "REMAIN$(b$, c$, VB_Compare=0, PB_Any=0) = Remain$(1, b, c, VB_Compare, PB_Any)"
   ucDefineFunction "REMOVE$(a$, b$, c=0)", CodePtr(uc_REMOVE)
   ucDefineFunction "REPEAT$(a, b$)", CodePtr(uc_REPEAT)
   ' +++ Replace is an enhanced function
   ucDefineFunction "REPLACE$(a$, b$, c$, option=0)", CodePtr(uc_REPLACE)
   ucDefineFunction "RGB(a, b, c)", CodePtr(uc_RGB)
   ucDefineFunction "RIGHT$(a$, b)", CodePtr(uc_RIGHT)
   ucDefineFunction "RND(a, b)", CodePtr(uc_RND2)
   ucDefineFunction "ROTATELEFT(a, b)", CodePtr(uc_ROTATEL)
   ucDefineFunction "ROTATERIGHT(a, b)", CodePtr(uc_ROTATER)
   ucDefineFunction "ROUND(a, b=0)", CodePtr(uc_ROUND)
   ' +++ RSET and LSET
   ucDefineFunction "RTRIM$(a$, b$=' ', c=0)", CodePtr(uc_RTRIM)
   ' +++ SHIFT signed
   ucDefineFunction "SHL[a, b]", CodePtr(uc_SHL)
   ucDefineFunction "SHR[a, b]", CodePtr(uc_SHR)
   ' +++ SIZEOF
   ucDefineFunction "SPACE$(a)", CodePtr(uc_SPACE)
   ucDefineFunction "STR$(a)", CodePtr(uc_STR)
   ucDefineFunction "STR$(a, b)", CodePtr(uc_STR2)
   ucDefineFunction "STRDELETE$(a$, b, c)", CodePtr(uc_STRDELETE)
   ucDefineFunction "STRING$(a, b$)", CodePtr(uc_STRINGA)
   ucDefineFunction "STRING$(a, b)", CodePtr(uc_STRINGB)
   ucDefineFunction "STRINSERT$(a$, b$, c)", CodePtr(uc_STRINSERT)
   ucDefineFunction "STRREVERSE$(a$)", CodePtr(uc_STRREVERSE)
   ucDefineFunction "TALLY(a$, b$, c=0)", CodePtr(uc_TALLY)
   ucDefineFunction "TIME$()", CodePtr(uc_TIME)
   ucDefineFunction "TIMER()", CodePtr(uc_TIMER)
   ucDefineFunction "TRIM$(a$, b$=' ', c=0)", CodePtr(uc_TRIM)
   ucDefineFunction "UCASE$(a$)", CodePtr(uc_UCASE)
   ucDefineFunction "VAL(a$)", CodePtr(uc_VAL)
   ucDefineFunction "VERIFY(a, b$, c$)", CodePtr(uc_VERIFY)
   ucDefineFunction "VERIFY(b$, c$) = Verify(1, b, c)"

   ucDefineFunction "SetVar(VarHandle, VarValue)", CodePtr(uc_SetVar)
   ucDefineFunction "_For(var,start,finish,step,Return&)", CodePtr(uc_ForA)
   ucDefineFunction "For(var@,start,finish,Return&)", CodePtr(uc_For)
   ucDefineFunction "DoNothing(a) = 0"
   ucDefineFunction "DoNothing$(a$) = ''"
   ucDefineOperator ":[a,b] = DoNothing(a) + b", t.PrecedenceMin

   t.ucProperty.FunctionProperties = %ucOverwrite + %ucOverload + %ucOverride

   ucDefineOperator "Goto[x]", 0, CodePtr(uc_Goto), %ucFastCallback
   ucDefineFunction "EXITBLOCK()", CodePtr(uc_Exit), %ucFastCallback
   ucDefineOperator "[x]: = 0"
   ucDefineOperator "Function[x]", t.PrecedenceMin+1
   ucDefineOperator "Dim[x]",      t.PrecedenceMin+1
   ucDefineOperator "For[x]",      t.PrecedenceMin+1
   ucDefineOperator "If[x]",       t.PrecedenceMin+1
   ucDefineOperator "ElseIf[x]",   t.PrecedenceMin+1
   ucDefineOperator "End[x]",      t.PrecedenceMin+1
   ucDefineFunction "If()"
   ucDefineFunction "Else()"
   ucDefineFunction "DetachFor()"
   ucDefineFunction "DetachIf()"
   ucDefineFunction "Function()"
End Sub

Function ucVariableHandle(ByVal ucSymbol$, t As ucThreadType) As Long
   ucVariableHandle = ucSymbolHandle(ucSymbol$+Chr$(0), %ucIsVariable, t.ucThread)
End Function

Function uc_ASC(t As ucThreadType) As Ext
   Function = Asc(ucParamStr(1, t), ucParam(2, t))
End Function

Function uc_BIN(t As ucThreadType) As Ext
   If ucParam(2, t) = 0 _
   Then ucReturnStr Bin$(ucParam(1, t)), t _
   Else ucReturnStr Bin$(ucParam(1, t), ucParam(2, t)), t
End Function

Function uc_BIT(t As ucThreadType) As Ext
   Dim intVar As Long, bitNumber As Long

   intVar = ucParam(1, t)
   BitNumber = ucParam(2, t)

   Function = Bit(intVar, bitNumber)
End Function

Function uc_CBYT(t As ucThreadType) As Ext
   Function = CByt(ucParam(1, t))
End Function

Function uc_CCUR(t As ucThreadType) As Ext
   Function = CCur(ucParam(1, t))
End Function

Function uc_CCUX(t As ucThreadType) As Ext
   Function = CCux(ucParam(1, t))
End Function

Function uc_CDBL(t As ucThreadType) As Ext
   Function = CDbl(ucParam(1, t))
End Function

Function uc_CDWD(t As ucThreadType) As Ext
   Function = CDwd(ucParam(1, t))
End Function

Function uc_CEXT(t As ucThreadType) As Ext
   Function = Cext(ucParam(1, t))
End Function

Function uc_CINT(t As ucThreadType) As Ext
   Function = CInt(ucParam(1, t))
End Function

Function uc_CLNG(t As ucThreadType) As Ext
   Function = CLng(ucParam(1, t))
End Function

Function uc_CQUD(t As ucThreadType) As Ext
   Function = CQud(ucParam(1, t))
End Function

Function uc_CSNG(t As ucThreadType) As Ext
   Function = CSng(ucParam(1, t))
End Function

Function uc_CWRD(t As ucThreadType) As Ext
   Function = CWrd(ucParam(1, t))
End Function

Function uc_CHR(t As ucThreadType) As Ext
   Dim x As Long, text$

   For x = 1 To t.ParamCount
      If ucParamType(x, t) = %ucType_AnsiString _
      Then text$ = text$ + ucParamStr(x, t)     _
      Else text$ = text$ + Chr$(ucParam(x, t))
   Next

   ucReturnStr text$, t
End Function

Function uc_CHRTO(t As ucThreadType) As Ext
   Dim x As Long, text$

   For x = ucParam(1, t) To ucParam(2, t)
      text$ = text$ + Chr$(x)
   Next

   ucReturnStr text$, t
End Function

Function uc_CURDIR(t As ucThreadType) As Ext
   ucReturnStr CurDir$, t
End Function

Function uc_CURDIR2(t As ucThreadType) As Ext
   ucReturnStr CurDir$(ucParamStr(1, t)), t
End Function

Function uc_CVBYT(t As ucThreadType) As Ext
   If ucParam(2, t) = -1 _
   Then Function = CvByt(ucParamStr(1, t)) _
   Else Function = CvByt(ucParamStr(1, t), ucParam(2, t))
End Function

Function uc_CVCUR(t As ucThreadType) As Ext
   If ucParam(2, t) = -1 _
   Then Function = CvCur(ucParamStr(1, t)) _
   Else Function = CvCur(ucParamStr(1, t), ucParam(2, t))
End Function

Function uc_CVCUX(t As ucThreadType) As Ext
   If ucParam(2, t) = -1 _
   Then Function = CvCux(ucParamStr(1, t)) _
   Else Function = CvCux(ucParamStr(1, t), ucParam(2, t))
End Function

Function uc_CVD(t As ucThreadType) As Ext
   If ucParam(2, t) = -1 _
   Then Function = Cvd(ucParamStr(1, t)) _
   Else Function = Cvd(ucParamStr(1, t), ucParam(2, t))
End Function

Function uc_CVDWD(t As ucThreadType) As Ext
   If ucParam(2, t) = -1 _
   Then Function = CvDwd(ucParamStr(1, t)) _
   Else Function = CvDwd(ucParamStr(1, t), ucParam(2, t))
End Function

Function uc_CVE(t As ucThreadType) As Ext
   If ucParam(2, t) = -1 _
   Then Function = Cve(ucParamStr(1, t)) _
   Else Function = Cve(ucParamStr(1, t), ucParam(2, t))
End Function

Function uc_CVI(t As ucThreadType) As Ext
   If ucParam(2, t) = -1 _
   Then Function = Cvi(ucParamStr(1, t)) _
   Else Function = Cvi(ucParamStr(1, t), ucParam(2, t))
End Function

Function uc_CVL(t As ucThreadType) As Ext
   If ucParam(2, t) = -1 _
   Then Function = Cvl(ucParamStr(1, t)) _
   Else Function = Cvl(ucParamStr(1, t), ucParam(2, t))
End Function

Function uc_CVQ(t As ucThreadType) As Ext
   If ucParam(2, t) = -1 _
   Then Function = Cvq(ucParamStr(1, t)) _
   Else Function = Cvq(ucParamStr(1, t), ucParam(2, t))
End Function

Function uc_CVS(t As ucThreadType) As Ext
   If ucParam(2, t) = -1 _
   Then Function = Cvs(ucParamStr(1, t)) _
   Else Function = Cvs(ucParamStr(1, t), ucParam(2, t))
End Function

Function uc_CVWRD(t As ucThreadType) As Ext
   If ucParam(2, t) = -1 _
   Then Function = CvWrd(ucParamStr(1, t)) _
   Else Function = CvWrd(ucParamStr(1, t), ucParam(2, t))
End Function

Function uc_DATE(t As ucThreadType) As Ext
   ucReturnStr Date$, t
End Function

Function uc_DIR(t As ucThreadType) As Ext
   ucReturnStr Dir$, t
End Function

Function uc_DIR2(t As ucThreadType) As Ext
   ucReturnStr Dir$(ucParamStr(1, t)), t
End Function

Function uc_DIR3(t As ucThreadType) As Ext
   ucReturnStr Dir$(ucParamStr(1, t), ucParam(2, t)), t
End Function

Function uc_DISKFREE(t As ucThreadType) As Ext
   Function = DiskFree(ucParamStr(1, t))
End Function

Function uc_DISKSIZE(t As ucThreadType) As Ext
   Function = DiskSize(ucParamStr(1, t))
End Function

Function uc_ENVIRON(t As ucThreadType) As Ext
   ucReturnStr Environ$(ucParamStr(1, t)), t
End Function

Function uc_ENVIRON2(t As ucThreadType) As Ext
   ucReturnStr Environ$(ucParam(1, t)), t
End Function

Function uc_EXTRACT(t As ucThreadType) As Ext
   If ucParam(4, t) Then
      MainString$ = UCase$(ucParamStr(2, t))
      MatchString$ = UCase$(ucParamStr(3, t))

      If ucParam(5, t) _
      Then i = InStr(ucParam(1, t), MainString$, Any MatchString$) _
      Else i = InStr(ucParam(1, t), MainString$, MatchString$)

      ucReturnStr Left$(ucParamStr(2, t), i-1), t  ' +++ might cause error if i=0
   Else
      If ucParam(5, t) _
      Then ucReturnStr Extract$(ucParam(1, t), ucParamStr(2, t), Any ucParamStr(3, t)), t _
      Else ucReturnStr Extract$(ucParam(1, t), ucParamStr(2, t), ucParamStr(3, t)), t
   End If
End Function

Function uc_FIX(t As ucThreadType) As Ext
   Function = Fix(ucParam(1, t))
End Function

Function uc_FORMAT(t As ucThreadType) As Ext
   ucReturnStr Format$(ucParam(1, t)), t
End Function

Function uc_FORMAT2(t As ucThreadType) As Ext
   ucReturnStr Format$(ucParam(1, t), ucParamStr(2, t)), t
End Function

Function uc_FRAC(t As ucThreadType) As Ext
   Function = Frac(ucParam(1, t))
End Function

Function uc_GETATTR(t As ucThreadType) As Ext
   Function = GetAttr(ucParamStr(1, t))
End Function

Function uc_HEX(t As ucThreadType) As Ext
   ucReturnStr Hex$(ucParam(1, t), ucParam(2, t)), t
End Function

Function uc_HIBYT(t As ucThreadType) As Ext
   Function = HiByt(ucParam(1, t))
End Function

Function uc_HIWRD(t As ucThreadType) As Ext
   Function = HiWrd(ucParam(1, t))
End Function

Function uc_INSTR(t As ucThreadType) As Ext
   If ucParam(4, t) Then
      MainString$ = UCase$(ucParamStr(2, t))
      MatchString$ = UCase$(ucParamStr(3, t))

      If ucParam(5, t) _
      Then Function = InStr(ucParam(1, t), MainString$, Any MatchString$) _
      Else Function = InStr(ucParam(1, t), MainString$, MatchString$)
   Else
      If ucParam(5, t) _
      Then Function = InStr(ucParam(1, t), ucParamStr(2, t), Any ucParamStr(3, t)) _
      Else Function = InStr(ucParam(1, t), ucParamStr(2, t), ucParamStr(3, t))
   End If
End Function

Function uc_INSTRREV(t As ucThreadType) As Ext
   If ucParam(4, t) Then
      Function = InStr(ucParam(3, t), UCase$(ucParamStr(1, t)), UCase$(ucParamStr(2, t)))
   Else
      Function = InStr(ucParam(3, t), ucParamStr(1, t), ucParamStr(2, t))
   End If
End Function

Function uc_ISFALSE(t As ucThreadType) As Ext
   Function = Abs(ucParam(1, t)=0)
End Function

Function uc_ISTRUE(t As ucThreadType) As Ext
   Function = t.ucProperty.RelationalTrue * Abs(ucParam(1, t)<>0)
End Function

Function uc_LCASE(t As ucThreadType) As Ext
   ucReturnStr LCase$(ucParamStr(1, t)), t
End Function

Function uc_LEFT(t As ucThreadType) As Ext
   ucReturnStr Left$(ucParamStr(1, t), ucParam(2, t)), t
End Function

Function uc_LEN(t As ucThreadType) As Ext
   Function = Len(ucParamStr(1, t))
End Function

Function uc_LOBYT(t As ucThreadType) As Ext
   Function = LoByt(ucParam(1, t))
End Function

Function uc_LOWRD(t As ucThreadType) As Ext
   Function = LoWrd(ucParam(1, t))
End Function

Function uc_LTRIM(t As ucThreadType) As Ext
   If ucParamStr(2, t) = "" Then
      ucReturnStr LTrim$(ucParamStr(1, t)), t
   ElseIf ucParam(3, t) Then
      ucReturnStr LTrim$(ucParamStr(1, t), Any ucParamStr(2, t)), t
   Else
      ucReturnStr LTrim$(ucParamStr(1, t), ucParamStr(2, t)), t
   End If
End Function

Function uc_MAKDWD(t As ucThreadType) As Ext
   Function = MakDwd(ucParam(1, t), ucParam(2, t))
End Function

Function uc_MAKLNG(t As ucThreadType) As Ext
   Function = MakLng(ucParam(1, t), ucParam(2, t))
End Function

Function uc_MAKPTR(t As ucThreadType) As Ext
   Function = MakPtr(ucParam(1, t), ucParam(2, t))
End Function

Function uc_MCASE(t As ucThreadType) As Ext
   ucReturnStr MCase$(ucParamStr(1, t)), t
End Function

Function uc_MID(t As ucThreadType) As Ext
   If ucParam(3, t) = -1 _
   Then ucReturnStr Mid$(ucParamStr(1, t), ucParam(2, t)) , t _
   Else ucReturnStr Mid$(ucParamStr(1, t), ucParam(2, t), ucParam(3, t)) , t
End Function

Function uc_MKBYT(t As ucThreadType) As Ext
   ucReturnStr MkByt$(ucParam(1, t)), t
End Function

Function uc_MKCUR(t As ucThreadType) As Ext
   ucReturnStr MkCur$(ucParam(1, t)), t
End Function

Function uc_MKCUX(t As ucThreadType) As Ext
   ucReturnStr MkCux$(ucParam(1, t)), t
End Function

Function uc_MKD(t As ucThreadType) As Ext
   ucReturnStr Mkd$(ucParam(1, t)), t
End Function

Function uc_MKDWD(t As ucThreadType) As Ext
   ucReturnStr MkDwd$(ucParam(1, t)), t
End Function

Function uc_MKE(t As ucThreadType) As Ext
   ucReturnStr Mke$(ucParam(1, t)), t
End Function

Function uc_MKI(t As ucThreadType) As Ext
   ucReturnStr Mki$(ucParam(1, t)), t
End Function

Function uc_MKL(t As ucThreadType) As Ext
   ucReturnStr Mkl$(ucParam(1, t)), t
End Function

Function uc_MKQ(t As ucThreadType) As Ext
   ucReturnStr Mkq$(ucParam(1, t)), t
End Function

Function uc_MKS(t As ucThreadType) As Ext
   ucReturnStr Mks$(ucParam(1, t)), t
End Function

Function uc_MKWRD(t As ucThreadType) As Ext
   ucReturnStr MkWrd$(ucParam(1, t)), t
End Function

Function uc_OCT(t As ucThreadType) As Ext
   ucReturnStr Oct$(ucParam(1, t), ucParam(2, t)), t
End Function

Function uc_PARSE(t As ucThreadType) As Ext
   ucReturnStr Parse$(ucParamStr(1, t), ucParam(2, t)), t
End Function

Function uc_PARSE2(t As ucThreadType) As Ext
   If ucParam(4, t) _
   Then ucReturnStr Parse$(ucParamStr(1, t), Any ucParamStr(2, t), ucParam(3, t)), t _
   Else ucReturnStr Parse$(ucParamStr(1, t), ucParamStr(2, t), ucParam(3, t)), t
End Function

Function uc_PARSECOUNT(t As ucThreadType) As Ext
   If ucParam(3, t) _
   Then Function = ParseCount(ucParamStr(1, t), Any ucParamStr(2, t)) _
   Else Function = ParseCount(ucParamStr(1, t), ucParamStr(2, t))
End Function

Function uc_PEEK(t As ucThreadType) As Ext
   Function = Peek(ucParam(1, t))
End Function

Function uc_PEEKs(t As ucThreadType) As Ext
   ucReturnStr Peek$(ucParam(1, t), ucParam(2, t)), t
End Function

Function uc_REMAIN(t As ucThreadType) As Ext
   If ucParam(4, t) Then
      MainString$ = UCase$(ucParamStr(2, t))
      MatchString$ = UCase$(ucParamStr(3, t))

      If ucParam(5, t) _
      Then i = InStr(ucParam(1, t), MainString$, Any MatchString$) _
      Else i = InStr(ucParam(1, t), MainString$, MatchString$)

      ucReturnStr Mid$(ucParamStr(2, t), i+Len(MatchString$)), t  ' +++ might cause error if i=0
   Else
      If ucParam(5, t) _
      Then ucReturnStr Remain$(ucParam(1, t), ucParamStr(2, t), Any ucParamStr(3, t)), t _
      Else ucReturnStr Remain$(ucParam(1, t), ucParamStr(2, t), ucParamStr(3, t)), t
   End If
End Function

Function uc_REMOVE(t As ucThreadType) As Ext
   If ucParam(3, t) _
   Then ucReturnStr Remove$(ucParamStr(1, t), Any ucParamStr(2, t)), t _
   Else ucReturnStr Remove$(ucParamStr(1, t), ucParamStr(2, t)), t
End Function

Function uc_REPEAT(t As ucThreadType) As Ext
   ucReturnStr Repeat$(ucParam(1, t), ucParamStr(2, t)), t
End Function

Function uc_REPLACE(t As ucThreadType) As Ext
   '+++ This is an enhanced function
   text$ = ucParamStr(3, t)

   If ucParam(4, t) _
   Then Replace Any ucParamStr(1, t) With ucParamStr(2, t) In text$ _
   Else Replace ucParamStr(1, t) With ucParamStr(2, t) In text$

   ucReturnStr text$, t
End Function

Function uc_RGB(t As ucThreadType) As Ext
   Function = RGB(ucParam(1, t), ucParam(2, t), ucParam(3, t))
End Function

Function uc_RIGHT(t As ucThreadType) As Ext
   ucReturnStr Right$(ucParamStr(1, t), ucParam(2, t)), t
End Function

Function uc_RND2(t As ucThreadType) As Ext
   Function = Rnd(ucParam(1, t), ucParam(2, t))
End Function

Function uc_ROTATEL(t As ucThreadType) As Ext
   Dim i As Long, count As Long

   i = ucParam(1, t)
   count = ucParam(2, t)
   Rotate Left i, count

   Function = i
End Function

Function uc_ROTATER(t As ucThreadType) As Ext
   Dim i As Long, count As Long

   i = ucParam(1, t)
   count = ucParam(2, t)
   Rotate Right i, count

   Function = i
End Function

Function uc_ROUND(t As ucThreadType) As Ext
   Function = Round(ucParam(1, t), ucParam(2, t))
End Function

Function uc_RTRIM(t As ucThreadType) As Ext
   If ucParamStr(2, t) = "" Then
      ucReturnStr RTrim$(ucParamStr(1, t)), t
   ElseIf ucParam(3, t) Then
      ucReturnStr RTrim$(ucParamStr(1, t), Any ucParamStr(2, t)), t
   Else
      ucReturnStr RTrim$(ucParamStr(1, t), ucParamStr(2, t)), t
   End If
End Function

Function uc_SHL(t As ucThreadType) As Ext
   Dim i As Long, count As Long

   i = ucParam(1, t)
   count = ucParam(2, t)
   Shift Left i, count

   Function = i
End Function

Function uc_SHR(t As ucThreadType) As Ext
   Dim i As Long, count As Long

   i = ucParam(1, t)
   count = ucParam(2, t)
   Shift Right i, count

   Function = i
End Function

Function uc_SPACE(t As ucThreadType) As Ext
   ucReturnStr Space$(ucParam(1, t)), t
End Function

Function uc_STR(t As ucThreadType) As Ext
   ucReturnStr Str$(ucParam(1, t)), t
End Function

Function uc_STR2(t As ucThreadType) As Ext
   ucReturnStr Str$(ucParam(1, t), ucParam(2, t)), t
End Function

Function uc_STRDELETE(t As ucThreadType) As Ext
   ucReturnStr StrDelete$(ucParamStr(1, t), ucParam(2, t), ucParam(3, t)), t
End Function

Function uc_STRINGA(t As ucThreadType) As Ext
   ucReturnStr String$(ucParam(1, t), ucParamStr(2, t)), t
End Function

Function uc_STRINGB(t As ucThreadType) As Ext
   ucReturnStr String$(ucParam(1, t), ucParam(2, t)), t
End Function

Function uc_STRINSERT(t As ucThreadType) As Ext
   ucReturnStr StrInsert$(ucParamStr(1, t), ucParamStr(2, t), ucParam(3, t)), t
End Function

Function uc_STRREVERSE(t As ucThreadType) As Ext
   ucReturnStr StrReverse$(ucParamStr(1, t)), t
End Function

Function uc_TALLY(t As ucThreadType) As Ext
   If ucParam(3, t) _
   Then Function = Tally(ucParamStr(1, t), Any ucParamStr(2, t)) _
   Else Function = Tally(ucParamStr(1, t), ucParamStr(2, t))
End Function

Function uc_TIME(t As ucThreadType) As Ext
   ucReturnStr Time$, t
End Function

Function uc_TIMER(t As ucThreadType) As Ext
   Function = Timer
End Function

Function uc_TRIM(t As ucThreadType) As Ext
   If ucParamStr(2, t) = "" Then
      ucReturnStr Trim$(ucParamStr(1, t)), t
   ElseIf ucParam(3, t) Then
      ucReturnStr Trim$(ucParamStr(1, t), Any ucParamStr(2, t)), t
   Else
      ucReturnStr Trim$(ucParamStr(1, t), ucParamStr(2, t)), t
   End If
End Function

Function uc_UCASE(t As ucThreadType) As Ext
   ucReturnStr UCase$(ucParamStr(1, t)), t
End Function

Function uc_VAL(t As ucThreadType) As Ext
   Function = Val(ucParamStr(1, t))
End Function

Function uc_VERIFY(t As ucThreadType) As Ext
   Function = Verify(ucParam(1, t), ucParamStr(2, t), ucParamStr(3, t))
End Function


Function uc_ForA(t As ucThreadType) As Ext
   Dim ExpressionPtr As Dword, VarHandle As Long, Counter As Ext
   Dim Start As Ext, Finish As Ext, Increment As Ext

   VarHandle      = ucParam(1, t)
   Start         = ucParam(2, t)
   Finish        = ucParam(3, t)
   Increment     = ucParam(4, t)
   ExpressionPtr = ucParam(5, t)

   For Counter = Start To Finish Step Increment
      ucSetVariableValue VarHandle, Counter
      uc_ForA = ucEvaluate(ExpressionPtr)
   Next
End Function

Function uc_For(t As ucThreadType) As Ext
   ' A more flexible For/Next defined in ucpblib.bas
   Dim ExpressionPtr As Dword, VarHandle As Long
   Dim Start As Ext, Finish As Ext, Counter As Ext

   VarHandle      = ucParam(1, t)
   Start         = ucParam(2, t)
   Finish        = ucParam(3, t)
   ExpressionPtr = ucParam(4, t)

   For Counter = Start To Finish
      ucSetVariableValue VarHandle, Counter
      uc_For = ucEvaluate(ExpressionPtr)
   Next
End Function

Function uc_SetVar(t As ucThreadType) As Ext
   Dim VariablePtr As Ext Ptr

   VariablePtr  = ucParam(1, t)
   @VariablePtr = ucParam(2, t)
   uc_SetVar    = @VariablePtr
End Function

Sub uc_Goto(ByVal Expr As ExpressionType Ptr)
   @Expr.GoToAddress = @Expr.@LeftOp
End Sub

Sub uc_Exit(ByVal Expr As ExpressionType Ptr)
   Expr = @Expr.GoToAddress
   @Expr.GoToAddress = 0
End Sub

Function StringHelper(t As ucThreadType) As Long
   Dim Func As ucHandleType

   If ucElementCategory(t) = %ucIsFunction Then
      Select Case ucTreeGetFunc(t)
         Case "EXTRACT", "INSTR", "REMAIN", "TRIM", "LTRIM", "RTRIM", _
              "PARSECOUNT", "REMOVE", "TALLY", "PARSE", "REPLACE"  '+++
            pCount = t.ParamCount-1
            If ucTreeGetFunc(t) = "PARSE" Then pCount = 2
            If ucTreeGetFunc(t) = "REPLACE" Then pCount = 1
            If ucTreeGetFunc(t) = "INSTR" Then pCount = t.ParamCount-2
' +++ Index Func.ParamCount so that + 1 not needed (when using ucItem(ucTreeNodeProperty(%ucFuncHandle, t).ParamCount)
            If Left$(ucTreeGetParam(pCount, t), 4) = "ANY " Then
               ucTreeSetParam pCount, Mid$(ucTreeGetParam(pCount, t), 5), t
               ucTreeSetParam t.ParamCount, "1", t
            End If
         Case "VARHANDLE"
            VarHandle = ucVariableHandle(ucTreeGetParam(1, t), t)
            ucSetExpr Trim$(Str$(VarHandle)), t
      End Select
   ElseIf ucElementCategory(t) = %ucIsBinaryOperator _
   And ucTreeGetOp(t) = "$" Then
   ' +++ Do this also so that $ can be at the end of a variable name
      ucSetExpr ucTreeGetParam(1, t) + ucTreeGetParam(2, t), t
   End If
End Function

Function uc_MaxStr(t As ucThreadType) As Ext
   MaxStr$ = ucParamStr(1, t)

   For x = 2 To t.ParamCount
      MaxStr$ = Max$(MaxStr$, ucParamStr(x, t))
   Next

   ucReturnStr MaxStr$, t
End Function

Function uc_MinStr(t As ucThreadType) As Ext
   MinStr$ = ucParamStr(1, t)

   For x = 2 To t.ParamCount
      MinStr$ = Min$(MinStr$, ucParamStr(x, t))
   Next

   ucReturnStr MinStr$, t
End Function

Function uc_IIfStr(t As ucThreadType) As Ext
   TruePart = ucParam(2, t)
   FalsePart = ucParam(3, t)

   If ucParam(1, t) _
   Then ucReturnStr ucEvaluateStr(TruePart), t _
   Else ucReturnStr ucEvaluateStr(FalsePart), t
End Function

Function StringMinMaxIIfStr(t As ucThreadType) As Long
   If ucTreeNodeProperty(%ucFuncHandle, t) = MinFunc _
   And ucTreeParamProperty(1, %ucIsString, t) _
   Then ucTreeSetFunc "MINSTR", t

   If ucTreeNodeProperty(%ucFuncHandle, t) = MaxFunc _
   And ucTreeParamProperty(1, %ucIsString, t) _
   Then ucTreeSetFunc "MAXSTR", t

   If ucTreeNodeProperty(%ucFuncHandle, t) = IIfFunc _
   And ucTreeParamProperty(2, %ucIsString, t) _
   Then ucTreeSetFunc "IIFSTR", t
End Function

Function BASIC_Hex(t As ucThreadType) As Long
   If ucElementCategory(t) = %ucIsUnaryPreOperator _
   And ucTreeGetOp(t) = "&" _
   Then ucSetExpr "#" + Mid$(ucGetExpr(t), 2), t
End Function

Function MultiLineParse(t As ucThreadType) As Long
   Dim VarInfo As ucHandleType

   Static IfList$
   Static VarList$
   Static DetachList$
   Static ElseIfCount As Long

   If ucElementCategory(t) = %ucIsFunction Then
      FunctionName$ = ucTreeGetFunc(t)

      If FunctionName$ = "SETVAR" Then
         ' +++ Need to distinguish if var is Double or Ext, and if Array element
         VarHandle = ucVariableHandle(ucTreeGetParam(1, t), t)

         If VarHandle > 0 _
         Then ucTreeSetParam 1, LTrim$(Str$(ucItem(VarHandle).DataPtr)), t
      ElseIf FunctionName$ = "ELSE" Then
         Incr ElseIfCount
         Block$ = "BLOCK" + Trim$(Str$(ElseIfCount))
         Replace "..." With "GOTO "+Block$ In IfList$
         ucSetExpr "EXITBLOCK : 0:(" + Block$ +":)", t
      ElseIf FunctionName$ = "DETACHIF" Then
         ucDetachSymbol "BLOCKSTART,BLOCKEND", t
         ' +++ Detach ElseIfs
         ucSetExpr "0", t
      End If
   ElseIf ucElementCategory(t) = %ucIsUnaryPreOperator Then
      FunctionName$ = ucTreeGetFunc(t)
      If FunctionName$ = "IF" Then
         Condition$ = Extract$(Remain$(ucGetExpr(t), "IF"), "THEN")
         IfList$ = "IIF(" + Condition$ + ", GOTO BLOCKSTART, ...);"

         ucSetExpr "GOTO BLOCKEND : (BLOCKSTART:)", t
         ucDefineVariable("BLOCKEND", %ucLocal, t.ucThread)
      ElseIf FunctionName$ = "ELSEIF" Then
         Incr ElseIfCount
         Condition$ = Extract$(Remain$(ucGetExpr(t), "ELSEIF"), "THEN")
         Block$ = "BLOCK" + Trim$(Str$(ElseIfCount))
         Replace "..." With "IIF(" + Condition$ + ", GOTO "+Block$+", ...)" In IfList$
         ucSetExpr "EXITBLOCK : 0:(" + Block$ +":)", t
      ElseIf FunctionName$ = "END" Then
         If ucTreeGetParam(1, t) = "IF" Then
            Replace "..." With "" In IfList$
            ucSetExpr "EXITBLOCK : 0:(BLOCKEND:) : "+Extract$(IfList$,";")+":DETACHIF", t
            IfList$ = Remain$(IfList$, ";")
         ElseIf ucTreeGetParam(1, t) = "FUNCTION" Then
            ucSetExpr "0", t
            ucDetachSymbol VarList$, t
            VarList$ = ""
            ucDefineFunction "", 0, %ucEndMultiline
         End If
      ElseIf FunctionName$ = "DIM" Then
         VariableName$ = ucTreeGetParam(1, t)
         VarList$ = VarList$ + Extract$(VariableName$, Any " =:") + ","
         ucDefineVariable(VariableName$, %ucLocal, t.ucThread)
         ucSetExpr Extract$(VariableName$, Any " =:") + "=0", t
      ElseIf FunctionName$ = "FUNCTION" Then
         FunctionName$ = Trim$(Remain$(Extract$(ucGetExpr(t), "("), "FUNCTION"))
         ucSetExpr FunctionName$ + " = 0", t
      ElseIf FunctionName$ = "GOTO" _
      And ucTreeGetParam(1, t) = "NEXTEND" Then
         VarHandle = ucDefineVariable(ucTreeGetParam(1, t), %ucLocal, t.ucThread)
      End If
   ElseIf ucElementCategory(t) = %ucIsUnaryPostOperator _
   And ucTreeGetOp(t) = ":" Then
      If ucTreeGetParam(1, t) = "BLOCKEND" _
      Then VarHandle = ucVariableHandle("BLOCKEND", t) _
      Else VarHandle = ucDefineVariable(ucTreeGetParam(1, t), %ucLocal, t.ucThread)

      ucSetVariableValue VarHandle, ucTreeNodeProperty(%ucCodeAddress, t)
   End If
End Function

Function ForNext(t As ucThreadType) As Long
   Static ForList$

   If ucElementCategory(t) = %ucIsUnaryPreOperator _
   And ucTreeGetOp(t) = "FOR" Then
      Expr$ = ucGetExpr(t)
      Counter$ = Str$(ucVariableHandle(Trim$(Remain$(Extract$(Expr$, "="), "FOR")), t))
      Start$ = Trim$(Remain$(Extract$(Expr$, "TO"), "="))
      Stop$ = Trim$(Remain$(Extract$(Expr$, "STEP"), "TO"))
      Stepp$ = Trim$(Remain$(Expr$, "STEP")) : If Stepp$ = "" Then Stepp$ = "1"
      ForList$ = "_FOR(" + Counter$ + "," + Start$ + "," + Stop$ + "," _
                + Stepp$ + ", GOTO BLOCKSTART)" + ";" + ForList$

      ucSetExpr "GOTO BLOCKEND : (BLOCKSTART:)", t
      ucDefineVariable("BLOCKEND", %ucLocal, t.ucThread)
   ElseIf ucElementCategory(t) = %ucIsOperand _
   And ucGetExpr(t) = "NEXT" Then
      ucSetExpr "EXITBLOCK : 0:(BLOCKEND:):"+Extract$(ForList$,";")+":DETACHFOR", t
      ForList$ = Remain$(ForList$, ";")
   ElseIf ucElementCategory(t) = %ucIsFunction _
   And ucTreeGetOp(t) = "DETACHFOR" Then
      ucDetachSymbol "BLOCKSTART,BLOCKEND", t
      ucSetExpr "0", t
   End If
End Function


Function LibMain(ByVal hInstance   As Long, _
                 ByVal fwdReason   As Long, _
                 ByVal lpvReserved As Long) Export As Long

    If fwdReason = 1 Then
       LibMain = 1
    End If
End Function

' --- End Of File
